#include <stdio.h>
# define U(x) x
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX BUFSIZ
#ifndef __cplusplus
# define output(c) (void)putc(c,yyout)
#else
# define lex_output(c) (void)putc(c,yyout)
#endif

#if defined(__cplusplus) || defined(__STDC__)

#if defined(__cplusplus) && defined(__EXTERN_C__)
extern "C" {
#endif
	int yyback(int *, int);
	int yyinput(void);
	int yylook(void);
	void yyoutput(int);
	int yyracc(int);
	int yyreject(void);
	void yyunput(int);
	int yylex(void);
#ifdef YYLEX_E
	void yywoutput(wchar_t);
	wchar_t yywinput(void);
#endif
#ifndef yyless
	int yyless(int);
#endif
#ifndef yywrap
	int yywrap(void);
#endif
#ifdef LEXDEBUG
	void allprint(char);
	void sprint(char *);
#endif
#if defined(__cplusplus) && defined(__EXTERN_C__)
}
#endif

#ifdef __cplusplus
extern "C" {
#endif
	void exit(int);
#ifdef __cplusplus
}
#endif

#endif
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
#ifndef __cplusplus
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
#else
# define lex_input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
#endif
#define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng;
char yytext[YYLMAX];
int yymorfg;
extern char *yysptr, yysbuf[];
int yytchar;
FILE *yyin = {stdin}, *yyout = {stdout};
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;

# line 2 "main.l"
/************************************************************************
 *                                                                      *
 *               GATT - Genetic Algorithm Time-Tabler                   *
 *                                                                      *
 *                By Dave Corne                                         *
 *                   Peter Ross (peter@aisb.ed.ac.uk),                  *
 *                   Emma Collingwood (emmac@aisb.ed.ac.uk)             *
 *                                                                      *
 ************************************************************************/

# line 12 "main.l"
/*
   Copyright (C) 1996, Dave Corne, Peter Ross and Emma Collingwood

   This program is free software you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation- either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY- without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program-if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
*/

# line 31 "main.l"
/***************************************************************
 * Filename: main.l
 *
 * translations of input data for use with lex/yacc
 ****************************************************************/

#define MAXINPUTNUMS 150
#define NEWLINE 0
#include "y.tab.h"
#include <stdlib.h>
#include "gatt.h"

int inputnumlist[MAXINPUTNUMS];
double inputdouble;

int numnames = 0;
int numnums = 0;

void resetinputlists();
void addtonumlist();
void addtonamelist();

int  i;                           /* Used for dealing with */
char *sn1, *sn2;                  /* number ranges */
# define YYNEWLINE 10
yylex(){
int nstr; extern int yyprevious;
#ifdef __cplusplus
/* to avoid CC and lint complaining yyfussy not being used ...*/
static int __lex_hack = 0;
if (__lex_hack) goto yyfussy;
#endif
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:

# line 77 "main.l"
        ;
break;
case 2:

# line 78 "main.l"
     ;
break;
case 3:

# line 79 "main.l"
      ;
break;
case 4:

# line 80 "main.l"
            { return NEWLINE;}
break;
case 5:

# line 81 "main.l"
         { return NEWLINE;}
break;
case 6:

# line 82 "main.l"
             { return THE; }
break;
case 7:

# line 83 "main.l"
           { return THERE; }
break;
case 8:

# line 84 "main.l"
            { return TIME; }
break;
case 9:

# line 85 "main.l"
       { return TIMETABLE; }
break;
case 10:

# line 86 "main.l"
          { return ASSIGN; }
break;
case 11:

# line 87 "main.l"
            { return DATE; }
break;
case 12:

# line 88 "main.l"
           { return APART; }
break;
case 13:

# line 89 "main.l"
            { return LONG; }
break;
case 14:

# line 90 "main.l"
            { return LAST; }
break;
case 15:

# line 91 "main.l"
           { return LASTS; }
break;
case 16:

# line 92 "main.l"
             { return ARE ;  }
break;
case 17:

# line 93 "main.l"
        { addtonumlist(atoi(yytext));
                   return NUMBER; }
break;
case 18:

# line 95 "main.l"
      { sn1 = (char *)malloc((i=strcspn(yytext,"-"))+1);
                   strncpy(sn1,yytext,i);
                   sn2 = (char *)malloc(strlen(yytext)-i);
                   strcpy(sn2,&yytext[i+1]);
                   for(i=atoi(sn1);i<=atoi(sn2);i++)
                      addtonumlist(i);
                   free(sn1);
                   free(sn2);
                   return NUMRANGE; }
break;
case 19:

# line 104 "main.l"
        { inputdouble = (double)atof(yytext); return DOUBLE; }
break;
case 20:

# line 105 "main.l"
             { return DAY; }
break;
case 21:

# line 106 "main.l"
            { return DAYS; }
break;
case 22:

# line 107 "main.l"
            { return SLOT; }
break;
case 23:

# line 108 "main.l"
           { return SLOTS; }
break;
case 24:

# line 109 "main.l"
         { return STUDENT; }
break;
case 25:

# line 110 "main.l"
        { return STUDENTS; }
break;
case 26:

# line 111 "main.l"
          { return MODULE ;  }
break;
case 27:

# line 112 "main.l"
         { return MODULES ; }
break;
case 28:

# line 113 "main.l"
            { return ROOM ;   }
break;
case 29:

# line 114 "main.l"
           { return ROOMS ; }
break;
case 30:

# line 115 "main.l"
            { return HOUR ; }
break;
case 31:

# line 116 "main.l"
           { return HOURS; }
break;
case 32:

# line 117 "main.l"
              { return IS ; }
break;
case 33:

# line 118 "main.l"
              { return BE; }
break;
case 34:

# line 119 "main.l"
         { return BETWEEN ; }
break;
case 35:

# line 120 "main.l"
              { return ON ; }
break;
case 36:

# line 121 "main.l"
              { return IN_ ; }
break;
case 37:

# line 122 "main.l"
              { return AT ; }
break;
case 38:

# line 123 "main.l"
             { return ALL ; }
break;
case 39:

# line 124 "main.l"
             { addtonamelist("___"); return AND ; }
break;
case 40:

# line 125 "main.l"
             { return MIN; }
break;
case 41:

# line 126 "main.l"
            { return MINS; }
break;
case 42:

# line 127 "main.l"
          { return MINUTE; }
break;
case 43:

# line 128 "main.l"
         { return MINUTES; }
break;
case 44:

# line 129 "main.l"
            { return TAKE; }
break;
case 45:

# line 130 "main.l"
           { return TAKES; }
break;
case 46:

# line 131 "main.l"
        { return SCHEDULE; }
break;
case 47:

# line 132 "main.l"
               { return P; }
break;
case 48:

# line 133 "main.l"
          { return PREFER; }
break;
case 49:

# line 134 "main.l"
      { return PREFERABLY; }
break;
case 50:

# line 135 "main.l"
      { return PREFERENCE; }
break;
case 51:

# line 136 "main.l"
           { return PLACE; }
break;
case 52:

# line 137 "main.l"
           { return OCCUR; }
break;
case 53:

# line 138 "main.l"
            { return INTO; }
break;
case 54:

# line 139 "main.l"
            { return WITH; }
break;
case 55:

# line 140 "main.l"
        { return PRIORITY; }
break;
case 56:

# line 141 "main.l"
          { addtonamelist("___"); return BEFORE; }
break;
case 57:

# line 142 "main.l"
           { addtonamelist("___"); return AFTER; }
break;
case 58:

# line 143 "main.l"
         { return EXACTLY; }
break;
case 59:

# line 144 "main.l"
          { return WEIGHT; }
break;
case 60:

# line 145 "main.l"
       { return PRECISELY; }
break;
case 61:

# line 146 "main.l"
           { return LEAST; }
break;
case 62:

# line 147 "main.l"
            { return MOST ; }
break;
case 63:

# line 148 "main.l"
            { return PAIR ; }
break;
case 64:

# line 149 "main.l"
        { return EXPECTED; }
break;
case 65:

# line 150 "main.l"
            { return SIZE; }
break;
case 66:

# line 151 "main.l"
            { return ONTO; }
break;
case 67:

# line 152 "main.l"
            { return HAVE; }
break;
case 68:

# line 153 "main.l"
          { return HAPPEN; }
break;
case 69:

# line 154 "main.l"
             { return PER; }
break;
case 70:

# line 155 "main.l"
              { return AS; }
break;
case 71:

# line 156 "main.l"
     { return UNAVAILABLE; }
break;
case 72:

# line 157 "main.l"
         { return REQUIRE; }
break;
case 73:

# line 158 "main.l"
        { return REQUIRES; }
break;
case 74:

# line 159 "main.l"
           { return DEBUG; }
break;
case 75:

# line 160 "main.l"
             { return HAS; }
break;
case 76:

# line 161 "main.l"
           { return AVOID; }
break;
case 77:

# line 162 "main.l"
          { return AVOIDS; }
break;
case 78:

# line 163 "main.l"
           { return HOLDS; }
break;
case 79:

# line 164 "main.l"
             { return CAN; }
break;
case 80:

# line 165 "main.l"
           { return EXTRA; }
break;
case 81:

# line 166 "main.l"
      { return ADDITIONAL; }
break;
case 82:

# line 167 "main.l"
        { return MINIMISE; }
break;
case 83:

# line 168 "main.l"
         { return MINIMUM; }
break;
case 84:

# line 169 "main.l"
         { return MAXIMUM; }
break;
case 85:

# line 170 "main.l"
          { return NUMBER_W; }
break;
case 86:

# line 171 "main.l"
              { return OF; }
break;
case 87:

# line 172 "main.l"
              { return NO; }
break;
case 88:

# line 173 "main.l"
            { return NUMBER_W; }
break;
case 89:

# line 174 "main.l"
          { return TAKING; }
break;
case 90:

# line 175 "main.l"
            { return SAME; }
break;
case 91:

# line 176 "main.l"
            { return SITS; }
break;
case 92:

# line 177 "main.l"
         { return SITTING; }
break;
case 93:

# line 178 "main.l"
           { return SEATS; }
break;
case 94:

# line 179 "main.l"
          { return CONSEC; }
break;
case 95:

# line 180 "main.l"
     { return CONSECUTIVE; }
break;
case 96:

# line 181 "main.l"
    { return CONCURRENTLY; }
break;
case 97:

# line 182 "main.l"
  { return SIMULTANEOUSLY; }
break;
case 98:

# line 183 "main.l"
{ return SIMULATED_ANNEALING; }
break;
case 99:

# line 184 "main.l"
           { return ALLOW; }
break;
case 100:

# line 185 "main.l"
         { return PENALTY; }
break;
case 101:

# line 186 "main.l"
           { return CLASH; }
break;
case 102:

# line 187 "main.l"
    { return EVENT_SPREAD; }
break;
case 103:

# line 188 "main.l"
      { return CONSTRAINT; }
break;
case 104:

# line 189 "main.l"
     { return CONSTRAINTS; }
break;
case 105:

# line 190 "main.l"
  { return SPECIFICATIONS; }
break;
case 106:

# line 191 "main.l"
      { return EXCLUSIONS; }
break;
case 107:

# line 192 "main.l"
         { return EXCLUDE; }
break;
case 108:

# line 193 "main.l"
        { return EXCLUDES; }
break;
case 109:

# line 194 "main.l"
       { return SPECIFIES; }
break;
case 110:

# line 195 "main.l"
         { return SPECIFY; }
break;
case 111:

# line 196 "main.l"
        { return ORDERING; }
break;
case 112:

# line 197 "main.l"
              { return TO; }
break;
case 113:

# line 198 "main.l"
             { return TOO; }
break;
case 114:

# line 199 "main.l"
            { return FROM; }
break;
case 115:

# line 200 "main.l"
            { return MUST; }
break;
case 116:

# line 201 "main.l"
            { return MANY; }
break;
case 117:

# line 202 "main.l"
            { return EXAM; }
break;
case 118:

# line 203 "main.l"
           { return EXAMS; }
break;
case 119:

# line 204 "main.l"
         { return LECTURE; }
break;
case 120:

# line 205 "main.l"
        { return LECTURER; }
break;
case 121:

# line 206 "main.l"
       { return LECTURERS; }
break;
case 122:

# line 207 "main.l"
        { return LECTURES; }
break;
case 123:

# line 208 "main.l"
           { return TUTOR;}
break;
case 124:

# line 209 "main.l"
          { return TUTORS;}
break;
case 125:

# line 210 "main.l"
        { return TUTORIAL; }
break;
case 126:

# line 211 "main.l"
       { return TUTORIALS; }
break;
case 127:

# line 212 "main.l"
           { return EVENT; }
break;
case 128:

# line 213 "main.l"
          { return EVENTS; }
break;
case 129:

# line 214 "main.l"
           { return TEACH; }
break;
case 130:

# line 215 "main.l"
         { return TEACHES; }
break;
case 131:

# line 216 "main.l"
         { return TEACHER; }
break;
case 132:

# line 217 "main.l"
        { return TEACHERS; }
break;
case 133:

# line 218 "main.l"
     { return INVIGILATOR; }
break;
case 134:

# line 219 "main.l"
    { return INVIGILATORS;}
break;
case 135:

# line 220 "main.l"
     { return INVIGILATES; }
break;
case 136:

# line 221 "main.l"
      { return INVIGILATE; }
break;
case 137:

# line 222 "main.l"
         { return DEFAULT;  }
break;
case 138:

# line 223 "main.l"
        { return DEFAULTS; }
break;
case 139:

# line 224 "main.l"
               { return A; }
break;
case 140:

# line 225 "main.l"
            { return LESS; }
break;
case 141:

# line 226 "main.l"
            { return MORE; }
break;
case 142:

# line 227 "main.l"
            { return THAN; }
break;
case 143:

# line 228 "main.l"
           { return FEWER; }
break;
case 144:

# line 229 "main.l"
           { return BEING; }
break;
case 145:

# line 230 "main.l"
           { return CLOSE; }
break;
case 146:

# line 231 "main.l"
           { return SHARE; }
break;
case 147:

# line 232 "main.l"
        { return CAPACITY; }
break;
case 148:

# line 233 "main.l"
        { return CONSECPEN;}
break;
case 149:

# line 234 "main.l"
   { return MINCOURSES;}
break;
case 150:

# line 235 "main.l"
   { return TOOMANYPERDAY; }
break;
case 151:

# line 236 "main.l"
      { return JUXTAPOSITION; }
break;
case 152:

# line 237 "main.l"
          { return  TOOCLOSEPEN ; }
break;
case 153:

# line 238 "main.l"
        { return  NTOOCLOSEPEN; }
break;
case 154:

# line 239 "main.l"
 { return MODEXCSLOTPEN; }
break;
case 155:

# line 240 "main.l"
   { return  AGENTPREFPEN; }
break;
case 156:

# line 241 "main.l"
   { return  MODAVSLOTPEN; }
break;
case 157:

# line 242 "main.l"
     { return  EVENTCAPPEN; }
break;
case 158:

# line 243 "main.l"
   { return  STUDCAPPEN; }
break;
case 159:

# line 244 "main.l"
 { return  MODEXCROOMPEN; }
break;
case 160:

# line 245 "main.l"
   { return  MODAVROOMPEN; }
break;
case 161:

# line 246 "main.l"
 { return  AGENTEXCSLOTPEN; }
break;
case 162:

# line 247 "main.l"
   { return  AGENTAVSLOTPEN; }
break;
case 163:

# line 248 "main.l"
 { return  AGENTOVERHPEN; }
break;
case 164:

# line 249 "main.l"
{ return  AGENTUNDERHPEN; }
break;
case 165:

# line 250 "main.l"
 { return AGENTOVEREPEN; }
break;
case 166:

# line 251 "main.l"
{ return AGENTUNDEREPEN; }
break;
case 167:

# line 252 "main.l"
{ return AGENTEXCMODPEN; }
break;
case 168:

# line 253 "main.l"
  { return AGENTAVMODPEN; }
break;
case 169:

# line 254 "main.l"
        { return AGENTCLASHPEN;}
break;
case 170:

# line 255 "main.l"
     { return AGENTTOOMANYPEN;}
break;
case 171:

# line 256 "main.l"
        { return CLASHPEN; }
break;
case 172:

# line 257 "main.l"
      { return NCLASHPEN; }
break;
case 173:

# line 258 "main.l"
     { return SSLOADPEN; }
break;
case 174:

# line 259 "main.l"
    { return SELOADPEN; }
break;
case 175:

# line 260 "main.l"
             { return NUMPOPSIS; }
break;
case 176:

# line 261 "main.l"
             { return POPSIZEIS; }
break;
case 177:

# line 262 "main.l"
          { return GENSSTAGEIS; }
break;
case 178:

# line 263 "main.l"
  { return REPINITIS; }
break;
case 179:

# line 264 "main.l"
              { return MIGINITIS; }
break;
case 180:

# line 265 "main.l"
{return USE_VDM;}
break;
case 181:

# line 266 "main.l"
{ return USE_EFM ; }
break;
case 182:

# line 267 "main.l"
            { return EFM_RATE ; }
break;
case 183:

# line 268 "main.l"
      { return CROSSRATEIS; }
break;
case 184:

# line 269 "main.l"
       { return MUTATERATEIS; }
break;
case 185:

# line 270 "main.l"
    { return PERMRATEIS; }
break;
case 186:

# line 271 "main.l"
   { return MUTATIONRATEIS; }
break;
case 187:

# line 272 "main.l"
         { return REINITRATEIS; }
break;
case 188:

# line 273 "main.l"
{ return SETDM; }
break;
case 189:

# line 274 "main.l"
          { return REINITIS;  }
break;
case 190:

# line 275 "main.l"
       { return CROSSOVERIS; }
break;
case 191:

# line 276 "main.l"
       { return SELECTIONIS; }
break;
case 192:

# line 277 "main.l"
    { return REPRODUCTIONIS; }
break;
case 193:

# line 278 "main.l"
{ return STOCHASTIC_REPRODUCTION; }
break;
case 194:

# line 279 "main.l"
       { return ADAPTIVEEFM; }
break;
case 195:

# line 280 "main.l"
     { return HEURISTIC_EVAL; }
break;
case 196:

# line 281 "main.l"
        { return NON_INTERACTIVE; }
break;
case 197:

# line 282 "main.l"
       { return EXP_OUTPUT; }
break;
case 198:

# line 283 "main.l"
               { return SEEDIS; }
break;
case 199:

# line 284 "main.l"
    { return INITIAL_TEMPERATURE; }
break;
case 200:

# line 285 "main.l"
      { return FINAL_TEMPERATURE; }
break;
case 201:

# line 286 "main.l"
           { return COOLING_RATE; }
break;
case 202:

# line 287 "main.l"
             { return ITERATIONS; }
break;
case 203:

# line 288 "main.l"
        { return CROWDING_FACTOR;}
break;
case 204:

# line 289 "main.l"
        { return RESTARTSIS; }
break;
case 205:

# line 291 "main.l"
         { return COLON; }
break;
case 206:

# line 292 "main.l"
         { return SLASH; }
break;
case 207:

# line 293 "main.l"
          { addtonamelist(yytext);
                   return NAME;}
break;
case 208:

# line 295 "main.l"
         { addtonamelist(yytext);
                   return NAME;}
break;
case 209:

# line 297 "main.l"
          { return WORD;}
break;
case -1:
break;
default:
(void)fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
/* end of yylex */


void addtonumlist(num)
int num;
{
 inputnumlist[numnums++] = num;
}

void addtonamelist(name)
char *name;
{
 inputnamelist[numnames] =
        (struct inputname *)malloc(sizeof(struct inputname));
 inputnamelist[numnames]->n = (char *)malloc(strlen(name)+1);
 strcpy(inputnamelist[numnames++]->n,name);
}

void resetinputlists()
 {
  int i;

  numnums = 0;
  for(i=0;i<numnames;i++) {
   free(inputnamelist[i]->n);
   free(inputnamelist[i]);
  }
  numnames = 0;
}



int yyvstop[] = {
0,

2,
0,

4,
0,

1,
0,

207,
209,
0,

206,
0,

17,
0,

205,
0,

139,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

47,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

5,
0,

3,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

70,
207,
209,
0,

37,
207,
209,
0,

207,
209,
0,

33,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

36,
207,
209,
0,

32,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

87,
207,
209,
0,

207,
209,
0,

207,
209,
0,

86,
207,
209,
0,

35,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

112,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

18,
0,

19,
0,

208,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

38,
207,
209,
0,

39,
207,
209,
0,

207,
209,
0,

16,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

79,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

20,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

75,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

40,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

88,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

69,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

6,
207,
209,
0,

207,
209,
0,

113,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

11,
207,
209,
0,

21,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

117,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

114,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

67,
207,
209,
0,

207,
209,
0,

30,
207,
209,
0,

207,
209,
0,

53,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

14,
207,
209,
0,

207,
209,
0,

207,
209,
0,

140,
207,
209,
0,

13,
207,
209,
0,

116,
207,
209,
0,

207,
209,
0,

207,
209,
0,

41,
207,
209,
0,

207,
209,
0,

207,
209,
0,

141,
207,
209,
0,

62,
207,
209,
0,

115,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

66,
207,
209,
0,

207,
209,
0,

63,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

28,
207,
209,
0,

90,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

91,
207,
209,
0,

207,
209,
0,

65,
207,
209,
0,

22,
207,
209,
0,

207,
209,
0,

207,
209,
0,

44,
207,
209,
0,

207,
209,
0,

207,
209,
0,

142,
207,
209,
0,

207,
209,
0,

8,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

54,
207,
209,
0,

207,
209,
0,

57,
207,
209,
0,

207,
209,
0,

99,
207,
209,
0,

12,
207,
209,
0,

207,
209,
0,

76,
207,
209,
0,

207,
209,
0,

144,
207,
209,
0,

207,
209,
0,

207,
209,
0,

101,
207,
209,
0,

145,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

74,
207,
209,
0,

207,
209,
0,

127,
207,
209,
0,

207,
209,
0,

118,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

80,
207,
209,
0,

143,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

78,
207,
209,
0,

31,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

15,
207,
209,
0,

61,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

52,
207,
209,
0,

207,
209,
0,

207,
209,
0,

51,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

29,
207,
209,
0,

207,
209,
0,

93,
207,
209,
0,

146,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

23,
207,
209,
0,

207,
209,
0,

207,
209,
0,

45,
207,
209,
0,

207,
209,
0,

129,
207,
209,
0,

7,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

123,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

10,
207,
209,
0,

77,
207,
209,
0,

56,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

94,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

128,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

68,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

42,
207,
209,
0,

26,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

85,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

48,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

89,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

124,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

59,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

34,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

137,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

58,
207,
209,
0,

107,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

119,
207,
209,
0,

84,
207,
209,
0,

207,
209,
0,

207,
209,
0,

83,
207,
209,
0,

43,
207,
209,
0,

27,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

100,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

72,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

92,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

110,
207,
209,
0,

24,
207,
209,
0,

131,
207,
209,
0,

130,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

147,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

138,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

108,
207,
209,
0,

207,
209,
0,

64,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

120,
207,
209,
0,

122,
207,
209,
0,

82,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

111,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

55,
207,
209,
0,

73,
207,
209,
0,

198,
207,
209,
0,

46,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

25,
207,
209,
0,

132,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

125,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

179,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

121,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

60,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

109,
207,
209,
0,

207,
209,
0,

9,
207,
209,
0,

207,
209,
0,

207,
209,
0,

126,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

81,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

103,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

106,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

175,
207,
209,
0,

207,
209,
0,

207,
209,
0,

176,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

136,
207,
209,
0,

207,
209,
0,

202,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

49,
207,
209,
0,

50,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

95,
207,
209,
0,

104,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

182,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

135,
207,
209,
0,

133,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

71,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

96,
207,
209,
0,

207,
209,
0,

201,
207,
209,
0,

207,
209,
0,

102,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

134,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

177,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

189,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

152,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

187,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

97,
207,
209,
0,

207,
209,
0,

207,
209,
0,

105,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

169,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

148,
207,
209,
0,

203,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

171,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

204,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

153,
207,
209,
0,

196,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

197,
207,
209,
0,

207,
209,
0,

207,
209,
0,

184,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

190,
207,
209,
0,

207,
209,
0,

207,
209,
0,

191,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

194,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

200,
207,
209,
0,

183,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

151,
207,
209,
0,

207,
209,
0,

172,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

170,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

157,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

173,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

195,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

185,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

192,
207,
209,
0,

199,
207,
209,
0,

207,
209,
0,

98,
207,
209,
0,

174,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

162,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

155,
207,
209,
0,

207,
209,
0,

207,
209,
0,

160,
207,
209,
0,

156,
207,
209,
0,

207,
209,
0,

207,
209,
0,

186,
207,
209,
0,

207,
209,
0,

207,
209,
0,

149,
207,
209,
0,

158,
207,
209,
0,

150,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

168,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

178,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

161,
207,
209,
0,

165,
207,
209,
0,

163,
207,
209,
0,

207,
209,
0,

207,
209,
0,

159,
207,
209,
0,

154,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

167,
207,
209,
0,

166,
207,
209,
0,

164,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

188,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

181,
207,
209,
0,

207,
209,
0,

207,
209,
0,

193,
207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

207,
209,
0,

180,
207,
209,
0,
0};
# define YYTYPE int
struct yywork { YYTYPE verify, advance; } yycrank[] = {
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,3,	1,4,	
3,3,	0,0,	7,7,	7,33,	
11,11,	11,37,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	1,3,	0,0,	3,3,	
1,5,	7,7,	0,0,	11,11,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,6,	1,7,	
1,8,	1,9,	1,9,	1,9,	
1,9,	1,9,	1,9,	1,9,	
1,9,	1,9,	1,9,	1,10,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,6,	1,6,	
1,6,	1,6,	1,6,	1,6,	
1,6,	1,6,	1,6,	1,6,	
1,6,	1,6,	1,6,	1,6,	
1,6,	1,6,	1,6,	1,6,	
1,6,	1,6,	1,6,	1,6,	
1,6,	1,6,	1,6,	1,6,	
0,0,	1,11,	0,0,	0,0,	
1,6,	0,0,	1,12,	1,13,	
1,14,	1,15,	1,16,	1,17,	
1,18,	1,19,	1,20,	1,21,	
1,6,	1,22,	1,23,	1,24,	
1,25,	1,26,	1,6,	1,27,	
1,28,	1,29,	1,30,	1,6,	
1,31,	1,6,	1,6,	1,6,	
5,5,	13,48,	12,38,	15,53,	
12,39,	12,40,	18,60,	15,54,	
5,5,	5,0,	12,41,	14,49,	
12,42,	16,55,	12,43,	16,56,	
12,44,	12,45,	12,46,	17,57,	
12,47,	19,61,	14,50,	17,58,	
20,63,	14,51,	21,66,	22,67,	
14,52,	20,64,	20,65,	22,68,	
17,59,	27,85,	30,102,	19,62,	
31,104,	38,109,	39,110,	30,103,	
31,105,	22,69,	27,86,	27,87,	
5,5,	6,6,	40,111,	5,5,	
6,32,	6,32,	6,32,	6,32,	
6,32,	6,32,	6,32,	6,32,	
6,32,	6,32,	41,112,	42,113,	
43,114,	44,115,	45,116,	47,117,	
5,5,	6,6,	6,6,	6,6,	
6,6,	6,6,	6,6,	6,6,	
6,6,	6,6,	6,6,	6,6,	
6,6,	6,6,	6,6,	6,6,	
6,6,	6,6,	6,6,	6,6,	
6,6,	6,6,	6,6,	6,6,	
6,6,	6,6,	6,6,	49,121,	
52,127,	49,122,	55,132,	6,6,	
57,137,	6,6,	6,6,	6,6,	
6,6,	6,6,	6,6,	6,6,	
6,6,	6,6,	6,6,	6,6,	
6,6,	6,6,	6,6,	6,6,	
6,6,	6,6,	6,6,	6,6,	
6,6,	6,6,	6,6,	6,6,	
6,6,	6,6,	6,6,	9,34,	
9,35,	50,123,	9,9,	9,9,	
9,9,	9,9,	9,9,	9,9,	
9,9,	9,9,	9,9,	9,9,	
51,125,	51,126,	54,130,	50,124,	
58,138,	59,139,	54,131,	9,36,	
9,36,	9,36,	9,36,	9,36,	
9,36,	9,36,	9,36,	9,36,	
9,36,	9,36,	9,36,	9,36,	
9,36,	9,36,	9,36,	9,36,	
9,36,	9,36,	9,36,	9,36,	
9,36,	9,36,	9,36,	9,36,	
9,36,	23,70,	24,74,	60,140,	
65,149,	25,77,	26,81,	53,128,	
25,78,	23,71,	26,82,	56,133,	
53,129,	56,134,	66,150,	23,72,	
25,79,	26,83,	24,75,	62,144,	
25,80,	23,73,	67,151,	26,84,	
24,76,	28,88,	56,135,	28,89,	
62,145,	28,90,	56,136,	29,96,	
28,91,	28,92,	32,32,	29,97,	
28,93,	63,146,	29,98,	29,99,	
28,94,	69,155,	70,156,	61,141,	
28,95,	29,100,	61,142,	71,158,	
63,147,	61,143,	63,148,	29,101,	
70,157,	73,162,	32,32,	32,32,	
32,32,	32,32,	32,32,	32,32,	
32,32,	32,32,	32,32,	32,32,	
32,32,	32,32,	32,32,	32,32,	
32,32,	32,32,	32,32,	32,32,	
32,32,	32,32,	32,32,	32,32,	
32,32,	32,32,	32,32,	32,32,	
75,165,	76,167,	77,168,	79,169,	
32,32,	80,170,	32,32,	32,32,	
32,32,	32,32,	32,32,	32,32,	
32,32,	32,32,	32,32,	32,32,	
32,32,	32,32,	32,32,	32,32,	
32,32,	32,32,	32,32,	32,32,	
32,32,	32,32,	32,32,	32,32,	
32,32,	32,32,	32,32,	32,32,	
34,106,	34,106,	34,106,	34,106,	
34,106,	34,106,	34,106,	34,106,	
34,106,	34,106,	35,107,	35,107,	
35,107,	35,107,	35,107,	35,107,	
35,107,	35,107,	35,107,	35,107,	
36,108,	36,108,	36,108,	36,108,	
36,108,	36,108,	36,108,	36,108,	
36,108,	36,108,	81,171,	82,172,	
75,166,	83,174,	85,177,	82,173,	
86,178,	36,36,	36,36,	36,36,	
36,36,	36,36,	36,36,	36,36,	
36,36,	36,36,	36,36,	36,36,	
36,36,	36,36,	36,36,	36,36,	
36,36,	36,36,	36,36,	36,36,	
36,36,	36,36,	36,36,	36,36,	
36,36,	36,36,	36,36,	48,118,	
72,159,	68,152,	48,119,	68,153,	
84,175,	74,163,	87,179,	88,180,	
84,176,	89,181,	90,182,	91,183,	
93,187,	48,120,	72,160,	72,161,	
92,184,	94,188,	95,189,	68,154,	
74,164,	96,190,	97,191,	92,185,	
98,192,	99,194,	100,195,	101,196,	
98,193,	92,186,	102,197,	103,198,	
104,199,	105,200,	108,108,	108,108,	
108,108,	108,108,	108,108,	108,108,	
108,108,	108,108,	108,108,	108,108,	
109,201,	110,202,	111,203,	112,204,	
114,205,	116,206,	117,207,	118,208,	
119,209,	120,210,	122,211,	123,212,	
124,213,	125,214,	126,216,	127,217,	
128,218,	129,219,	130,220,	131,221,	
132,222,	133,223,	134,225,	135,226,	
136,228,	137,229,	138,230,	139,231,	
141,240,	125,215,	140,232,	133,224,	
140,233,	143,241,	140,234,	144,242,	
145,243,	146,244,	135,227,	147,245,	
140,235,	140,236,	148,246,	140,237,	
149,247,	140,238,	140,239,	150,248,	
151,249,	152,250,	153,251,	154,252,	
155,253,	156,254,	157,255,	158,256,	
159,259,	160,260,	161,261,	162,262,	
163,263,	164,264,	166,265,	167,266,	
168,267,	158,257,	169,268,	158,258,	
170,269,	171,270,	172,271,	174,272,	
175,273,	176,275,	177,276,	175,274,	
178,277,	179,278,	180,279,	181,280,	
182,281,	183,282,	184,283,	185,284,	
185,285,	186,286,	187,287,	188,288,	
189,289,	190,290,	191,292,	192,293,	
193,294,	190,291,	194,295,	195,296,	
196,297,	197,298,	198,299,	199,300,	
200,301,	201,302,	202,303,	203,304,	
204,305,	205,306,	206,307,	207,308,	
208,309,	209,310,	210,311,	211,312,	
212,313,	213,314,	214,315,	215,316,	
216,318,	217,319,	220,320,	221,321,	
222,322,	223,323,	224,324,	225,325,	
226,326,	227,327,	228,328,	229,329,	
230,330,	232,331,	215,317,	233,332,	
234,333,	235,334,	236,336,	238,339,	
237,337,	239,340,	240,341,	242,342,	
243,343,	244,344,	246,345,	247,346,	
248,347,	235,335,	237,338,	249,348,	
250,349,	251,350,	255,351,	256,352,	
258,353,	259,354,	263,355,	264,356,	
265,357,	266,358,	267,359,	269,360,	
271,361,	272,362,	273,363,	274,364,	
275,365,	276,366,	277,367,	278,368,	
280,369,	281,370,	282,371,	283,372,	
285,373,	287,374,	288,376,	289,377,	
290,378,	291,379,	292,380,	294,381,	
295,382,	296,383,	297,385,	298,386,	
300,392,	299,387,	302,393,	304,394,	
307,395,	299,388,	308,396,	296,384,	
299,389,	287,375,	309,397,	311,398,	
312,399,	315,400,	316,401,	317,402,	
318,403,	319,404,	321,405,	299,390,	
322,406,	323,409,	299,391,	325,410,	
326,412,	327,413,	330,414,	331,415,	
332,416,	333,417,	334,418,	335,419,	
336,420,	337,421,	338,422,	339,423,	
340,425,	341,426,	325,411,	344,427,	
345,428,	346,429,	339,424,	347,430,	
350,431,	351,432,	352,433,	353,435,	
354,436,	355,437,	356,438,	357,439,	
358,440,	360,441,	361,442,	363,443,	
364,444,	365,445,	352,434,	366,446,	
367,447,	369,448,	372,449,	373,451,	
374,452,	376,454,	377,455,	379,456,	
380,457,	382,458,	322,407,	383,459,	
384,460,	385,461,	386,463,	387,464,	
388,465,	389,466,	374,453,	390,467,	
391,468,	372,450,	392,469,	385,462,	
393,470,	394,471,	398,478,	394,472,	
399,479,	394,473,	322,408,	400,480,	
401,481,	402,482,	403,483,	404,484,	
405,485,	406,486,	409,490,	394,474,	
394,475,	410,491,	411,492,	412,493,	
394,476,	394,477,	407,487,	413,494,	
407,488,	414,495,	407,489,	415,496,	
416,497,	417,498,	418,499,	419,500,	
420,501,	421,502,	422,503,	423,505,	
424,506,	425,507,	427,508,	428,509,	
429,510,	430,511,	431,512,	432,513,	
433,514,	434,516,	435,517,	436,518,	
437,519,	438,520,	439,521,	433,515,	
441,522,	442,523,	422,504,	443,524,	
444,525,	445,527,	446,528,	447,529,	
444,526,	448,530,	449,531,	450,532,	
451,533,	452,534,	453,535,	454,536,	
455,538,	457,539,	457,540,	458,541,	
459,542,	460,543,	461,544,	463,545,	
464,546,	465,547,	466,548,	467,549,	
468,550,	470,551,	471,552,	454,537,	
472,553,	473,554,	474,555,	475,556,	
476,557,	477,558,	479,559,	480,560,	
481,561,	482,562,	483,563,	484,564,	
485,565,	486,566,	487,567,	488,568,	
489,570,	491,571,	492,572,	493,573,	
494,574,	495,575,	496,576,	497,577,	
498,578,	499,579,	488,569,	500,580,	
501,581,	502,582,	503,583,	504,584,	
505,585,	506,586,	507,587,	507,588,	
508,591,	509,592,	510,593,	511,594,	
512,595,	512,596,	514,597,	515,598,	
519,599,	520,600,	521,601,	522,602,	
524,603,	507,589,	507,590,	525,604,	
526,605,	527,606,	528,607,	529,608,	
530,609,	531,610,	532,611,	534,612,	
535,613,	536,614,	538,616,	536,615,	
539,618,	541,619,	542,620,	543,621,	
544,622,	545,623,	546,624,	547,625,	
548,626,	549,627,	550,628,	551,629,	
552,630,	553,631,	554,632,	555,633,	
556,634,	557,635,	538,617,	558,636,	
560,637,	561,638,	562,639,	563,640,	
564,641,	566,642,	567,643,	568,644,	
569,645,	570,646,	572,647,	574,648,	
575,649,	576,650,	577,651,	578,652,	
579,653,	580,654,	581,655,	582,656,	
583,657,	584,658,	585,659,	586,660,	
587,661,	588,662,	589,663,	590,664,	
591,665,	592,666,	593,667,	594,668,	
595,669,	598,670,	599,671,	600,672,	
601,673,	603,674,	604,675,	605,676,	
610,677,	611,678,	612,679,	613,680,	
614,681,	615,682,	616,683,	619,684,	
620,685,	621,686,	622,687,	623,688,	
624,689,	625,690,	626,691,	627,692,	
628,693,	629,694,	630,695,	631,696,	
632,697,	633,698,	634,699,	635,700,	
636,701,	637,702,	638,703,	639,704,	
640,705,	641,706,	642,707,	643,708,	
644,709,	645,710,	646,711,	647,712,	
648,713,	649,714,	650,715,	651,716,	
652,717,	654,718,	655,719,	656,720,	
657,721,	658,722,	659,723,	660,724,	
661,725,	662,726,	663,727,	664,730,	
665,731,	666,732,	667,734,	668,735,	
670,736,	663,728,	671,737,	672,738,	
663,729,	673,739,	675,740,	666,733,	
676,741,	677,742,	678,743,	679,744,	
680,745,	681,746,	683,747,	685,748,	
686,749,	688,750,	689,751,	690,752,	
691,753,	692,754,	693,755,	695,756,	
696,757,	697,758,	698,759,	699,760,	
700,761,	701,762,	702,763,	703,764,	
704,765,	705,766,	706,767,	707,768,	
708,769,	709,770,	710,771,	711,772,	
713,773,	714,774,	715,775,	716,776,	
717,777,	718,778,	720,779,	721,780,	
723,781,	724,782,	725,783,	726,784,	
727,785,	728,786,	729,787,	730,788,	
731,789,	732,790,	733,791,	735,792,	
736,793,	737,794,	738,795,	739,796,	
742,797,	743,798,	744,799,	745,800,	
746,801,	747,802,	748,803,	749,804,	
750,805,	751,806,	752,807,	753,808,	
754,809,	755,810,	756,811,	757,812,	
758,813,	759,814,	760,815,	761,816,	
762,817,	763,818,	764,819,	766,820,	
767,821,	768,822,	769,823,	770,824,	
771,825,	772,826,	773,827,	774,828,	
775,829,	777,830,	778,831,	779,832,	
780,833,	781,834,	782,835,	783,836,	
784,837,	785,838,	786,839,	787,840,	
788,841,	789,842,	791,843,	792,844,	
793,845,	794,846,	795,847,	796,848,	
797,849,	798,850,	799,851,	800,852,	
801,853,	802,854,	803,855,	804,856,	
806,857,	807,858,	808,859,	809,860,	
810,861,	811,862,	812,864,	813,865,	
814,866,	815,867,	816,868,	817,869,	
819,870,	821,871,	823,872,	823,873,	
824,874,	825,875,	826,876,	811,863,	
827,877,	828,878,	829,879,	830,880,	
831,881,	832,882,	833,883,	834,884,	
835,885,	836,886,	837,887,	838,888,	
839,889,	840,890,	841,891,	842,892,	
844,893,	845,894,	846,895,	847,896,	
848,897,	849,898,	850,899,	851,900,	
852,901,	853,902,	854,903,	855,904,	
856,905,	857,906,	858,907,	859,908,	
860,909,	861,910,	862,911,	863,912,	
864,913,	865,914,	866,915,	867,916,	
868,917,	869,918,	870,919,	871,920,	
872,921,	873,922,	874,923,	875,924,	
876,925,	877,926,	878,927,	879,928,	
881,929,	882,930,	883,931,	884,932,	
885,933,	886,934,	887,935,	889,936,	
890,937,	891,938,	892,939,	893,940,	
894,941,	895,942,	896,943,	897,944,	
898,945,	899,946,	900,947,	901,948,	
902,949,	903,950,	905,951,	906,952,	
907,953,	908,954,	909,955,	910,956,	
911,957,	912,958,	913,959,	914,960,	
915,962,	916,963,	917,964,	918,965,	
919,966,	920,967,	921,968,	922,969,	
923,970,	924,971,	925,972,	925,973,	
926,974,	914,961,	927,975,	928,976,	
929,977,	930,978,	931,979,	933,980,	
934,981,	935,982,	936,983,	937,984,	
938,985,	939,986,	940,987,	941,988,	
942,989,	943,990,	944,991,	945,992,	
947,993,	948,994,	950,995,	951,996,	
952,997,	953,998,	954,999,	955,1000,	
956,1001,	957,1002,	958,1003,	960,1004,	
961,1005,	962,1006,	963,1007,	964,1008,	
965,1009,	968,1010,	969,1011,	970,1012,	
972,1013,	973,1014,	974,1015,	975,1016,	
976,1017,	977,1018,	978,1019,	979,1020,	
980,1021,	981,1022,	982,1023,	983,1024,	
985,1025,	986,1026,	987,1027,	988,1028,	
989,1029,	992,1030,	993,1031,	994,1032,	
995,1033,	996,1034,	997,1035,	998,1036,	
999,1037,	1000,1038,	1001,1039,	1002,1040,	
1003,1041,	1004,1042,	1005,1043,	1006,1044,	
1007,1045,	1008,1046,	1009,1047,	1010,1048,	
1011,1049,	1012,1050,	1013,1051,	1014,1052,	
1016,1053,	1017,1054,	1019,1055,	1020,1056,	
1021,1057,	1023,1058,	1024,1059,	1026,1060,	
1027,1061,	1028,1062,	1029,1063,	1030,1064,	
1031,1065,	1032,1066,	1033,1067,	1034,1068,	
1036,1069,	1037,1070,	1038,1071,	1039,1072,	
1040,1073,	1041,1074,	1042,1075,	1043,1076,	
1044,1077,	1045,1079,	1046,1080,	1044,1078,	
1047,1081,	1048,1082,	1049,1083,	1050,1084,	
1051,1085,	1052,1086,	1055,1087,	1056,1088,	
1057,1089,	1058,1090,	1059,1091,	1060,1092,	
1062,1093,	1064,1094,	1065,1095,	1066,1096,	
1067,1097,	1068,1098,	1069,1099,	1070,1100,	
1071,1101,	1072,1102,	1073,1103,	1074,1104,	
1075,1105,	1076,1106,	1077,1107,	1078,1108,	
1079,1109,	1081,1110,	1082,1112,	1083,1113,	
1081,1111,	1085,1114,	1086,1115,	1087,1116,	
1088,1117,	1089,1118,	1090,1119,	1091,1120,	
1092,1121,	1093,1122,	1094,1123,	1095,1124,	
1097,1125,	1098,1126,	1099,1127,	1101,1128,	
1102,1129,	1103,1130,	1104,1131,	1105,1132,	
1106,1133,	1107,1134,	1108,1135,	1109,1136,	
1110,1137,	1111,1138,	1112,1139,	1113,1140,	
1114,1141,	1115,1142,	1117,1143,	1118,1144,	
1119,1145,	1122,1146,	1125,1147,	1126,1148,	
1127,1149,	1128,1150,	1129,1151,	1130,1152,	
1132,1153,	1133,1154,	1134,1155,	1135,1156,	
1137,1157,	1138,1158,	1141,1159,	1142,1160,	
1144,1161,	1145,1162,	1149,1163,	1150,1164,	
1151,1165,	1153,1166,	1154,1167,	1155,1168,	
1156,1169,	1157,1170,	1158,1171,	1159,1172,	
1160,1173,	1162,1174,	1163,1175,	1164,1176,	
1165,1177,	1166,1178,	1170,1179,	1171,1180,	
1174,1181,	1175,1182,	1176,1183,	1177,1184,	
1181,1185,	1182,1186,	1183,1187,	1184,1188,	
1186,1189,	1187,1190,	1188,1191,	1189,1192,	
1190,1193,	1191,1194,	1193,1195,	1194,1196,	
1196,1197,	1197,1198,	1198,1199,	1199,1200,	
0,0};
struct yysvf yysvec[] = {
0,	0,	0,
yycrank+1,	0,		0,	
yycrank+0,	yysvec+1,	0,	
yycrank+3,	0,		yyvstop+1,
yycrank+0,	0,		yyvstop+3,
yycrank+-123,	0,		yyvstop+5,
yycrank+124,	0,		yyvstop+7,
yycrank+5,	0,		0,	
yycrank+0,	0,		yyvstop+10,
yycrank+202,	0,		yyvstop+12,
yycrank+0,	0,		yyvstop+14,
yycrank+7,	0,		0,	
yycrank+26,	yysvec+6,	yyvstop+16,
yycrank+24,	yysvec+6,	yyvstop+20,
yycrank+38,	yysvec+6,	yyvstop+23,
yycrank+30,	yysvec+6,	yyvstop+26,
yycrank+19,	yysvec+6,	yyvstop+29,
yycrank+42,	yysvec+6,	yyvstop+32,
yycrank+33,	yysvec+6,	yyvstop+35,
yycrank+48,	yysvec+6,	yyvstop+38,
yycrank+38,	yysvec+6,	yyvstop+41,
yycrank+33,	yysvec+6,	yyvstop+44,
yycrank+54,	yysvec+6,	yyvstop+47,
yycrank+196,	yysvec+6,	yyvstop+50,
yycrank+199,	yysvec+6,	yyvstop+53,
yycrank+198,	yysvec+6,	yyvstop+56,
yycrank+201,	yysvec+6,	yyvstop+59,
yycrank+56,	yysvec+6,	yyvstop+63,
yycrank+220,	yysvec+6,	yyvstop+66,
yycrank+226,	yysvec+6,	yyvstop+69,
yycrank+48,	yysvec+6,	yyvstop+72,
yycrank+59,	yysvec+6,	yyvstop+75,
yycrank+281,	yysvec+6,	yyvstop+78,
yycrank+0,	0,		yyvstop+81,
yycrank+356,	0,		0,	
yycrank+366,	0,		0,	
yycrank+376,	0,		0,	
yycrank+0,	0,		yyvstop+83,
yycrank+61,	yysvec+6,	yyvstop+85,
yycrank+46,	yysvec+6,	yyvstop+88,
yycrank+69,	yysvec+6,	yyvstop+91,
yycrank+74,	yysvec+6,	yyvstop+94,
yycrank+83,	yysvec+6,	yyvstop+97,
yycrank+87,	yysvec+6,	yyvstop+100,
yycrank+84,	yysvec+6,	yyvstop+103,
yycrank+71,	yysvec+6,	yyvstop+106,
yycrank+0,	yysvec+6,	yyvstop+110,
yycrank+76,	yysvec+6,	yyvstop+114,
yycrank+365,	yysvec+6,	yyvstop+117,
yycrank+105,	yysvec+6,	yyvstop+121,
yycrank+152,	yysvec+6,	yyvstop+124,
yycrank+150,	yysvec+6,	yyvstop+127,
yycrank+105,	yysvec+6,	yyvstop+130,
yycrank+183,	yysvec+6,	yyvstop+133,
yycrank+164,	yysvec+6,	yyvstop+136,
yycrank+117,	yysvec+6,	yyvstop+139,
yycrank+206,	yysvec+6,	yyvstop+142,
yycrank+101,	yysvec+6,	yyvstop+145,
yycrank+154,	yysvec+6,	yyvstop+148,
yycrank+154,	yysvec+6,	yyvstop+151,
yycrank+200,	yysvec+6,	yyvstop+154,
yycrank+223,	yysvec+6,	yyvstop+157,
yycrank+203,	yysvec+6,	yyvstop+160,
yycrank+224,	yysvec+6,	yyvstop+163,
yycrank+0,	yysvec+6,	yyvstop+167,
yycrank+195,	yysvec+6,	yyvstop+171,
yycrank+186,	yysvec+6,	yyvstop+174,
yycrank+199,	yysvec+6,	yyvstop+177,
yycrank+372,	yysvec+6,	yyvstop+180,
yycrank+223,	yysvec+6,	yyvstop+183,
yycrank+224,	yysvec+6,	yyvstop+186,
yycrank+229,	yysvec+6,	yyvstop+189,
yycrank+368,	yysvec+6,	yyvstop+192,
yycrank+230,	yysvec+6,	yyvstop+195,
yycrank+372,	yysvec+6,	yyvstop+198,
yycrank+326,	yysvec+6,	yyvstop+201,
yycrank+264,	yysvec+6,	yyvstop+205,
yycrank+275,	yysvec+6,	yyvstop+208,
yycrank+0,	yysvec+6,	yyvstop+211,
yycrank+259,	yysvec+6,	yyvstop+215,
yycrank+277,	yysvec+6,	yyvstop+219,
yycrank+329,	yysvec+6,	yyvstop+222,
yycrank+325,	yysvec+6,	yyvstop+225,
yycrank+340,	yysvec+6,	yyvstop+228,
yycrank+371,	yysvec+6,	yyvstop+231,
yycrank+325,	yysvec+6,	yyvstop+234,
yycrank+337,	yysvec+6,	yyvstop+237,
yycrank+363,	yysvec+6,	yyvstop+240,
yycrank+366,	yysvec+6,	yyvstop+243,
yycrank+373,	yysvec+6,	yyvstop+246,
yycrank+381,	yysvec+6,	yyvstop+249,
yycrank+382,	yysvec+6,	yyvstop+252,
yycrank+375,	yysvec+6,	yyvstop+255,
yycrank+369,	yysvec+6,	yyvstop+258,
yycrank+384,	yysvec+6,	yyvstop+261,
yycrank+369,	yysvec+6,	yyvstop+264,
yycrank+382,	yysvec+6,	yyvstop+267,
yycrank+393,	yysvec+6,	yyvstop+270,
yycrank+395,	yysvec+6,	yyvstop+273,
yycrank+384,	yysvec+6,	yyvstop+276,
yycrank+383,	yysvec+6,	yyvstop+279,
yycrank+379,	yysvec+6,	yyvstop+283,
yycrank+401,	yysvec+6,	yyvstop+286,
yycrank+398,	yysvec+6,	yyvstop+289,
yycrank+395,	yysvec+6,	yyvstop+292,
yycrank+385,	yysvec+6,	yyvstop+295,
yycrank+0,	yysvec+34,	yyvstop+298,
yycrank+0,	yysvec+35,	yyvstop+300,
yycrank+454,	0,		yyvstop+302,
yycrank+407,	yysvec+6,	yyvstop+304,
yycrank+412,	yysvec+6,	yyvstop+307,
yycrank+404,	yysvec+6,	yyvstop+310,
yycrank+404,	yysvec+6,	yyvstop+313,
yycrank+0,	yysvec+6,	yyvstop+317,
yycrank+402,	yysvec+6,	yyvstop+321,
yycrank+0,	yysvec+6,	yyvstop+324,
yycrank+412,	yysvec+6,	yyvstop+328,
yycrank+413,	yysvec+6,	yyvstop+331,
yycrank+408,	yysvec+6,	yyvstop+334,
yycrank+410,	yysvec+6,	yyvstop+337,
yycrank+402,	yysvec+6,	yyvstop+340,
yycrank+0,	yysvec+6,	yyvstop+343,
yycrank+425,	yysvec+6,	yyvstop+347,
yycrank+408,	yysvec+6,	yyvstop+350,
yycrank+409,	yysvec+6,	yyvstop+353,
yycrank+426,	yysvec+6,	yyvstop+356,
yycrank+418,	yysvec+6,	yyvstop+359,
yycrank+408,	yysvec+6,	yyvstop+362,
yycrank+427,	yysvec+6,	yyvstop+365,
yycrank+414,	yysvec+6,	yyvstop+368,
yycrank+413,	yysvec+6,	yyvstop+372,
yycrank+434,	yysvec+6,	yyvstop+375,
yycrank+422,	yysvec+6,	yyvstop+378,
yycrank+434,	yysvec+6,	yyvstop+381,
yycrank+426,	yysvec+6,	yyvstop+384,
yycrank+434,	yysvec+6,	yyvstop+387,
yycrank+422,	yysvec+6,	yyvstop+390,
yycrank+436,	yysvec+6,	yyvstop+393,
yycrank+441,	yysvec+6,	yyvstop+396,
yycrank+430,	yysvec+6,	yyvstop+399,
yycrank+443,	yysvec+6,	yyvstop+402,
yycrank+428,	yysvec+6,	yyvstop+405,
yycrank+0,	yysvec+6,	yyvstop+408,
yycrank+444,	yysvec+6,	yyvstop+412,
yycrank+447,	yysvec+6,	yyvstop+415,
yycrank+434,	yysvec+6,	yyvstop+418,
yycrank+433,	yysvec+6,	yyvstop+421,
yycrank+440,	yysvec+6,	yyvstop+424,
yycrank+449,	yysvec+6,	yyvstop+427,
yycrank+442,	yysvec+6,	yyvstop+430,
yycrank+443,	yysvec+6,	yyvstop+433,
yycrank+444,	yysvec+6,	yyvstop+436,
yycrank+446,	yysvec+6,	yyvstop+439,
yycrank+446,	yysvec+6,	yyvstop+442,
yycrank+448,	yysvec+6,	yyvstop+445,
yycrank+461,	yysvec+6,	yyvstop+448,
yycrank+444,	yysvec+6,	yyvstop+451,
yycrank+461,	yysvec+6,	yyvstop+454,
yycrank+462,	yysvec+6,	yyvstop+457,
yycrank+451,	yysvec+6,	yyvstop+461,
yycrank+468,	yysvec+6,	yyvstop+464,
yycrank+454,	yysvec+6,	yyvstop+467,
yycrank+455,	yysvec+6,	yyvstop+470,
yycrank+454,	yysvec+6,	yyvstop+473,
yycrank+462,	yysvec+6,	yyvstop+476,
yycrank+0,	0,		yyvstop+479,
yycrank+479,	yysvec+6,	yyvstop+481,
yycrank+477,	yysvec+6,	yyvstop+484,
yycrank+459,	yysvec+6,	yyvstop+487,
yycrank+467,	yysvec+6,	yyvstop+490,
yycrank+479,	yysvec+6,	yyvstop+493,
yycrank+467,	yysvec+6,	yyvstop+496,
yycrank+485,	yysvec+6,	yyvstop+499,
yycrank+0,	yysvec+6,	yyvstop+502,
yycrank+484,	yysvec+6,	yyvstop+506,
yycrank+485,	yysvec+6,	yyvstop+509,
yycrank+474,	yysvec+6,	yyvstop+512,
yycrank+469,	yysvec+6,	yyvstop+515,
yycrank+493,	yysvec+6,	yyvstop+518,
yycrank+480,	yysvec+6,	yyvstop+521,
yycrank+489,	yysvec+6,	yyvstop+524,
yycrank+490,	yysvec+6,	yyvstop+527,
yycrank+476,	yysvec+6,	yyvstop+530,
yycrank+479,	yysvec+6,	yyvstop+533,
yycrank+477,	yysvec+6,	yyvstop+536,
yycrank+480,	yysvec+6,	yyvstop+539,
yycrank+496,	yysvec+6,	yyvstop+542,
yycrank+482,	yysvec+6,	yyvstop+545,
yycrank+500,	yysvec+6,	yyvstop+548,
yycrank+500,	yysvec+6,	yyvstop+551,
yycrank+500,	yysvec+6,	yyvstop+554,
yycrank+503,	yysvec+6,	yyvstop+557,
yycrank+493,	yysvec+6,	yyvstop+560,
yycrank+490,	yysvec+6,	yyvstop+563,
yycrank+505,	yysvec+6,	yyvstop+567,
yycrank+512,	yysvec+6,	yyvstop+570,
yycrank+497,	yysvec+6,	yyvstop+574,
yycrank+491,	yysvec+6,	yyvstop+577,
yycrank+515,	yysvec+6,	yyvstop+580,
yycrank+508,	yysvec+6,	yyvstop+583,
yycrank+508,	yysvec+6,	yyvstop+586,
yycrank+497,	yysvec+6,	yyvstop+589,
yycrank+500,	yysvec+6,	yyvstop+592,
yycrank+499,	yysvec+6,	yyvstop+595,
yycrank+497,	yysvec+6,	yyvstop+598,
yycrank+501,	yysvec+6,	yyvstop+601,
yycrank+515,	yysvec+6,	yyvstop+604,
yycrank+519,	yysvec+6,	yyvstop+607,
yycrank+506,	yysvec+6,	yyvstop+610,
yycrank+518,	yysvec+6,	yyvstop+613,
yycrank+521,	yysvec+6,	yyvstop+616,
yycrank+524,	yysvec+6,	yyvstop+619,
yycrank+520,	yysvec+6,	yyvstop+622,
yycrank+524,	yysvec+6,	yyvstop+625,
yycrank+509,	yysvec+6,	yyvstop+628,
yycrank+526,	yysvec+6,	yyvstop+631,
yycrank+523,	yysvec+6,	yyvstop+634,
yycrank+529,	yysvec+6,	yyvstop+637,
yycrank+0,	yysvec+6,	yyvstop+640,
yycrank+0,	yysvec+6,	yyvstop+644,
yycrank+527,	yysvec+6,	yyvstop+648,
yycrank+514,	yysvec+6,	yyvstop+651,
yycrank+516,	yysvec+6,	yyvstop+654,
yycrank+517,	yysvec+6,	yyvstop+657,
yycrank+519,	yysvec+6,	yyvstop+660,
yycrank+518,	yysvec+6,	yyvstop+664,
yycrank+537,	yysvec+6,	yyvstop+667,
yycrank+542,	yysvec+6,	yyvstop+670,
yycrank+541,	yysvec+6,	yyvstop+673,
yycrank+525,	yysvec+6,	yyvstop+676,
yycrank+532,	yysvec+6,	yyvstop+679,
yycrank+0,	yysvec+6,	yyvstop+682,
yycrank+527,	yysvec+6,	yyvstop+686,
yycrank+541,	yysvec+6,	yyvstop+689,
yycrank+543,	yysvec+6,	yyvstop+692,
yycrank+540,	yysvec+6,	yyvstop+695,
yycrank+529,	yysvec+6,	yyvstop+698,
yycrank+547,	yysvec+6,	yyvstop+701,
yycrank+546,	yysvec+6,	yyvstop+704,
yycrank+548,	yysvec+6,	yyvstop+707,
yycrank+549,	yysvec+6,	yyvstop+710,
yycrank+0,	yysvec+6,	yyvstop+713,
yycrank+536,	yysvec+6,	yyvstop+717,
yycrank+537,	yysvec+6,	yyvstop+720,
yycrank+548,	yysvec+6,	yyvstop+724,
yycrank+0,	yysvec+6,	yyvstop+727,
yycrank+551,	yysvec+6,	yyvstop+731,
yycrank+558,	yysvec+6,	yyvstop+734,
yycrank+559,	yysvec+6,	yyvstop+737,
yycrank+544,	yysvec+6,	yyvstop+740,
yycrank+544,	yysvec+6,	yyvstop+744,
yycrank+544,	yysvec+6,	yyvstop+747,
yycrank+0,	yysvec+6,	yyvstop+750,
yycrank+0,	yysvec+6,	yyvstop+754,
yycrank+0,	yysvec+6,	yyvstop+758,
yycrank+553,	yysvec+6,	yyvstop+762,
yycrank+554,	yysvec+6,	yyvstop+765,
yycrank+0,	yysvec+6,	yyvstop+768,
yycrank+548,	yysvec+6,	yyvstop+772,
yycrank+557,	yysvec+6,	yyvstop+775,
yycrank+0,	yysvec+6,	yyvstop+778,
yycrank+0,	yysvec+6,	yyvstop+782,
yycrank+0,	yysvec+6,	yyvstop+786,
yycrank+565,	yysvec+6,	yyvstop+790,
yycrank+556,	yysvec+6,	yyvstop+793,
yycrank+563,	yysvec+6,	yyvstop+796,
yycrank+568,	yysvec+6,	yyvstop+799,
yycrank+556,	yysvec+6,	yyvstop+802,
yycrank+0,	yysvec+6,	yyvstop+805,
yycrank+557,	yysvec+6,	yyvstop+809,
yycrank+0,	yysvec+6,	yyvstop+812,
yycrank+564,	yysvec+6,	yyvstop+816,
yycrank+572,	yysvec+6,	yyvstop+819,
yycrank+569,	yysvec+6,	yyvstop+822,
yycrank+574,	yysvec+6,	yyvstop+825,
yycrank+562,	yysvec+6,	yyvstop+828,
yycrank+572,	yysvec+6,	yyvstop+831,
yycrank+563,	yysvec+6,	yyvstop+834,
yycrank+564,	yysvec+6,	yyvstop+837,
yycrank+0,	yysvec+6,	yyvstop+841,
yycrank+580,	yysvec+6,	yyvstop+845,
yycrank+566,	yysvec+6,	yyvstop+848,
yycrank+581,	yysvec+6,	yyvstop+851,
yycrank+575,	yysvec+6,	yyvstop+854,
yycrank+0,	yysvec+6,	yyvstop+857,
yycrank+579,	yysvec+6,	yyvstop+861,
yycrank+0,	yysvec+6,	yyvstop+864,
yycrank+590,	yysvec+6,	yyvstop+868,
yycrank+581,	yysvec+6,	yyvstop+872,
yycrank+586,	yysvec+6,	yyvstop+875,
yycrank+573,	yysvec+6,	yyvstop+878,
yycrank+579,	yysvec+6,	yyvstop+882,
yycrank+586,	yysvec+6,	yyvstop+885,
yycrank+0,	yysvec+6,	yyvstop+888,
yycrank+590,	yysvec+6,	yyvstop+892,
yycrank+576,	yysvec+6,	yyvstop+895,
yycrank+594,	yysvec+6,	yyvstop+899,
yycrank+580,	yysvec+6,	yyvstop+902,
yycrank+598,	yysvec+6,	yyvstop+905,
yycrank+600,	yysvec+6,	yyvstop+908,
yycrank+592,	yysvec+6,	yyvstop+911,
yycrank+0,	yysvec+6,	yyvstop+914,
yycrank+593,	yysvec+6,	yyvstop+918,
yycrank+0,	yysvec+6,	yyvstop+921,
yycrank+604,	yysvec+6,	yyvstop+925,
yycrank+0,	yysvec+6,	yyvstop+928,
yycrank+0,	yysvec+6,	yyvstop+932,
yycrank+590,	yysvec+6,	yyvstop+936,
yycrank+587,	yysvec+6,	yyvstop+939,
yycrank+605,	yysvec+6,	yyvstop+943,
yycrank+0,	yysvec+6,	yyvstop+946,
yycrank+606,	yysvec+6,	yyvstop+950,
yycrank+603,	yysvec+6,	yyvstop+953,
yycrank+0,	yysvec+6,	yyvstop+956,
yycrank+0,	yysvec+6,	yyvstop+960,
yycrank+595,	yysvec+6,	yyvstop+964,
yycrank+611,	yysvec+6,	yyvstop+967,
yycrank+597,	yysvec+6,	yyvstop+970,
yycrank+602,	yysvec+6,	yyvstop+973,
yycrank+608,	yysvec+6,	yyvstop+976,
yycrank+0,	yysvec+6,	yyvstop+979,
yycrank+606,	yysvec+6,	yyvstop+983,
yycrank+671,	yysvec+6,	yyvstop+986,
yycrank+609,	yysvec+6,	yyvstop+990,
yycrank+0,	yysvec+6,	yyvstop+993,
yycrank+619,	yysvec+6,	yyvstop+997,
yycrank+604,	yysvec+6,	yyvstop+1000,
yycrank+610,	yysvec+6,	yyvstop+1003,
yycrank+0,	yysvec+6,	yyvstop+1006,
yycrank+0,	yysvec+6,	yyvstop+1010,
yycrank+627,	yysvec+6,	yyvstop+1014,
yycrank+612,	yysvec+6,	yyvstop+1017,
yycrank+615,	yysvec+6,	yyvstop+1020,
yycrank+615,	yysvec+6,	yyvstop+1023,
yycrank+623,	yysvec+6,	yyvstop+1026,
yycrank+611,	yysvec+6,	yyvstop+1029,
yycrank+619,	yysvec+6,	yyvstop+1032,
yycrank+615,	yysvec+6,	yyvstop+1035,
yycrank+618,	yysvec+6,	yyvstop+1038,
yycrank+626,	yysvec+6,	yyvstop+1041,
yycrank+616,	yysvec+6,	yyvstop+1044,
yycrank+623,	yysvec+6,	yyvstop+1047,
yycrank+0,	yysvec+6,	yyvstop+1050,
yycrank+0,	yysvec+6,	yyvstop+1054,
yycrank+638,	yysvec+6,	yyvstop+1058,
yycrank+631,	yysvec+6,	yyvstop+1061,
yycrank+621,	yysvec+6,	yyvstop+1064,
yycrank+627,	yysvec+6,	yyvstop+1067,
yycrank+0,	yysvec+6,	yyvstop+1070,
yycrank+0,	yysvec+6,	yyvstop+1074,
yycrank+626,	yysvec+6,	yyvstop+1078,
yycrank+624,	yysvec+6,	yyvstop+1081,
yycrank+637,	yysvec+6,	yyvstop+1084,
yycrank+642,	yysvec+6,	yyvstop+1087,
yycrank+643,	yysvec+6,	yyvstop+1090,
yycrank+635,	yysvec+6,	yyvstop+1093,
yycrank+651,	yysvec+6,	yyvstop+1096,
yycrank+637,	yysvec+6,	yyvstop+1099,
yycrank+634,	yysvec+6,	yyvstop+1102,
yycrank+0,	yysvec+6,	yyvstop+1105,
yycrank+644,	yysvec+6,	yyvstop+1109,
yycrank+634,	yysvec+6,	yyvstop+1112,
yycrank+0,	yysvec+6,	yyvstop+1115,
yycrank+636,	yysvec+6,	yyvstop+1119,
yycrank+638,	yysvec+6,	yyvstop+1122,
yycrank+648,	yysvec+6,	yyvstop+1125,
yycrank+641,	yysvec+6,	yyvstop+1128,
yycrank+655,	yysvec+6,	yyvstop+1131,
yycrank+0,	yysvec+6,	yyvstop+1134,
yycrank+640,	yysvec+6,	yyvstop+1138,
yycrank+0,	yysvec+6,	yyvstop+1141,
yycrank+0,	yysvec+6,	yyvstop+1145,
yycrank+661,	yysvec+6,	yyvstop+1149,
yycrank+649,	yysvec+6,	yyvstop+1152,
yycrank+659,	yysvec+6,	yyvstop+1155,
yycrank+0,	yysvec+6,	yyvstop+1158,
yycrank+659,	yysvec+6,	yyvstop+1162,
yycrank+652,	yysvec+6,	yyvstop+1165,
yycrank+0,	yysvec+6,	yyvstop+1168,
yycrank+660,	yysvec+6,	yyvstop+1172,
yycrank+663,	yysvec+6,	yyvstop+1175,
yycrank+0,	yysvec+6,	yyvstop+1179,
yycrank+668,	yysvec+6,	yyvstop+1183,
yycrank+659,	yysvec+6,	yyvstop+1186,
yycrank+671,	yysvec+6,	yyvstop+1189,
yycrank+664,	yysvec+6,	yyvstop+1192,
yycrank+665,	yysvec+6,	yyvstop+1196,
yycrank+671,	yysvec+6,	yyvstop+1199,
yycrank+654,	yysvec+6,	yyvstop+1202,
yycrank+672,	yysvec+6,	yyvstop+1205,
yycrank+659,	yysvec+6,	yyvstop+1208,
yycrank+671,	yysvec+6,	yyvstop+1211,
yycrank+662,	yysvec+6,	yyvstop+1214,
yycrank+669,	yysvec+6,	yyvstop+1217,
yycrank+684,	yysvec+6,	yyvstop+1220,
yycrank+0,	yysvec+6,	yyvstop+1223,
yycrank+0,	yysvec+6,	yyvstop+1227,
yycrank+0,	yysvec+6,	yyvstop+1231,
yycrank+672,	yysvec+6,	yyvstop+1235,
yycrank+668,	yysvec+6,	yyvstop+1238,
yycrank+673,	yysvec+6,	yyvstop+1241,
yycrank+671,	yysvec+6,	yyvstop+1244,
yycrank+692,	yysvec+6,	yyvstop+1248,
yycrank+687,	yysvec+6,	yyvstop+1251,
yycrank+681,	yysvec+6,	yyvstop+1254,
yycrank+676,	yysvec+6,	yyvstop+1257,
yycrank+678,	yysvec+6,	yyvstop+1260,
yycrank+705,	yysvec+6,	yyvstop+1263,
yycrank+0,	yysvec+6,	yyvstop+1266,
yycrank+673,	yysvec+6,	yyvstop+1270,
yycrank+696,	yysvec+6,	yyvstop+1273,
yycrank+693,	yysvec+6,	yyvstop+1276,
yycrank+698,	yysvec+6,	yyvstop+1279,
yycrank+686,	yysvec+6,	yyvstop+1282,
yycrank+689,	yysvec+6,	yyvstop+1285,
yycrank+692,	yysvec+6,	yyvstop+1288,
yycrank+713,	yysvec+6,	yyvstop+1291,
yycrank+694,	yysvec+6,	yyvstop+1294,
yycrank+705,	yysvec+6,	yyvstop+1297,
yycrank+714,	yysvec+6,	yyvstop+1300,
yycrank+700,	yysvec+6,	yyvstop+1303,
yycrank+704,	yysvec+6,	yyvstop+1306,
yycrank+719,	yysvec+6,	yyvstop+1309,
yycrank+705,	yysvec+6,	yyvstop+1312,
yycrank+705,	yysvec+6,	yyvstop+1315,
yycrank+722,	yysvec+6,	yyvstop+1318,
yycrank+0,	yysvec+6,	yyvstop+1321,
yycrank+710,	yysvec+6,	yyvstop+1325,
yycrank+711,	yysvec+6,	yyvstop+1328,
yycrank+715,	yysvec+6,	yyvstop+1331,
yycrank+710,	yysvec+6,	yyvstop+1334,
yycrank+721,	yysvec+6,	yyvstop+1337,
yycrank+714,	yysvec+6,	yyvstop+1340,
yycrank+709,	yysvec+6,	yyvstop+1343,
yycrank+716,	yysvec+6,	yyvstop+1346,
yycrank+711,	yysvec+6,	yyvstop+1349,
yycrank+712,	yysvec+6,	yyvstop+1353,
yycrank+712,	yysvec+6,	yyvstop+1357,
yycrank+730,	yysvec+6,	yyvstop+1360,
yycrank+714,	yysvec+6,	yyvstop+1363,
yycrank+0,	yysvec+6,	yyvstop+1366,
yycrank+722,	yysvec+6,	yyvstop+1370,
yycrank+712,	yysvec+6,	yyvstop+1373,
yycrank+734,	yysvec+6,	yyvstop+1376,
yycrank+739,	yysvec+6,	yyvstop+1379,
yycrank+721,	yysvec+6,	yyvstop+1383,
yycrank+737,	yysvec+6,	yyvstop+1386,
yycrank+738,	yysvec+6,	yyvstop+1389,
yycrank+733,	yysvec+6,	yyvstop+1392,
yycrank+726,	yysvec+6,	yyvstop+1395,
yycrank+746,	yysvec+6,	yyvstop+1398,
yycrank+741,	yysvec+6,	yyvstop+1401,
yycrank+727,	yysvec+6,	yyvstop+1404,
yycrank+745,	yysvec+6,	yyvstop+1407,
yycrank+742,	yysvec+6,	yyvstop+1410,
yycrank+732,	yysvec+6,	yyvstop+1413,
yycrank+0,	yysvec+6,	yyvstop+1416,
yycrank+735,	yysvec+6,	yyvstop+1420,
yycrank+753,	yysvec+6,	yyvstop+1423,
yycrank+741,	yysvec+6,	yyvstop+1426,
yycrank+743,	yysvec+6,	yyvstop+1429,
yycrank+757,	yysvec+6,	yyvstop+1432,
yycrank+0,	yysvec+6,	yyvstop+1435,
yycrank+747,	yysvec+6,	yyvstop+1439,
yycrank+759,	yysvec+6,	yyvstop+1442,
yycrank+756,	yysvec+6,	yyvstop+1445,
yycrank+741,	yysvec+6,	yyvstop+1448,
yycrank+748,	yysvec+6,	yyvstop+1451,
yycrank+749,	yysvec+6,	yyvstop+1454,
yycrank+0,	yysvec+6,	yyvstop+1457,
yycrank+751,	yysvec+6,	yyvstop+1461,
yycrank+744,	yysvec+6,	yyvstop+1464,
yycrank+756,	yysvec+6,	yyvstop+1467,
yycrank+745,	yysvec+6,	yyvstop+1470,
yycrank+748,	yysvec+6,	yyvstop+1473,
yycrank+753,	yysvec+6,	yyvstop+1476,
yycrank+757,	yysvec+6,	yyvstop+1479,
yycrank+759,	yysvec+6,	yyvstop+1482,
yycrank+0,	yysvec+6,	yyvstop+1485,
yycrank+749,	yysvec+6,	yyvstop+1489,
yycrank+770,	yysvec+6,	yyvstop+1492,
yycrank+756,	yysvec+6,	yyvstop+1495,
yycrank+768,	yysvec+6,	yyvstop+1498,
yycrank+779,	yysvec+6,	yyvstop+1501,
yycrank+772,	yysvec+6,	yyvstop+1504,
yycrank+761,	yysvec+6,	yyvstop+1507,
yycrank+765,	yysvec+6,	yyvstop+1511,
yycrank+760,	yysvec+6,	yyvstop+1514,
yycrank+782,	yysvec+6,	yyvstop+1517,
yycrank+760,	yysvec+6,	yyvstop+1520,
yycrank+0,	yysvec+6,	yyvstop+1523,
yycrank+766,	yysvec+6,	yyvstop+1527,
yycrank+771,	yysvec+6,	yyvstop+1531,
yycrank+783,	yysvec+6,	yyvstop+1534,
yycrank+768,	yysvec+6,	yyvstop+1537,
yycrank+784,	yysvec+6,	yyvstop+1540,
yycrank+771,	yysvec+6,	yyvstop+1543,
yycrank+773,	yysvec+6,	yyvstop+1546,
yycrank+793,	yysvec+6,	yyvstop+1549,
yycrank+779,	yysvec+6,	yyvstop+1552,
yycrank+775,	yysvec+6,	yyvstop+1555,
yycrank+781,	yysvec+6,	yyvstop+1558,
yycrank+776,	yysvec+6,	yyvstop+1561,
yycrank+785,	yysvec+6,	yyvstop+1564,
yycrank+790,	yysvec+6,	yyvstop+1567,
yycrank+791,	yysvec+6,	yyvstop+1570,
yycrank+783,	yysvec+6,	yyvstop+1573,
yycrank+799,	yysvec+6,	yyvstop+1576,
yycrank+805,	yysvec+6,	yyvstop+1579,
yycrank+804,	yysvec+6,	yyvstop+1582,
yycrank+791,	yysvec+6,	yyvstop+1585,
yycrank+788,	yysvec+6,	yyvstop+1588,
yycrank+790,	yysvec+6,	yyvstop+1591,
yycrank+0,	yysvec+6,	yyvstop+1595,
yycrank+805,	yysvec+6,	yyvstop+1599,
yycrank+806,	yysvec+6,	yyvstop+1602,
yycrank+0,	yysvec+6,	yyvstop+1605,
yycrank+0,	yysvec+6,	yyvstop+1609,
yycrank+0,	yysvec+6,	yyvstop+1613,
yycrank+813,	yysvec+6,	yyvstop+1617,
yycrank+801,	yysvec+6,	yyvstop+1620,
yycrank+809,	yysvec+6,	yyvstop+1623,
yycrank+808,	yysvec+6,	yyvstop+1626,
yycrank+0,	yysvec+6,	yyvstop+1629,
yycrank+804,	yysvec+6,	yyvstop+1633,
yycrank+817,	yysvec+6,	yyvstop+1636,
yycrank+806,	yysvec+6,	yyvstop+1639,
yycrank+796,	yysvec+6,	yyvstop+1642,
yycrank+803,	yysvec+6,	yyvstop+1645,
yycrank+819,	yysvec+6,	yyvstop+1649,
yycrank+819,	yysvec+6,	yyvstop+1652,
yycrank+820,	yysvec+6,	yyvstop+1655,
yycrank+812,	yysvec+6,	yyvstop+1658,
yycrank+0,	yysvec+6,	yyvstop+1661,
yycrank+822,	yysvec+6,	yyvstop+1665,
yycrank+827,	yysvec+6,	yyvstop+1668,
yycrank+826,	yysvec+6,	yyvstop+1671,
yycrank+0,	yysvec+6,	yyvstop+1674,
yycrank+831,	yysvec+6,	yyvstop+1678,
yycrank+813,	yysvec+6,	yyvstop+1682,
yycrank+0,	yysvec+6,	yyvstop+1686,
yycrank+821,	yysvec+6,	yyvstop+1690,
yycrank+815,	yysvec+6,	yyvstop+1693,
yycrank+810,	yysvec+6,	yyvstop+1696,
yycrank+824,	yysvec+6,	yyvstop+1699,
yycrank+836,	yysvec+6,	yyvstop+1702,
yycrank+822,	yysvec+6,	yyvstop+1705,
yycrank+825,	yysvec+6,	yyvstop+1708,
yycrank+822,	yysvec+6,	yyvstop+1711,
yycrank+838,	yysvec+6,	yyvstop+1714,
yycrank+830,	yysvec+6,	yyvstop+1717,
yycrank+842,	yysvec+6,	yyvstop+1720,
yycrank+829,	yysvec+6,	yyvstop+1723,
yycrank+844,	yysvec+6,	yyvstop+1726,
yycrank+843,	yysvec+6,	yyvstop+1729,
yycrank+842,	yysvec+6,	yyvstop+1732,
yycrank+843,	yysvec+6,	yyvstop+1735,
yycrank+834,	yysvec+6,	yyvstop+1738,
yycrank+847,	yysvec+6,	yyvstop+1741,
yycrank+0,	yysvec+6,	yyvstop+1744,
yycrank+838,	yysvec+6,	yyvstop+1748,
yycrank+844,	yysvec+6,	yyvstop+1751,
yycrank+840,	yysvec+6,	yyvstop+1754,
yycrank+837,	yysvec+6,	yyvstop+1757,
yycrank+857,	yysvec+6,	yyvstop+1760,
yycrank+0,	yysvec+6,	yyvstop+1763,
yycrank+839,	yysvec+6,	yyvstop+1767,
yycrank+843,	yysvec+6,	yyvstop+1770,
yycrank+843,	yysvec+6,	yyvstop+1773,
yycrank+859,	yysvec+6,	yyvstop+1776,
yycrank+858,	yysvec+6,	yyvstop+1779,
yycrank+0,	yysvec+6,	yyvstop+1782,
yycrank+848,	yysvec+6,	yyvstop+1786,
yycrank+0,	yysvec+6,	yyvstop+1789,
yycrank+847,	yysvec+6,	yyvstop+1793,
yycrank+851,	yysvec+6,	yyvstop+1796,
yycrank+850,	yysvec+6,	yyvstop+1799,
yycrank+865,	yysvec+6,	yyvstop+1802,
yycrank+848,	yysvec+6,	yyvstop+1805,
yycrank+848,	yysvec+6,	yyvstop+1808,
yycrank+860,	yysvec+6,	yyvstop+1811,
yycrank+854,	yysvec+6,	yyvstop+1814,
yycrank+851,	yysvec+6,	yyvstop+1817,
yycrank+851,	yysvec+6,	yyvstop+1820,
yycrank+847,	yysvec+6,	yyvstop+1823,
yycrank+854,	yysvec+6,	yyvstop+1826,
yycrank+855,	yysvec+6,	yyvstop+1829,
yycrank+858,	yysvec+6,	yyvstop+1832,
yycrank+868,	yysvec+6,	yyvstop+1835,
yycrank+873,	yysvec+6,	yyvstop+1838,
yycrank+874,	yysvec+6,	yyvstop+1841,
yycrank+860,	yysvec+6,	yyvstop+1844,
yycrank+861,	yysvec+6,	yyvstop+1847,
yycrank+868,	yysvec+6,	yyvstop+1850,
yycrank+874,	yysvec+6,	yyvstop+1853,
yycrank+865,	yysvec+6,	yyvstop+1856,
yycrank+0,	yysvec+6,	yyvstop+1860,
yycrank+0,	yysvec+6,	yyvstop+1864,
yycrank+886,	yysvec+6,	yyvstop+1868,
yycrank+883,	yysvec+6,	yyvstop+1871,
yycrank+872,	yysvec+6,	yyvstop+1874,
yycrank+870,	yysvec+6,	yyvstop+1877,
yycrank+0,	yysvec+6,	yyvstop+1880,
yycrank+864,	yysvec+6,	yyvstop+1884,
yycrank+878,	yysvec+6,	yyvstop+1887,
yycrank+888,	yysvec+6,	yyvstop+1890,
yycrank+0,	yysvec+6,	yyvstop+1893,
yycrank+0,	yysvec+6,	yyvstop+1897,
yycrank+0,	yysvec+6,	yyvstop+1901,
yycrank+0,	yysvec+6,	yyvstop+1905,
yycrank+888,	yysvec+6,	yyvstop+1909,
yycrank+888,	yysvec+6,	yyvstop+1912,
yycrank+880,	yysvec+6,	yyvstop+1915,
yycrank+875,	yysvec+6,	yyvstop+1918,
yycrank+895,	yysvec+6,	yyvstop+1921,
yycrank+878,	yysvec+6,	yyvstop+1924,
yycrank+895,	yysvec+6,	yyvstop+1927,
yycrank+0,	yysvec+6,	yyvstop+1930,
yycrank+0,	yysvec+6,	yyvstop+1934,
yycrank+894,	yysvec+6,	yyvstop+1938,
yycrank+895,	yysvec+6,	yyvstop+1941,
yycrank+902,	yysvec+6,	yyvstop+1944,
yycrank+883,	yysvec+6,	yyvstop+1947,
yycrank+901,	yysvec+6,	yyvstop+1951,
yycrank+884,	yysvec+6,	yyvstop+1954,
yycrank+885,	yysvec+6,	yyvstop+1957,
yycrank+897,	yysvec+6,	yyvstop+1960,
yycrank+899,	yysvec+6,	yyvstop+1963,
yycrank+907,	yysvec+6,	yyvstop+1966,
yycrank+897,	yysvec+6,	yyvstop+1969,
yycrank+901,	yysvec+6,	yyvstop+1972,
yycrank+892,	yysvec+6,	yyvstop+1975,
yycrank+900,	yysvec+6,	yyvstop+1978,
yycrank+895,	yysvec+6,	yyvstop+1981,
yycrank+908,	yysvec+6,	yyvstop+1984,
yycrank+916,	yysvec+6,	yyvstop+1987,
yycrank+911,	yysvec+6,	yyvstop+1990,
yycrank+897,	yysvec+6,	yyvstop+1993,
yycrank+896,	yysvec+6,	yyvstop+1996,
yycrank+899,	yysvec+6,	yyvstop+1999,
yycrank+919,	yysvec+6,	yyvstop+2002,
yycrank+915,	yysvec+6,	yyvstop+2005,
yycrank+917,	yysvec+6,	yyvstop+2008,
yycrank+914,	yysvec+6,	yyvstop+2011,
yycrank+923,	yysvec+6,	yyvstop+2014,
yycrank+906,	yysvec+6,	yyvstop+2017,
yycrank+914,	yysvec+6,	yyvstop+2020,
yycrank+908,	yysvec+6,	yyvstop+2023,
yycrank+907,	yysvec+6,	yyvstop+2026,
yycrank+913,	yysvec+6,	yyvstop+2029,
yycrank+908,	yysvec+6,	yyvstop+2032,
yycrank+911,	yysvec+6,	yyvstop+2035,
yycrank+912,	yysvec+6,	yyvstop+2038,
yycrank+0,	yysvec+6,	yyvstop+2041,
yycrank+918,	yysvec+6,	yyvstop+2045,
yycrank+915,	yysvec+6,	yyvstop+2048,
yycrank+934,	yysvec+6,	yyvstop+2051,
yycrank+916,	yysvec+6,	yyvstop+2054,
yycrank+932,	yysvec+6,	yyvstop+2057,
yycrank+939,	yysvec+6,	yyvstop+2060,
yycrank+930,	yysvec+6,	yyvstop+2063,
yycrank+925,	yysvec+6,	yyvstop+2066,
yycrank+923,	yysvec+6,	yyvstop+2069,
yycrank+933,	yysvec+6,	yyvstop+2072,
yycrank+931,	yysvec+6,	yyvstop+2075,
yycrank+939,	yysvec+6,	yyvstop+2078,
yycrank+940,	yysvec+6,	yyvstop+2081,
yycrank+927,	yysvec+6,	yyvstop+2084,
yycrank+927,	yysvec+6,	yyvstop+2087,
yycrank+0,	yysvec+6,	yyvstop+2090,
yycrank+945,	yysvec+6,	yyvstop+2094,
yycrank+938,	yysvec+6,	yyvstop+2097,
yycrank+932,	yysvec+6,	yyvstop+2100,
yycrank+952,	yysvec+6,	yyvstop+2103,
yycrank+0,	yysvec+6,	yyvstop+2106,
yycrank+929,	yysvec+6,	yyvstop+2110,
yycrank+951,	yysvec+6,	yyvstop+2113,
yycrank+958,	yysvec+6,	yyvstop+2116,
yycrank+943,	yysvec+6,	yyvstop+2119,
yycrank+939,	yysvec+6,	yyvstop+2122,
yycrank+961,	yysvec+6,	yyvstop+2125,
yycrank+941,	yysvec+6,	yyvstop+2128,
yycrank+0,	yysvec+6,	yyvstop+2131,
yycrank+961,	yysvec+6,	yyvstop+2135,
yycrank+0,	yysvec+6,	yyvstop+2138,
yycrank+964,	yysvec+6,	yyvstop+2142,
yycrank+948,	yysvec+6,	yyvstop+2145,
yycrank+0,	yysvec+6,	yyvstop+2148,
yycrank+953,	yysvec+6,	yyvstop+2152,
yycrank+957,	yysvec+6,	yyvstop+2155,
yycrank+968,	yysvec+6,	yyvstop+2158,
yycrank+949,	yysvec+6,	yyvstop+2161,
yycrank+968,	yysvec+6,	yyvstop+2164,
yycrank+950,	yysvec+6,	yyvstop+2167,
yycrank+0,	yysvec+6,	yyvstop+2170,
yycrank+967,	yysvec+6,	yyvstop+2174,
yycrank+964,	yysvec+6,	yyvstop+2177,
yycrank+952,	yysvec+6,	yyvstop+2180,
yycrank+951,	yysvec+6,	yyvstop+2183,
yycrank+970,	yysvec+6,	yyvstop+2186,
yycrank+963,	yysvec+6,	yyvstop+2189,
yycrank+959,	yysvec+6,	yyvstop+2192,
yycrank+966,	yysvec+6,	yyvstop+2195,
yycrank+974,	yysvec+6,	yyvstop+2198,
yycrank+961,	yysvec+6,	yyvstop+2201,
yycrank+961,	yysvec+6,	yyvstop+2205,
yycrank+981,	yysvec+6,	yyvstop+2208,
yycrank+982,	yysvec+6,	yyvstop+2211,
yycrank+980,	yysvec+6,	yyvstop+2214,
yycrank+982,	yysvec+6,	yyvstop+2217,
yycrank+978,	yysvec+6,	yyvstop+2220,
yycrank+966,	yysvec+6,	yyvstop+2223,
yycrank+0,	yysvec+6,	yyvstop+2226,
yycrank+968,	yysvec+6,	yyvstop+2230,
yycrank+984,	yysvec+6,	yyvstop+2233,
yycrank+985,	yysvec+6,	yyvstop+2236,
yycrank+986,	yysvec+6,	yyvstop+2239,
yycrank+991,	yysvec+6,	yyvstop+2242,
yycrank+979,	yysvec+6,	yyvstop+2245,
yycrank+0,	yysvec+6,	yyvstop+2248,
yycrank+974,	yysvec+6,	yyvstop+2252,
yycrank+994,	yysvec+6,	yyvstop+2255,
yycrank+0,	yysvec+6,	yyvstop+2258,
yycrank+978,	yysvec+6,	yyvstop+2262,
yycrank+983,	yysvec+6,	yyvstop+2265,
yycrank+979,	yysvec+6,	yyvstop+2268,
yycrank+994,	yysvec+6,	yyvstop+2271,
yycrank+986,	yysvec+6,	yyvstop+2274,
yycrank+983,	yysvec+6,	yyvstop+2277,
yycrank+982,	yysvec+6,	yyvstop+2280,
yycrank+998,	yysvec+6,	yyvstop+2283,
yycrank+991,	yysvec+6,	yyvstop+2286,
yycrank+986,	yysvec+6,	yyvstop+2289,
yycrank+988,	yysvec+6,	yyvstop+2293,
yycrank+0,	yysvec+6,	yyvstop+2296,
yycrank+998,	yysvec+6,	yyvstop+2300,
yycrank+993,	yysvec+6,	yyvstop+2303,
yycrank+1008,	yysvec+6,	yyvstop+2306,
yycrank+1005,	yysvec+6,	yyvstop+2309,
yycrank+1008,	yysvec+6,	yyvstop+2312,
yycrank+0,	yysvec+6,	yyvstop+2315,
yycrank+0,	yysvec+6,	yyvstop+2319,
yycrank+1011,	yysvec+6,	yyvstop+2323,
yycrank+992,	yysvec+6,	yyvstop+2326,
yycrank+1015,	yysvec+6,	yyvstop+2329,
yycrank+1003,	yysvec+6,	yyvstop+2332,
yycrank+1007,	yysvec+6,	yyvstop+2335,
yycrank+1001,	yysvec+6,	yyvstop+2338,
yycrank+1002,	yysvec+6,	yyvstop+2341,
yycrank+1014,	yysvec+6,	yyvstop+2344,
yycrank+1015,	yysvec+6,	yyvstop+2347,
yycrank+999,	yysvec+6,	yyvstop+2350,
yycrank+1016,	yysvec+6,	yyvstop+2353,
yycrank+1003,	yysvec+6,	yyvstop+2356,
yycrank+1005,	yysvec+6,	yyvstop+2359,
yycrank+1016,	yysvec+6,	yyvstop+2362,
yycrank+1027,	yysvec+6,	yyvstop+2365,
yycrank+1028,	yysvec+6,	yyvstop+2368,
yycrank+1024,	yysvec+6,	yyvstop+2371,
yycrank+1014,	yysvec+6,	yyvstop+2374,
yycrank+1012,	yysvec+6,	yyvstop+2377,
yycrank+1030,	yysvec+6,	yyvstop+2380,
yycrank+1009,	yysvec+6,	yyvstop+2383,
yycrank+1008,	yysvec+6,	yyvstop+2386,
yycrank+1035,	yysvec+6,	yyvstop+2389,
yycrank+0,	yysvec+6,	yyvstop+2393,
yycrank+1030,	yysvec+6,	yyvstop+2397,
yycrank+1033,	yysvec+6,	yyvstop+2400,
yycrank+1033,	yysvec+6,	yyvstop+2403,
yycrank+1039,	yysvec+6,	yyvstop+2406,
yycrank+1030,	yysvec+6,	yyvstop+2409,
yycrank+1041,	yysvec+6,	yyvstop+2412,
yycrank+1037,	yysvec+6,	yyvstop+2415,
yycrank+1043,	yysvec+6,	yyvstop+2418,
yycrank+1025,	yysvec+6,	yyvstop+2421,
yycrank+1026,	yysvec+6,	yyvstop+2424,
yycrank+0,	yysvec+6,	yyvstop+2427,
yycrank+1038,	yysvec+6,	yyvstop+2431,
yycrank+1047,	yysvec+6,	yyvstop+2434,
yycrank+1038,	yysvec+6,	yyvstop+2437,
yycrank+1028,	yysvec+6,	yyvstop+2440,
yycrank+1048,	yysvec+6,	yyvstop+2443,
yycrank+1043,	yysvec+6,	yyvstop+2446,
yycrank+1032,	yysvec+6,	yyvstop+2449,
yycrank+1049,	yysvec+6,	yyvstop+2452,
yycrank+1044,	yysvec+6,	yyvstop+2455,
yycrank+1039,	yysvec+6,	yyvstop+2458,
yycrank+1054,	yysvec+6,	yyvstop+2461,
yycrank+1053,	yysvec+6,	yyvstop+2464,
yycrank+1041,	yysvec+6,	yyvstop+2467,
yycrank+0,	yysvec+6,	yyvstop+2470,
yycrank+1039,	yysvec+6,	yyvstop+2474,
yycrank+1044,	yysvec+6,	yyvstop+2478,
yycrank+1039,	yysvec+6,	yyvstop+2481,
yycrank+1042,	yysvec+6,	yyvstop+2484,
yycrank+1063,	yysvec+6,	yyvstop+2487,
yycrank+1043,	yysvec+6,	yyvstop+2490,
yycrank+1050,	yysvec+6,	yyvstop+2493,
yycrank+1046,	yysvec+6,	yyvstop+2496,
yycrank+1054,	yysvec+6,	yyvstop+2499,
yycrank+1052,	yysvec+6,	yyvstop+2502,
yycrank+1053,	yysvec+6,	yyvstop+2505,
yycrank+1068,	yysvec+6,	yyvstop+2508,
yycrank+1065,	yysvec+6,	yyvstop+2511,
yycrank+1053,	yysvec+6,	yyvstop+2514,
yycrank+0,	yysvec+6,	yyvstop+2517,
yycrank+1067,	yysvec+6,	yyvstop+2521,
yycrank+1055,	yysvec+6,	yyvstop+2524,
yycrank+1065,	yysvec+6,	yyvstop+2527,
yycrank+1055,	yysvec+6,	yyvstop+2530,
yycrank+1061,	yysvec+6,	yyvstop+2533,
yycrank+1072,	yysvec+6,	yyvstop+2536,
yycrank+1062,	yysvec+6,	yyvstop+2539,
yycrank+1074,	yysvec+6,	yyvstop+2542,
yycrank+1062,	yysvec+6,	yyvstop+2545,
yycrank+1076,	yysvec+6,	yyvstop+2548,
yycrank+1068,	yysvec+6,	yyvstop+2551,
yycrank+1068,	yysvec+6,	yyvstop+2554,
yycrank+0,	yysvec+6,	yyvstop+2557,
yycrank+1068,	yysvec+6,	yyvstop+2561,
yycrank+0,	yysvec+6,	yyvstop+2564,
yycrank+1065,	yysvec+6,	yyvstop+2568,
yycrank+0,	yysvec+6,	yyvstop+2571,
yycrank+1068,	yysvec+6,	yyvstop+2575,
yycrank+1068,	yysvec+6,	yyvstop+2578,
yycrank+1073,	yysvec+6,	yyvstop+2581,
yycrank+1085,	yysvec+6,	yyvstop+2584,
yycrank+1086,	yysvec+6,	yyvstop+2587,
yycrank+1092,	yysvec+6,	yyvstop+2590,
yycrank+1095,	yysvec+6,	yyvstop+2593,
yycrank+1090,	yysvec+6,	yyvstop+2596,
yycrank+1078,	yysvec+6,	yyvstop+2599,
yycrank+1082,	yysvec+6,	yyvstop+2602,
yycrank+1089,	yysvec+6,	yyvstop+2605,
yycrank+1079,	yysvec+6,	yyvstop+2608,
yycrank+1101,	yysvec+6,	yyvstop+2611,
yycrank+1086,	yysvec+6,	yyvstop+2614,
yycrank+1082,	yysvec+6,	yyvstop+2617,
yycrank+1083,	yysvec+6,	yyvstop+2620,
yycrank+1100,	yysvec+6,	yyvstop+2623,
yycrank+1087,	yysvec+6,	yyvstop+2626,
yycrank+1086,	yysvec+6,	yyvstop+2629,
yycrank+1102,	yysvec+6,	yyvstop+2632,
yycrank+0,	yysvec+6,	yyvstop+2635,
yycrank+1094,	yysvec+6,	yyvstop+2639,
yycrank+1091,	yysvec+6,	yyvstop+2642,
yycrank+1102,	yysvec+6,	yyvstop+2645,
yycrank+1095,	yysvec+6,	yyvstop+2648,
yycrank+1103,	yysvec+6,	yyvstop+2651,
yycrank+1099,	yysvec+6,	yyvstop+2654,
yycrank+1102,	yysvec+6,	yyvstop+2657,
yycrank+1100,	yysvec+6,	yyvstop+2660,
yycrank+1115,	yysvec+6,	yyvstop+2663,
yycrank+1103,	yysvec+6,	yyvstop+2666,
yycrank+1115,	yysvec+6,	yyvstop+2669,
yycrank+1105,	yysvec+6,	yyvstop+2672,
yycrank+1121,	yysvec+6,	yyvstop+2675,
yycrank+1122,	yysvec+6,	yyvstop+2678,
yycrank+1117,	yysvec+6,	yyvstop+2681,
yycrank+1120,	yysvec+6,	yyvstop+2684,
yycrank+1115,	yysvec+6,	yyvstop+2687,
yycrank+1111,	yysvec+6,	yyvstop+2690,
yycrank+1104,	yysvec+6,	yyvstop+2693,
yycrank+1115,	yysvec+6,	yyvstop+2696,
yycrank+1123,	yysvec+6,	yyvstop+2699,
yycrank+1130,	yysvec+6,	yyvstop+2702,
yycrank+1119,	yysvec+6,	yyvstop+2705,
yycrank+1117,	yysvec+6,	yyvstop+2708,
yycrank+1107,	yysvec+6,	yyvstop+2711,
yycrank+1115,	yysvec+6,	yyvstop+2714,
yycrank+1129,	yysvec+6,	yyvstop+2717,
yycrank+1120,	yysvec+6,	yyvstop+2720,
yycrank+1121,	yysvec+6,	yyvstop+2723,
yycrank+1125,	yysvec+6,	yyvstop+2726,
yycrank+1113,	yysvec+6,	yyvstop+2729,
yycrank+1134,	yysvec+6,	yyvstop+2732,
yycrank+1141,	yysvec+6,	yyvstop+2735,
yycrank+1132,	yysvec+6,	yyvstop+2738,
yycrank+1122,	yysvec+6,	yyvstop+2741,
yycrank+1125,	yysvec+6,	yyvstop+2744,
yycrank+0,	yysvec+6,	yyvstop+2747,
yycrank+1143,	yysvec+6,	yyvstop+2751,
yycrank+1131,	yysvec+6,	yyvstop+2754,
yycrank+1131,	yysvec+6,	yyvstop+2757,
yycrank+1142,	yysvec+6,	yyvstop+2760,
yycrank+1139,	yysvec+6,	yyvstop+2763,
yycrank+1127,	yysvec+6,	yyvstop+2766,
yycrank+1145,	yysvec+6,	yyvstop+2769,
yycrank+0,	yysvec+6,	yyvstop+2772,
yycrank+1130,	yysvec+6,	yyvstop+2776,
yycrank+1132,	yysvec+6,	yyvstop+2779,
yycrank+1144,	yysvec+6,	yyvstop+2782,
yycrank+1136,	yysvec+6,	yyvstop+2785,
yycrank+1156,	yysvec+6,	yyvstop+2788,
yycrank+1137,	yysvec+6,	yyvstop+2791,
yycrank+1158,	yysvec+6,	yyvstop+2794,
yycrank+1153,	yysvec+6,	yyvstop+2797,
yycrank+1137,	yysvec+6,	yyvstop+2800,
yycrank+1155,	yysvec+6,	yyvstop+2803,
yycrank+1136,	yysvec+6,	yyvstop+2806,
yycrank+1161,	yysvec+6,	yyvstop+2809,
yycrank+1159,	yysvec+6,	yyvstop+2812,
yycrank+1145,	yysvec+6,	yyvstop+2815,
yycrank+1156,	yysvec+6,	yyvstop+2818,
yycrank+0,	yysvec+6,	yyvstop+2821,
yycrank+1162,	yysvec+6,	yyvstop+2825,
yycrank+1162,	yysvec+6,	yyvstop+2828,
yycrank+1163,	yysvec+6,	yyvstop+2831,
yycrank+1170,	yysvec+6,	yyvstop+2834,
yycrank+1167,	yysvec+6,	yyvstop+2837,
yycrank+1172,	yysvec+6,	yyvstop+2840,
yycrank+1167,	yysvec+6,	yyvstop+2843,
yycrank+1158,	yysvec+6,	yyvstop+2846,
yycrank+1160,	yysvec+6,	yyvstop+2849,
yycrank+1170,	yysvec+6,	yyvstop+2852,
yycrank+1171,	yysvec+6,	yyvstop+2855,
yycrank+1174,	yysvec+6,	yyvstop+2858,
yycrank+1179,	yysvec+6,	yyvstop+2861,
yycrank+1168,	yysvec+6,	yyvstop+2864,
yycrank+1166,	yysvec+6,	yyvstop+2867,
yycrank+1163,	yysvec+6,	yyvstop+2870,
yycrank+1167,	yysvec+6,	yyvstop+2873,
yycrank+1168,	yysvec+6,	yyvstop+2876,
yycrank+1185,	yysvec+6,	yyvstop+2879,
yycrank+1171,	yysvec+6,	yyvstop+2882,
yycrank+1168,	yysvec+6,	yyvstop+2885,
yycrank+1176,	yysvec+6,	yyvstop+2888,
yycrank+1169,	yysvec+6,	yyvstop+2891,
yycrank+1190,	yysvec+6,	yyvstop+2894,
yycrank+1172,	yysvec+6,	yyvstop+2897,
yycrank+1194,	yysvec+6,	yyvstop+2900,
yycrank+1180,	yysvec+6,	yyvstop+2903,
yycrank+0,	yysvec+6,	yyvstop+2906,
yycrank+1181,	yysvec+6,	yyvstop+2910,
yycrank+1191,	yysvec+6,	yyvstop+2913,
yycrank+1193,	yysvec+6,	yyvstop+2916,
yycrank+1195,	yysvec+6,	yyvstop+2919,
yycrank+1180,	yysvec+6,	yyvstop+2922,
yycrank+1185,	yysvec+6,	yyvstop+2925,
yycrank+1200,	yysvec+6,	yyvstop+2928,
yycrank+1186,	yysvec+6,	yyvstop+2931,
yycrank+1198,	yysvec+6,	yyvstop+2934,
yycrank+1188,	yysvec+6,	yyvstop+2937,
yycrank+1191,	yysvec+6,	yyvstop+2940,
yycrank+1201,	yysvec+6,	yyvstop+2943,
yycrank+1206,	yysvec+6,	yyvstop+2946,
yycrank+0,	yysvec+6,	yyvstop+2949,
yycrank+1204,	yysvec+6,	yyvstop+2953,
yycrank+1210,	yysvec+6,	yyvstop+2956,
yycrank+0,	yysvec+6,	yyvstop+2959,
yycrank+1190,	yysvec+6,	yyvstop+2963,
yycrank+1210,	yysvec+6,	yyvstop+2966,
yycrank+1206,	yysvec+6,	yyvstop+2969,
yycrank+1204,	yysvec+6,	yyvstop+2972,
yycrank+1209,	yysvec+6,	yyvstop+2975,
yycrank+1216,	yysvec+6,	yyvstop+2978,
yycrank+1212,	yysvec+6,	yyvstop+2981,
yycrank+1203,	yysvec+6,	yyvstop+2984,
yycrank+1198,	yysvec+6,	yyvstop+2987,
yycrank+0,	yysvec+6,	yyvstop+2990,
yycrank+1197,	yysvec+6,	yyvstop+2994,
yycrank+1208,	yysvec+6,	yyvstop+2997,
yycrank+1217,	yysvec+6,	yyvstop+3000,
yycrank+1217,	yysvec+6,	yyvstop+3003,
yycrank+1207,	yysvec+6,	yyvstop+3006,
yycrank+1219,	yysvec+6,	yyvstop+3009,
yycrank+0,	yysvec+6,	yyvstop+3012,
yycrank+0,	yysvec+6,	yyvstop+3016,
yycrank+1212,	yysvec+6,	yyvstop+3020,
yycrank+1206,	yysvec+6,	yyvstop+3023,
yycrank+1211,	yysvec+6,	yyvstop+3026,
yycrank+0,	yysvec+6,	yyvstop+3029,
yycrank+1213,	yysvec+6,	yyvstop+3033,
yycrank+1217,	yysvec+6,	yyvstop+3036,
yycrank+1225,	yysvec+6,	yyvstop+3039,
yycrank+1213,	yysvec+6,	yyvstop+3042,
yycrank+1212,	yysvec+6,	yyvstop+3045,
yycrank+1228,	yysvec+6,	yyvstop+3048,
yycrank+1216,	yysvec+6,	yyvstop+3051,
yycrank+1236,	yysvec+6,	yyvstop+3054,
yycrank+1216,	yysvec+6,	yyvstop+3057,
yycrank+1219,	yysvec+6,	yyvstop+3060,
yycrank+1239,	yysvec+6,	yyvstop+3063,
yycrank+1219,	yysvec+6,	yyvstop+3066,
yycrank+0,	yysvec+6,	yyvstop+3069,
yycrank+1226,	yysvec+6,	yyvstop+3073,
yycrank+1221,	yysvec+6,	yyvstop+3076,
yycrank+1237,	yysvec+6,	yyvstop+3079,
yycrank+1224,	yysvec+6,	yyvstop+3082,
yycrank+1239,	yysvec+6,	yyvstop+3085,
yycrank+0,	yysvec+6,	yyvstop+3088,
yycrank+0,	yysvec+6,	yyvstop+3092,
yycrank+1233,	yysvec+6,	yyvstop+3096,
yycrank+1247,	yysvec+6,	yyvstop+3099,
yycrank+1231,	yysvec+6,	yyvstop+3102,
yycrank+1223,	yysvec+6,	yyvstop+3105,
yycrank+1224,	yysvec+6,	yyvstop+3108,
yycrank+1237,	yysvec+6,	yyvstop+3111,
yycrank+1237,	yysvec+6,	yyvstop+3114,
yycrank+1230,	yysvec+6,	yyvstop+3117,
yycrank+1235,	yysvec+6,	yyvstop+3120,
yycrank+1245,	yysvec+6,	yyvstop+3123,
yycrank+1235,	yysvec+6,	yyvstop+3126,
yycrank+1257,	yysvec+6,	yyvstop+3129,
yycrank+1252,	yysvec+6,	yyvstop+3132,
yycrank+1243,	yysvec+6,	yyvstop+3135,
yycrank+1260,	yysvec+6,	yyvstop+3138,
yycrank+1261,	yysvec+6,	yyvstop+3141,
yycrank+1256,	yysvec+6,	yyvstop+3144,
yycrank+1258,	yysvec+6,	yyvstop+3147,
yycrank+1264,	yysvec+6,	yyvstop+3150,
yycrank+1265,	yysvec+6,	yyvstop+3153,
yycrank+1260,	yysvec+6,	yyvstop+3156,
yycrank+1251,	yysvec+6,	yyvstop+3159,
yycrank+1252,	yysvec+6,	yyvstop+3162,
yycrank+0,	yysvec+6,	yyvstop+3165,
yycrank+1263,	yysvec+6,	yyvstop+3169,
yycrank+1264,	yysvec+6,	yyvstop+3172,
yycrank+0,	yysvec+6,	yyvstop+3175,
yycrank+1269,	yysvec+6,	yyvstop+3179,
yycrank+1253,	yysvec+6,	yyvstop+3182,
yycrank+1267,	yysvec+6,	yyvstop+3185,
yycrank+0,	yysvec+6,	yyvstop+3188,
yycrank+1260,	yysvec+6,	yyvstop+3192,
yycrank+1265,	yysvec+6,	yyvstop+3195,
yycrank+0,	yysvec+6,	yyvstop+3198,
yycrank+1254,	yysvec+6,	yyvstop+3202,
yycrank+1262,	yysvec+6,	yyvstop+3205,
yycrank+1278,	yysvec+6,	yyvstop+3208,
yycrank+1264,	yysvec+6,	yyvstop+3211,
yycrank+1270,	yysvec+6,	yyvstop+3214,
yycrank+1264,	yysvec+6,	yyvstop+3217,
yycrank+1276,	yysvec+6,	yyvstop+3220,
yycrank+1283,	yysvec+6,	yyvstop+3223,
yycrank+1284,	yysvec+6,	yyvstop+3226,
yycrank+0,	yysvec+6,	yyvstop+3229,
yycrank+1277,	yysvec+6,	yyvstop+3233,
yycrank+1284,	yysvec+6,	yyvstop+3236,
yycrank+1281,	yysvec+6,	yyvstop+3239,
yycrank+1269,	yysvec+6,	yyvstop+3242,
yycrank+1289,	yysvec+6,	yyvstop+3245,
yycrank+1273,	yysvec+6,	yyvstop+3248,
yycrank+1276,	yysvec+6,	yyvstop+3251,
yycrank+1271,	yysvec+6,	yyvstop+3254,
yycrank+1287,	yysvec+6,	yyvstop+3257,
yycrank+1277,	yysvec+6,	yyvstop+3260,
yycrank+1280,	yysvec+6,	yyvstop+3263,
yycrank+1297,	yysvec+6,	yyvstop+3266,
yycrank+1281,	yysvec+6,	yyvstop+3269,
yycrank+1282,	yysvec+6,	yyvstop+3272,
yycrank+1285,	yysvec+6,	yyvstop+3275,
yycrank+1287,	yysvec+6,	yyvstop+3278,
yycrank+1281,	yysvec+6,	yyvstop+3281,
yycrank+0,	yysvec+6,	yyvstop+3284,
yycrank+0,	yysvec+6,	yyvstop+3288,
yycrank+1282,	yysvec+6,	yyvstop+3292,
yycrank+1302,	yysvec+6,	yyvstop+3295,
yycrank+1286,	yysvec+6,	yyvstop+3298,
yycrank+1284,	yysvec+6,	yyvstop+3301,
yycrank+1291,	yysvec+6,	yyvstop+3304,
yycrank+1289,	yysvec+6,	yyvstop+3307,
yycrank+0,	yysvec+6,	yyvstop+3310,
yycrank+1292,	yysvec+6,	yyvstop+3314,
yycrank+0,	yysvec+6,	yyvstop+3317,
yycrank+1295,	yysvec+6,	yyvstop+3321,
yycrank+1305,	yysvec+6,	yyvstop+3324,
yycrank+1297,	yysvec+6,	yyvstop+3327,
yycrank+1296,	yysvec+6,	yyvstop+3330,
yycrank+1297,	yysvec+6,	yyvstop+3333,
yycrank+1315,	yysvec+6,	yyvstop+3336,
yycrank+1303,	yysvec+6,	yyvstop+3339,
yycrank+1300,	yysvec+6,	yyvstop+3342,
yycrank+1312,	yysvec+6,	yyvstop+3345,
yycrank+1302,	yysvec+6,	yyvstop+3348,
yycrank+1314,	yysvec+6,	yyvstop+3351,
yycrank+1300,	yysvec+6,	yyvstop+3354,
yycrank+1322,	yysvec+6,	yyvstop+3357,
yycrank+1323,	yysvec+6,	yyvstop+3360,
yycrank+1324,	yysvec+6,	yyvstop+3363,
yycrank+1319,	yysvec+6,	yyvstop+3366,
yycrank+0,	yysvec+6,	yyvstop+3369,
yycrank+1320,	yysvec+6,	yyvstop+3373,
yycrank+1321,	yysvec+6,	yyvstop+3376,
yycrank+1322,	yysvec+6,	yyvstop+3379,
yycrank+0,	yysvec+6,	yyvstop+3382,
yycrank+1330,	yysvec+6,	yyvstop+3386,
yycrank+1331,	yysvec+6,	yyvstop+3389,
yycrank+1326,	yysvec+6,	yyvstop+3392,
yycrank+1312,	yysvec+6,	yyvstop+3395,
yycrank+1311,	yysvec+6,	yyvstop+3398,
yycrank+1314,	yysvec+6,	yyvstop+3401,
yycrank+1321,	yysvec+6,	yyvstop+3404,
yycrank+1331,	yysvec+6,	yyvstop+3407,
yycrank+1332,	yysvec+6,	yyvstop+3410,
yycrank+1331,	yysvec+6,	yyvstop+3413,
yycrank+1325,	yysvec+6,	yyvstop+3416,
yycrank+0,	yysvec+6,	yyvstop+3419,
yycrank+1335,	yysvec+6,	yyvstop+3423,
yycrank+1336,	yysvec+6,	yyvstop+3426,
yycrank+1329,	yysvec+6,	yyvstop+3429,
yycrank+0,	yysvec+6,	yyvstop+3432,
yycrank+1325,	yysvec+6,	yyvstop+3436,
yycrank+1341,	yysvec+6,	yyvstop+3439,
yycrank+1340,	yysvec+6,	yyvstop+3442,
yycrank+1332,	yysvec+6,	yyvstop+3445,
yycrank+1348,	yysvec+6,	yyvstop+3448,
yycrank+1332,	yysvec+6,	yyvstop+3451,
yycrank+1333,	yysvec+6,	yyvstop+3454,
yycrank+1334,	yysvec+6,	yyvstop+3457,
yycrank+1337,	yysvec+6,	yyvstop+3460,
yycrank+1353,	yysvec+6,	yyvstop+3463,
yycrank+1354,	yysvec+6,	yyvstop+3466,
yycrank+1340,	yysvec+6,	yyvstop+3469,
yycrank+1341,	yysvec+6,	yyvstop+3472,
yycrank+1340,	yysvec+6,	yyvstop+3475,
yycrank+1341,	yysvec+6,	yyvstop+3478,
yycrank+0,	yysvec+6,	yyvstop+3481,
yycrank+1353,	yysvec+6,	yyvstop+3485,
yycrank+1358,	yysvec+6,	yyvstop+3488,
yycrank+1359,	yysvec+6,	yyvstop+3491,
yycrank+0,	yysvec+6,	yyvstop+3494,
yycrank+0,	yysvec+6,	yyvstop+3498,
yycrank+1347,	yysvec+6,	yyvstop+3502,
yycrank+0,	yysvec+6,	yyvstop+3505,
yycrank+0,	yysvec+6,	yyvstop+3509,
yycrank+1348,	yysvec+6,	yyvstop+3513,
yycrank+1349,	yysvec+6,	yyvstop+3516,
yycrank+1343,	yysvec+6,	yyvstop+3519,
yycrank+1350,	yysvec+6,	yyvstop+3522,
yycrank+1346,	yysvec+6,	yyvstop+3525,
yycrank+1353,	yysvec+6,	yyvstop+3528,
yycrank+0,	yysvec+6,	yyvstop+3531,
yycrank+1352,	yysvec+6,	yyvstop+3535,
yycrank+1364,	yysvec+6,	yyvstop+3538,
yycrank+1365,	yysvec+6,	yyvstop+3541,
yycrank+1366,	yysvec+6,	yyvstop+3544,
yycrank+0,	yysvec+6,	yyvstop+3547,
yycrank+1356,	yysvec+6,	yyvstop+3551,
yycrank+1357,	yysvec+6,	yyvstop+3554,
yycrank+0,	yysvec+6,	yyvstop+3557,
yycrank+0,	yysvec+6,	yyvstop+3561,
yycrank+1369,	yysvec+6,	yyvstop+3565,
yycrank+1370,	yysvec+6,	yyvstop+3568,
yycrank+0,	yysvec+6,	yyvstop+3571,
yycrank+1364,	yysvec+6,	yyvstop+3575,
yycrank+1357,	yysvec+6,	yyvstop+3578,
yycrank+0,	yysvec+6,	yyvstop+3581,
yycrank+0,	yysvec+6,	yyvstop+3585,
yycrank+0,	yysvec+6,	yyvstop+3589,
yycrank+1358,	yysvec+6,	yyvstop+3593,
yycrank+1375,	yysvec+6,	yyvstop+3596,
yycrank+1375,	yysvec+6,	yyvstop+3599,
yycrank+0,	yysvec+6,	yyvstop+3602,
yycrank+1376,	yysvec+6,	yyvstop+3606,
yycrank+1368,	yysvec+6,	yyvstop+3609,
yycrank+1369,	yysvec+6,	yyvstop+3612,
yycrank+1370,	yysvec+6,	yyvstop+3615,
yycrank+1380,	yysvec+6,	yyvstop+3618,
yycrank+1381,	yysvec+6,	yyvstop+3621,
yycrank+1373,	yysvec+6,	yyvstop+3624,
yycrank+1374,	yysvec+6,	yyvstop+3627,
yycrank+0,	yysvec+6,	yyvstop+3630,
yycrank+1380,	yysvec+6,	yyvstop+3634,
yycrank+1389,	yysvec+6,	yyvstop+3637,
yycrank+1370,	yysvec+6,	yyvstop+3640,
yycrank+1388,	yysvec+6,	yyvstop+3643,
yycrank+1379,	yysvec+6,	yyvstop+3646,
yycrank+0,	yysvec+6,	yyvstop+3649,
yycrank+0,	yysvec+6,	yyvstop+3653,
yycrank+0,	yysvec+6,	yyvstop+3657,
yycrank+1380,	yysvec+6,	yyvstop+3661,
yycrank+1381,	yysvec+6,	yyvstop+3664,
yycrank+0,	yysvec+6,	yyvstop+3667,
yycrank+0,	yysvec+6,	yyvstop+3671,
yycrank+1381,	yysvec+6,	yyvstop+3675,
yycrank+1377,	yysvec+6,	yyvstop+3678,
yycrank+1395,	yysvec+6,	yyvstop+3681,
yycrank+1400,	yysvec+6,	yyvstop+3684,
yycrank+0,	yysvec+6,	yyvstop+3687,
yycrank+0,	yysvec+6,	yyvstop+3691,
yycrank+0,	yysvec+6,	yyvstop+3695,
yycrank+1386,	yysvec+6,	yyvstop+3699,
yycrank+1392,	yysvec+6,	yyvstop+3702,
yycrank+1382,	yysvec+6,	yyvstop+3705,
yycrank+1390,	yysvec+6,	yyvstop+3708,
yycrank+0,	yysvec+6,	yyvstop+3711,
yycrank+1389,	yysvec+6,	yyvstop+3715,
yycrank+1396,	yysvec+6,	yyvstop+3718,
yycrank+1385,	yysvec+6,	yyvstop+3721,
yycrank+1393,	yysvec+6,	yyvstop+3724,
yycrank+1393,	yysvec+6,	yyvstop+3727,
yycrank+1389,	yysvec+6,	yyvstop+3730,
yycrank+0,	yysvec+6,	yyvstop+3733,
yycrank+1396,	yysvec+6,	yyvstop+3737,
yycrank+1410,	yysvec+6,	yyvstop+3740,
yycrank+0,	yysvec+6,	yyvstop+3743,
yycrank+1392,	yysvec+6,	yyvstop+3747,
yycrank+1404,	yysvec+6,	yyvstop+3750,
yycrank+1399,	yysvec+6,	yyvstop+3753,
yycrank+1401,	yysvec+6,	yyvstop+3756,
yycrank+0,	yysvec+6,	yyvstop+3759,
0,	0,	0};
struct yywork *yytop = yycrank+1511;
struct yysvf *yybgin = yysvec+1;
char yymatch[] = {
  0,   1,   1,   1,   1,   1,   1,   1, 
  1,   9,  10,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  9,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,  45,   1,   1, 
 48,  48,  48,  48,  48,  48,  48,  48, 
 48,  48,   1,   1,   1,   1,   1,   1, 
  1,  65,  65,  65,  65,  65,  65,  65, 
 65,  65,  65,  65,  65,  65,  65,  65, 
 65,  65,  65,  65,  65,  65,  65,  65, 
 65,  65,  65,   1,   1,   1,   1,  45, 
  1,  45,  45,  45,  45,  45,  45,  45, 
 45,  45,  45,  45,  45,  45,  45,  45, 
 45,  45,  45,  45,  45,  45,  45,  45, 
 45,  45,  45,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
0};
char yyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
/*	Copyright (c) 1989 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#pragma ident	"@(#)ncform	6.8	95/02/11 SMI"

int yylineno =1;
# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
char yysbuf[YYLMAX];
char *yysptr = yysbuf;
int *yyfnd;
extern struct yysvf *yyestate;
int yyprevious = YYNEWLINE;
#if defined(__cplusplus) || defined(__STDC__)
int yylook(void)
#else
yylook()
#endif
{
	register struct yysvf *yystate, **lsp;
	register struct yywork *yyt;
	struct yysvf *yyz;
	int yych, yyfirst;
	struct yywork *yyr;
# ifdef LEXDEBUG
	int debug;
# endif
	char *yylastch;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	yyfirst=1;
	if (!yymorfg)
		yylastch = yytext;
	else {
		yymorfg=0;
		yylastch = yytext+yyleng;
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)fprintf(yyout,"state %d\n",yystate-yysvec-1);
# endif
			yyt = yystate->yystoff;
			if(yyt == yycrank && !yyfirst){  /* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == yycrank)break;
				}
#ifndef __cplusplus
			*yylastch++ = yych = input();
#else
			*yylastch++ = yych = lex_input();
#endif
			if(yylastch > &yytext[YYLMAX]) {
				fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
				exit(1);
			}
			yyfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"char ");
				allprint(yych);
				putchar('\n');
				}
# endif
			yyr = yyt;
			if ( (int)yyt > (int)yycrank){
				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					if(lsp > &yylstate[YYLMAX]) {
						fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
						exit(1);
					}
					goto contin;
					}
				}
# ifdef YYOPTIM
			else if((int)yyt < (int)yycrank) {		/* r < yycrank */
				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"compressed state\n");
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					if(lsp > &yylstate[YYLMAX]) {
						fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
						exit(1);
					}
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
					}
# endif
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					if(lsp > &yylstate[YYLMAX]) {
						fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
						exit(1);
					}
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt= yystate->yystoff) != yycrank){
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"state %d char ",yystate-yysvec-1);
				allprint(yych);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			fprintf(yyout,"stopped at %d with ",*(lsp-1)-yysvec-1);
			allprint(yych);
			putchar('\n');
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
				yyleng = yylastch-yytext+1;
				yytext[yyleng] = 0;
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"\nmatch ");
					sprint(yytext);
					fprintf(yyout," action %d\n",*yyfnd);
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
		if (yytext[0] == 0  /* && feof(yyin) */)
			{
			yysptr=yysbuf;
			return(0);
			}
#ifndef __cplusplus
		yyprevious = yytext[0] = input();
		if (yyprevious>0)
			output(yyprevious);
#else
		yyprevious = yytext[0] = lex_input();
		if (yyprevious>0)
			lex_output(yyprevious);
#endif
		yylastch=yytext;
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}
#if defined(__cplusplus) || defined(__STDC__)
int yyback(int *p, int m)
#else
yyback(p, m)
	int *p;
#endif
{
	if (p==0) return(0);
	while (*p) {
		if (*p++ == m)
			return(1);
	}
	return(0);
}
	/* the following are only used in the lex library */
#if defined(__cplusplus) || defined(__STDC__)
int yyinput(void)
#else
yyinput()
#endif
{
#ifndef __cplusplus
	return(input());
#else
	return(lex_input());
#endif
	}
#if defined(__cplusplus) || defined(__STDC__)
void yyoutput(int c)
#else
yyoutput(c)
  int c; 
#endif
{
#ifndef __cplusplus
	output(c);
#else
	lex_output(c);
#endif
	}
#if defined(__cplusplus) || defined(__STDC__)
void yyunput(int c)
#else
yyunput(c)
   int c; 
#endif
{
	unput(c);
	}
