
# line 41 "main.y"
#include "gatt.h"             /* Include struct defn's and defines */

void report();              /* Prototypes; defined in this file. */
void free_pops();
void freechromo();
int declarenewroom();
int declarenewagent();
int compchromo();
int equal_timetables();

extern CHROMOSOME *init_pops();
void insert();
void getbestchromo();
void dump_chromos();
extern void init_genotype();
double drandom();
double insert_prob;
int simulated_annealing=0;
double temperature;
double initial_temperature = 20.0;
int iterations = 10000;
int crowding_factor = 5;
double final_temperature = 0.1;
double cooling_rate = 0.90;
int restart, restarts;
double efm_pressure;
extern void dealwithinput();
extern void printstats();        
double sabestfit;
double avhddb();
int sabest[200];
int vbestfitness=1000000;
int dch[100][500];
int dchnum=0;
void dcheck();
int saved_seed;
int seed_given;
int use_seed_given = 0;
extern int *bests;
extern int nbests;
extern int nsimgroups;
double best_fitness;
int replace_equal = 1;
extern void makerunscreen();
extern void makehelpscreen();
extern void makeprintscreen();
extern char *modagentexcs;
extern char *modslotexcs;
extern char *modroomexcs;
int maxconsecutive = 0;  /* max consecutive exams */
int allmodsexcludenum = 0;
/* Defined in chromo.c */

extern void create_chromo();
extern void copy_genotype();
extern void freechromo();
extern CHROMOSOME copychromo();

/* Defined in select.c */

extern CHROMOSOME rank_select();
extern CHROMOSOME fitprop_select();
extern CHROMOSOME tm_select();
extern CHROMOSOME tn_select();

/* Defined in reprod.c */

extern void hillclimb();
extern void one_reproduction();
extern void gen_reproduction();
extern void ss_gen_reproduction();
extern void ss_one_reproduction();
extern void ss_one_boltzmann_reproduction();
extern void mix_ops_ss_one_reproduction();
extern void evolutionary_reproduction();
extern void save_best_reinit();
extern void crossexpts();
extern int bestpen;
extern int bestclash;
extern int besttc;

/* Defined in cross.c */

extern CHROMOSOME one_pt_cross();
extern CHROMOSOME two_pt_cross();
extern CHROMOSOME uniform_cross();
extern CHROMOSOME temporal_stamp_recombination();
extern CHROMOSOME directed_temporal_stamp_recombination();
extern CHROMOSOME violation_directed_recombination();

/* Defined in mutate.c */

extern double adaptive();
extern double nonadaptive();
extern double diversity();
extern double diversity_measure;

/* Defined in reinit.c */

extern void no_reinit();
extern void converge_reinit();
extern void permute_slots_reinit();
extern void complete_reinit();

/* Defined in tt0.c */

extern CHROMOSOME mutate_tt0();
extern CHROMOSOME mutate_vdm();
extern CHROMOSOME mutate_efm();
/* int tnchange_size;
   int tnrchange_size;
   int tnachange_size;
   int tnchoose_size;
*/
/* Defined in print.c */

extern void print_best_tt();
extern void print_student_tts();

/* defined in main.l */

extern void addtonamelist();

/* defined in screens.c */
extern int sort_main_help_action();
extern int sort_out_print_action(); 
extern int current_state_id;
extern int poss_actions_id;
/* Standard C lib stuff */

extern FILE *fopen();
extern int fscanf();
extern char *malloc();
extern char *strdup();
extern long random();
/* Globals used in various files, but declared here  */

double avhd;
int interactive = 1;
int eval_nmodsperday = 0;
int npdpen = 1;
int consecpen = 1;
int clashpen = 1;
int nclashpen = 1;
int juxtpen = 1;
int tooclosepen = 1;
int ntooclosepen = 1;
int modexcslotpen = 1;
int modavslotpen = 1;
int eventcappen = 1;
int studcappen = 1;
int modexcroompen = 1;
int modavroompen = 1;
int agentexcslotpen = 1;
int agentavslotpen = 1;
int agentoverhpen = 1;
int agentunderhpen = 1;
int agentoverepen = 1;
int agentunderepen = 1;
int agentexcmodpen = 1;
int agentavmodpen = 1;
int agentprefpen = 1;
int agentclashpen = 1;
int agenttoomanypen = 1;
int ssloadpen = 1;
int seloadpen = 1;
int studentoomanypen = 1;
int clashperexam_pen = 50;

int slotseatconstraints = 0;
int sloteventconstraints = 0;
int slotseatmax, sloteventmax;
int hctrials;

int numpop = 1,            /* Number of populations */
    numchromo = 200,        /* Number of chromos in a population */
    geno_size = 32,        /* Length of a chromosome */
    gens_stage = 2000,      /* How many times to cycle before asking user */
    repinterval = 100,      /* Interval between screen/file reports */
    isadaptive = FALSE,    /* Using adaptive mutation? */
    last_line = 24,        /* Size of screen; actually found at run time */
    migint = 10,           /* Interval between migrations */
    tournament_size = 3,  /* Default size in tournament selection */
    chromo_id = 1,         /* Chromosome IDs start from this value */
    bestchrom,            /* This keeps track of the best chromosome */
    days,
    slotsperday,
    *bestinpop,           /* Keeps track of best chromo in each pop */
    vdm = FALSE,
    efm = FALSE,
    dsm = FALSE,
    debug = FALSE;

int default_agentmaxmods,
    default_agentmaxhours,
    default_agentminmods,
    default_agentminhours,
    default_expectedmodsize,
    default_agentspermod,
    maxpref,
    maxdaysofar = 0;

  /*  Memory allocators */

JUXT           *newjuxtalloc();
EDGE           *newedgealloc();
LL_MODS        *newllmodalloc();
LL_SPEC        *newllspecalloc();
LL_STUDS       *newllstudalloc();
LL_JUXTS       *newlljuxtsalloc();
LL_EDGES       *newlledgealloc();
LL_JUXTS       *newlljuxtalloc();
_MODULE        *newmodalloc();
_STUDENT       *newstudentalloc(); 
char           *namealloc();

FILE *crosspoints;                 /* File for crossover experiments */
FILE *output = (FILE *)NULL;       /* Output file if any */
FILE *chromofile = (FILE *)NULL;   /* Chromo file, if any output file */
int chromoutput = FALSE;           /* Doing any output? */
int twins = FALSE;         /* Crossover produces pairs, or just one child? */
char outfilename[256], chromofilename[256];
double mute_rate = 0.02,   /* Default proportion of chromo to mutate */
       mutation_rate = 0.2,/* Default proportion of pop to mutate */
       reinit_rate = 0.3,  /* Default reinit mutation rate */
       cross_rate = 0.6,   /* Default crossover rate if applicable */
       bias = 1.5,         /* Default bias for rank selection */
       dsm_rate = 1.0,     /* Default rate for domain-specific mutation*/
       perm_rate = 0.1;
 
double *dchecks, *devals; 
char *eval_name,           /* String giving name of problem */
     *maxfitness,          /* String giving max fitness (if known) */
     *cross_name,          /* String naming crossover type */
     *select_name,         /* String naming selection type */
     *repro_name;          /* String naming reproduction type */
int     *modprefs;            /* Array with maximum agent preferences */
double *total_abs_fitness; /* Used in roulette selection: size of wheel */
int *evals;                /* How often eval has been called in each pop */
int *checks;               /* How many constraint checks per pop */
int ss_xmax,ss_ymax,ss_n;  /* Size of grid and length of walk in ssN */
int n_formae;              /* No. formae to transmit in temp_stamp_rec */  
int n_vdr;                 /* No of genes to swap in viol_direc_recomb */
int trials;                /* Parameter for evolutionary reproduction */
int stochastic_reproduction = 0; /* Is reproduction stochastic ? */
extern double eval_tt();
extern double init_eval_tt();

/* Default bindings for function pointers */

CHROMOSOME (*selection)() = tn_select;
CHROMOSOME (*mutate)() = mutate_tt0;
CHROMOSOME (*crossover)() = uniform_cross;
void (*reproduction)() = one_reproduction;
void (*reinitialise)() = converge_reinit;
double (*mrate)() = nonadaptive;
double (*evaluate)() = eval_tt;
double (*init_evaluate)() = init_eval_tt;
extern void analyse_initial_pop();
extern int randchoose();
extern int abestchoose();
/* extern int tnchoose();*/
extern int randchange();
extern int abestchange();   
extern int tnchange();

/* int (*dmchoose)() = tnchoose;*/
int (*dmchange)() = tnchange; 


int default_roomstudcap = -1;
int default_roommodcap = -1;
int default_modlength = -1;

int minconmods = 0;
int minimods = -1;
int minidays = -1;

int numslotsgiven = 0;
int numroomsgiven = 0;
int numstudentsgiven = 0;
int nummodsgiven = 0;

int numagentsgiven = 0;
int aldaysbetweenmods = -1;
int alslotsbetweenmods = -1;
int alminsbetweenmods = -1;
int agentmodsperday = -1;
int studmodsperday = -1;
int numedges = 0;
int numjuxts = 0;

int roomsmatter = FALSE;
int agentsmatter = FALSE; 
int reprochosen = FALSE;
int spatialchosen = FALSE;
int onegeneforslots = FALSE;
int chromoformat = _SLOT_;
int adaptive_efm = FALSE; 
int lazy_eval = FALSE;
int numtocheck;
extern int inputnumlist[];
extern int numnums;
extern int numnames;
extern int reinits;
extern void resetinputlists();
extern double inputdouble;

/* functions declared here */
int find_num_distinct_bests(CHROMOSOME *);

JUXT      *addnewjuxt();
EDGE      *addnewedge();
_MODULE   *addnewmodule();
_STUDENT  *addnewstudent();

# define THERE 257
# define ARE 258
# define NAME 259
# define NUMBER 260
# define SLOT 261
# define SLOTS 262
# define DAY 263
# define DAYS 264
# define IS 265
# define ON 266
# define AT 267
# define BETWEEN 268
# define MODULE 269
# define MODULES 270
# define ALL 271
# define MINUTES 272
# define HAS 273
# define EXTRA 274
# define STUDENT 275
# define STUDENTS 276
# define TAKES 277
# define FORCE 278
# define FORCIBLY 279
# define F 280
# define PREFER 281
# define PREFERABLY 282
# define P 283
# define WITH 284
# define STRENGTH 285
# define PRIORITY 286
# define IN_ 287
# define INTO 288
# define EXCLUDE 289
# define FROM 290
# define BEFORE 291
# define AFTER 292
# define EXACTLY 293
# define LEAST 294
# define MOST 295
# define AND 296
# define PAIR 297
# define ROOM 298
# define ROOMS 299
# define HAVE 300
# define MINIMISE 301
# define NUMBER_W 302
# define OF 303
# define EXPECTED 304
# define WEIGHT 305
# define TAKING 306
# define CONSECUTIVE 307
# define ALLOW 308
# define TIME 309
# define DATE 310
# define LONG 311
# define LAST 312
# define MINS 313
# define MIN 314
# define LASTS 315
# define PRECISELY 316
# define NO 317
# define LESS 318
# define THAN 319
# define FEWER 320
# define A 321
# define MINIMUM 322
# define MORE 323
# define MAXIMUM 324
# define SAME 325
# define AS 326
# define TO 327
# define BE 328
# define THE 329
# define CONCURRENTLY 330
# define SIMULTANEOUSLY 331
# define MUST 332
# define TAKE 333
# define PLACE 334
# define OCCUR 335
# define HAPPEN 336
# define SITS 337
# define EXAM 338
# define EXAMS 339
# define LECTURE 340
# define LECTURES 341
# define TIMETABLE 342
# define COLON 343
# define SLASH 344
# define ONTO 345
# define MINUTE 346
# define ADDITIONAL 347
# define SITTING 348
# define CONSEC 349
# define SCHEDULE 350
# define STA 351
# define SDA 352
# define CAN 353
# define DESIRABILITY 354
# define DES 355
# define TEACHER 356
# define TEACHERS 357
# define LECTURER 358
# define LECTURERS 359
# define TUTOR 360
# define TUTORS 361
# define AVOID 362
# define PROHIBIT 363
# define PENALTY 364
# define CLASH 365
# define EVENT_SPREAD 366
# define CONSTRAINT 367
# define CONSTRAINTS 368
# define SPECIFICATIONS 369
# define EXCLUSIONS 370
# define ORDERING 371
# define TOO 372
# define MANY 373
# define BEING 374
# define CLOSE 375
# define DOUBLE 376
# define POPULATION 377
# define SIZE 378
# define SPREAD 379
# define INTERMODULE 380
# define REINITIS 381
# define INTERVAL 382
# define GENERATIONS 383
# define PER 384
# define STAGE 385
# define MIGRATION 386
# define RANDOM 387
# define SEED 388
# define OFFSPRING 389
# define BREEDING 390
# define USE 391
# define EVENT_FREEING 392
# define MUTATION 393
# define RATE 394
# define VIOLATION_DIRECTED 395
# define CROSSOVERIS 396
# define NUMRANGE 397
# define EFM_RATE 398
# define ADAPTIVEEFM 399
# define MUTATIONRATEIS 400
# define RESTARTSIS 401
# define SELECTIONIS 402
# define REPRODUCTIONIS 403
# define REINITRATEIS 404
# define SHARE 405
# define STOCHASTIC_REPRODUCTION 406
# define ONE_POINT 407
# define TWO_POINT 408
# define OUTPUT 409
# define FILE_W 410
# define DEMES 411
# define ONLY 412
# define GENE 413
# define FOR 414
# define APART 415
# define INVIGILATOR 416
# define INVIGILATES 417
# define DEFAULT 418
# define DEFAULTS 419
# define HOURS 420
# define HOUR 421
# define PREFERENCE 422
# define INVIGILATE 423
# define AVOIDS 424
# define EXCLUDES 425
# define SPECIFIES 426
# define SPECIFY 427
# define TUTORIAL 428
# define TUTORIALS 429
# define EVENT 430
# define EVENTS 431
# define ASSIGN 432
# define HOLDS 433
# define UNAVAILABLE 434
# define REQUIRE 435
# define REQUIRES 436
# define DEBUG 437
# define TOOMANYPERDAY 438
# define JUXTAPOSITION 439
# define TOOCLOSEPEN 440
# define MODEXCSLOTPEN 441
# define AGENTPREFPEN 442
# define MODAVSLOTPEN 443
# define EVENTCAPPEN 444
# define STUDCAPPEN 445
# define MODEXCROOMPEN 446
# define MODAVROOMPEN 447
# define AGENTEXCSLOTPEN 448
# define AGENTAVSLOTPEN 449
# define AGENTOVERHPEN 450
# define AGENTUNDERHPEN 451
# define AGENTOVEREPEN 452
# define AGENTUNDEREPEN 453
# define AGENTEXCMODPEN 454
# define AGENTAVMODPEN 455
# define CLASHPEN 456
# define NUMPOPSIS 457
# define POPSIZEIS 458
# define GENSSTAGEIS 459
# define REPINITIS 460
# define MIGINITIS 461
# define USE_VDM 462
# define USE_EFM 463
# define CROSSRATEIS 464
# define MUTATERATEIS 465
# define HEURISTIC_EVAL 466
# define EXP_OUTPUT 467
# define SEATS 468
# define CAPACITY 469
# define SSLOADPEN 470
# define SELOADPEN 471
# define SETDM 472
# define PERMRATEIS 473
# define NON_INTERACTIVE 474
# define SEEDIS 475
# define INITIAL_TEMPERATURE 476
# define FINAL_TEMPERATURE 477
# define COOLING_RATE 478
# define ITERATIONS 479
# define NCLASHPEN 480
# define NTOOCLOSEPEN 481
# define SIMULATED_ANNEALING 482
# define CROWDING_FACTOR 483
# define WORD 484
# define AGENTCLASHPEN 485
# define AGENTTOOMANYPEN 486
# define TEACH 487
# define TEACHES 488
# define INVIGILATORS 489
# define MINCOURSES 490
# define CONSECPEN 491

#ifdef __STDC__
#include <stdlib.h>
#include <string.h>
#else
#include <malloc.h>
#include <memory.h>
#endif

#include <values.h>

#ifdef __cplusplus

#ifndef yyerror
	void yyerror(const char *);
#endif

#ifndef yylex
#ifdef __EXTERN_C__
	extern "C" { int yylex(void); }
#else
	int yylex(void);
#endif
#endif
	int yyparse(void);

#endif
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYSTYPE
#define YYSTYPE int
#endif
YYSTYPE yylval;
YYSTYPE yyval;
typedef int yytabelem;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#if YYMAXDEPTH > 0
int yy_yys[YYMAXDEPTH], *yys = yy_yys;
YYSTYPE yy_yyv[YYMAXDEPTH], *yyv = yy_yyv;
#else	/* user does initial allocation */
int *yys;
YYSTYPE *yyv;
#endif
static int yymaxdepth = YYMAXDEPTH;
# define YYERRCODE 256

# line 952 "main.y"


char **filelist;
unsigned nfiles;
extern FILE *yyin;

main(argc,argv)
int argc;
char **argv;
{
  int i, pop,gen,mignext,action,gen_total,fileoutput,ee,evs;
  CHROMOSOME *pops,migchromo;
  filelist = argv+1;
  nfiles = argc-1;

  if(nfiles == 0) {
    fprintf(stderr, "Usage: gatt file1 [file2 ...]\n");
    exit(1);
  }

  printf(" Assimilating the data ... ");
  for(i=0;i<nfiles;i++) {
    yyin = fopen(filelist[i],"r");
    if (!(yyin)) {
      fprintf(stderr, "GATT could not open file %s\n",filelist[i]);
      exit(1);
    }
    fflush(stdout);
    while(!feof(yyin))
      yyparse();
  }
  printf(" Done.\n Initialising ... ");
  dealwithinput();
  
  printf(" Done.");
  
  if (use_seed_given==1)
    srandom(seed_given);
  else /* Initialise random number gen */
    srandom((saved_seed=(unsigned)time(0))); 

  mignext=0;
  
  maxfitness = "1";
  eval_name = "modules/slots";
  cross_name = "uniform";
  select_name = "tn_select";
  repro_name = "one";
  
  if((reproduction == ss_gen_reproduction)
     || (reproduction == ss_one_reproduction)
     || (reproduction == mix_ops_ss_one_reproduction) 
     || (reproduction == ss_one_boltzmann_reproduction)) {
    ss_xmax = (int) sqrt((double)numchromo);
    ss_ymax = numchromo/ss_xmax;
    numchromo = ss_xmax*ss_ymax;
    migint = 0;
  }

 
  if(interactive==0){ 
    
    /* check if we have an output file */
    if (output == (FILE *)NULL) {
      /* open the default one */
      if ((output = fopen("OUTPUT", "r")) == NULL){
	printf("Couldn't open default output file\n");
	exit(0);
      }
    }
    

    total_abs_fitness = (double *)malloc(numpop*sizeof(double));
    pops = init_pops(numpop,numchromo);
    if(simulated_annealing==1)
      cooling_rate =
        exp( (log(final_temperature/initial_temperature)/(gens_stage/iterations)));
    gen_total = 1;
    for(i=0;i<numpop;i++) evals[i]=0;
    for(i=0;i<numpop;i++) checks[i]=0;

    for(gen=1; gen <= gens_stage; gen++, gen_total++) {
      for(pop=0; pop<numpop; pop+=1) {            /* For each generation */
	/* if(pops[0].fitness<0.9){ */
	getbestchromo(pops);
	reproduction(pops,pop*numchromo,numchromo);        /*Reproduce. */
	getbestchromo(pops);
	reinitialise(pops,pop*numchromo,numchromo,reinit_rate);
	getbestchromo(pops);
      }                                           /* Reinitialise */
      if (numpop>1 && migint > 0 && gen%migint==0) {
	migchromo=selection(pops,mignext*numchromo,numchromo);/*Migrate if */
	for(pop=0; pop<numpop; pop+=1) {                   /*necessary. */
	  if(pop != mignext)               /* Don't insert to itssource */
	    insert(pops,migchromo,pop*numchromo,numchromo);
	}
	mignext=(mignext+1)%numpop;
      }

      if((numchromo==1) && (restart<restarts) && (gen==(gens_stage-1)))  {
	if (output){ 
	  if(simulated_annealing==1)
	    bestpen = (int)(1.0/sabestfit - 1);
	  fprintf(output,"Bestpen = %d, cl %d, tc %d, rns %d \n",
		  bestpen, bestclash, besttc, saved_seed);
	}
	restart++; dcheck(pops);
	if(restarts==1) gen=gens_stage; else {
	  free_pops(pops,numpop*numchromo);
	  gen_total = 1;gen=1;
	  pops = init_pops(numpop,numchromo);
	  for(i=0;i<numpop;i++) evals[i] = 0;
	  for(i=0;i<numpop;i++) checks[i] = 0;
	  report(0,fileoutput,pops,0);   
	  sabestfit=-100000.0;
	  bestpen=1000000;
	}
      }
      
    }


    if(numchromo==1)
      fprintf(output,"Bestpen %d, cl %d, tc %d, rns %d  ahd %g  \n",
	      bestpen, bestclash, besttc, saved_seed, avhd);
    else
      fprintf(output," Bestpen %d Num %d HD %g \n", bestpen,
	      find_num_distinct_bests(pops),avhddb(pops));
    exit(0);
  }
  
  stdscr = initscr(); 
  last_line = tgetnum("li"); 
  if(last_line < 0) last_line = 24; 
  /* crosspoints = fopen("cross","a");    */
  
  total_abs_fitness = (double *)malloc(numpop*sizeof(double));
  pops = init_pops(numpop,numchromo);
  getbestchromo(pops);
  gen_total = 1;
  for(i=0;i<numpop;i++) evals[i]=0;
  for(i=0;i<numpop;i++) checks[i]=0;
  action = ASK_AGAIN;
  if(output) {
    fprintf(output,   "\n\n===================================\n");
    fprintf(output,   "               eval = %s\n",eval_name);
    fprintf(output,   "        max-fitness = %s\n",maxfitness);
    fprintf(output,   "       reproduction = %s\n",repro_name);
    fprintf(output,   "             select = %s\n",select_name);
    if(!strcmp(select_name,"fitprop"))
      fprintf(output, "     selection-bias = n/a\n");
    else
      fprintf(output, "     selection-bias = %3.2f\n",bias);
    fprintf(output,   "  chromosome-length = %d\n",geno_size);
    fprintf(output,   "               pops = %d\n",numpop);
    fprintf(output,   "chromosomes-per-pop = %d\n",numchromo);
    fprintf(output,   " migration-interval = %d\n",migint);
    fprintf(output,   "     crossover-type = %s\n",cross_name);
    if(!strcmp(repro_name,"one"))
      fprintf(output, "     crossover-rate = n/a\n");
    else
      fprintf(output, "     crossover-rate = %3.2f\n",cross_rate);
    if(isadaptive)
      fprintf(output, "      mutation-rate = adaptive\n");
    else
      fprintf(output, "      mutation-rate = %3.2f\n", mute_rate);
    fprintf(output,   " reporting-interval = %d\n", repinterval);
    if(twins)
      fprintf(output, "              twins = yes\n");
    else
      fprintf(output, "              twins = no\n");
    fprintf(output,   "\n");
  }

  current_state_id=2;
  poss_actions_id=0;
  report(0,fileoutput,pops,0); 
  current_state_id=0; 
  poss_actions_id=1;
  while(action != QUIT) {
    do {
      switch(getch()) {
      case 'r': case 'R':
	action = RESTART;
	free_pops(pops,numpop*numchromo);
	gen_total = 1;
	pops = init_pops(numpop,numchromo);
	for(i=0;i<numpop;i++) evals[i] = 0;
	for(i=0;i<numpop;i++) checks[i] = 0;
	poss_actions_id = 0;
	report(0,fileoutput,pops,0);
	
	if(output)
	  fprintf(output,
		  "\n\n------ re-starting ------\n\n");
	break;
      case 'c': case 'C':
	action = CONTINUE;
	break;
      case 'q': case 'Q':
	action = QUIT;
	break;
      case 'h' : case 'H':
	action = ASK_AGAIN;
	clear();
	makehelpscreen(pops);
	refresh();
	evs=0;
	for(ee=0;ee<numpop;ee++) evs+=evals[ee];
	action=sort_main_help_action(pops,evs,gen);
	break;
      case 'p': case 'P':
	action = ASK_AGAIN;
	clear();
	makeprintscreen(pops);
	refresh();
	evs=0;
	for(ee=0;ee<numpop;ee++) evs+=evals[ee];
	action=sort_out_print_action(pops,evs,gen);
	break;
      default:
	action = ASK_AGAIN;
	move(0,30);
	clrtoeol();
	refresh(); 
	break;
      }
    } while(action == ASK_AGAIN);
    if(action == CONTINUE) {
      current_state_id=0;
      poss_actions_id=1;
      for(gen=1; gen <= gens_stage; gen++, gen_total++) {
	for(pop=0; pop<numpop; pop+=1) {            /* For each generation */
	  getbestchromo(pops);
	  reproduction(pops,pop*numchromo,numchromo);        /* Reproduce. */
	  getbestchromo(pops);
	  reinitialise(pops,pop*numchromo,numchromo,reinit_rate);
	  getbestchromo(pops);
	}
	
	if((numchromo==1) && (restart<restarts) && (gen==gens_stage)){
	  restart++; 
	  free_pops(pops,numpop*numchromo);
	  gen_total = 1; gen=1;
	  pops = init_pops(numpop,numchromo);
	  for(i=0;i<numpop;i++) evals[i] = 0;
	  for(i=0;i<numpop;i++) checks[i] = 0;
	  report(0,fileoutput,pops,0);
	  
	}
	
	if (numpop>1 && migint > 0 && gen%migint==0) {
	  migchromo=selection(pops,mignext*numchromo,numchromo);
	  /* Migrate if necessary */
	  for(pop=0; pop<numpop; pop+=1) {     
	    if(pop != mignext)               /* Don't insert to its source */
	      insert(pops,migchromo,pop*numchromo,numchromo);
	  }
	  mignext=(mignext+1)%numpop;
	}
	if (gen_total%repinterval==0) {                      /* Report if  */
	  report(gen_total,fileoutput,pops,gen);             /* necessary  */
	}
	if (gen+1==gens_stage)
	  {current_state_id=1; poss_actions_id=0;}
      } 
    }
  }
  if(output)
    fclose(output);
  if(chromoutput)
    fclose(chromofile);
  if (output) printstats();
  if(output) 
    fclose(output);
  free_pops(pops,numpop*numchromo);
  move(last_line-1,0);
  refresh();
  endwin(); 
  exit(0);
}

void act_set_cross()
{
  char *name;
  name = inputnamelist[0]->n;
  
  if      (!strcmp(name,"uniform")) 
    crossover = uniform_cross;
  else
    if (!strcmp(name,"two-point"))
      crossover = two_pt_cross;
    else
      if (!strcmp(name,"one-point"))
	crossover = one_pt_cross;
      else 
	if (!strncmp(name,"temporal_stamp",14)) {
	  crossover = temporal_stamp_recombination;
	  n_formae = atoi(name+14);
	}
	else
	  if (!strncmp(name,"directed_temporal_stamp",23)) { 
	    crossover = directed_temporal_stamp_recombination;
	    n_formae = atoi(name+23);
	  }
	  else
	    if (!strncmp(name,"violation_directed",18)) {
	      crossover = violation_directed_recombination;
	      n_vdr = atoi(name+18);
	    }
}

void act_set_directed_mutation()
{
  efm_pressure = inputdouble;
  resetinputlists();
}

void act_set_repro()
{
  char *name;
  name = inputnamelist[0]->n;
 
  if      (!strcmp(name,"one")) reproduction = one_reproduction;
  else if (!strcmp(name,"gen")) reproduction = gen_reproduction;
  else if (!strncmp(name,"evolutionary",12)) {
    reproduction = evolutionary_reproduction;
    trials = atoi(name+12);
  }
  else if (!strcmp(name,"mis_ops")) reproduction = mix_ops_ss_one_reproduction;
  else if (!strncmp(name,"hillclimb",9)) {
    hctrials = atoi(name+9);
  }
  else if (!strcmp(name,"spatial_one")) {
    reproduction = ss_one_reproduction;
  }
  else if (!strncmp(name, "spatial_one_boltzmann",21)) {
    reproduction = ss_one_boltzmann_reproduction;
  }
  
}

void act_set_reinit()
{
 char *name;
 name = inputnamelist[0]->n;

 if      (!strcmp(name,"none")) reinitialise = no_reinit;
 else if (!strcmp(name,"converge")) reinitialise = converge_reinit;
 else if (!strcmp(name,"permute")) reinitialise = permute_slots_reinit;
 else if (!strcmp(name,"complete")) reinitialise = complete_reinit;
}

void act_set_select()
{ 
 char *name, *name2;
 int num;
 name = inputnamelist[0]->n;
 if(numnames==2)
 name2 = inputnamelist[1]->n;

 num = inputnumlist[0];

 if  (!strcmp(name,"tn")) {
   selection = tn_select;
   tournament_size = num;
 }
 else if  (!strcmp(name,"rank")) {selection = rank_select;}
 else if  (!strcmp(name,"fitprop")) {selection = fitprop_select;}
 else if  (!strcmp(name,"spatial")) {
   spatialchosen = 1; ss_n = num;
   if(!strcmp(name2,"replace_better")) replace_equal=0;
 }
}

void act_declareslots()
{
  numslots = inputnumlist[0];
  resetinputlists();
}
void act_declaredays()
{
  numdays = inputnumlist[0];
  resetinputlists();
}
void act_declarestudents()
{
  numstudents = inputnumlist[0];
  resetinputlists();
}
void act_declarerooms()
{
  numrooms = inputnumlist[0];
  resetinputlists();
}
void act_declaremods()
{
  nummods = inputnumlist[0];
  resetinputlists();
}
void act_declareagents()
{
  numagents = inputnumlist[0];
  resetinputlists();
}

void act_slotdescription()
{
   int ident, day, hrs, mins;

   ident = inputnumlist[0];
   day = inputnumlist[1];
   hrs = inputnumlist[2];
   mins = inputnumlist[3];

   if (!(ident==numslotsgiven)) {
    printf("Error: slots given in wrong order\n");
    exit(0);
  }
  
   if (ident>=numslots) {
     printf("Error: more slots given than previously declared\n");
     exit(0);
   }

   if (day > maxdaysofar)
     maxdaysofar = day; 

   slots[ident] = (struct slot *)malloc(sizeof(struct slot));
   slots[ident]->id = ident;
   slots[ident]->day = day;
   slots[ident]->aday = day;
   slots[ident]->time = (60*hrs)+mins;
   slots[ident]->sscap = -1;
   slots[ident]->secap = -1;
   numslotsgiven++;

   resetinputlists();
 }

void act_roomdescription()
{
  char *roomname;
  int i;
 
 
  for(i=0;i<numnames;i++) {
    roomname = inputnamelist[i]->n;
    declarenewroom(roomname);    
  }
  resetinputlists();
}

void act_moddescription()
{ 
  char     *modname;
  int      i;
  _MODULE  *modp;
  for(i=0;i<numnames;i++) {
    modname = inputnamelist[i]->n;
    t_modules = addnewmodule(t_modules,modname);
    modp = f_module;
  }
  resetinputlists();
}
void act_agentdescription()
{
  char *agentname;
  int i;

  for(i=0;i<numnames;i++) {
    agentname = inputnamelist[i]->n;
    declarenewagent(agentname);
  }
  resetinputlists();
}


void act_daydescription()
{
  int gap, daya, dayb, s = -1, i;
  
  gap = inputnumlist[0];
  daya = inputnumlist[1];
  dayb = inputnumlist[2];

   /* Find the first slot after daya */
  while (!(slots[++s]->day > daya));
  
  /* Add gap to absolute days after slot s */
  for(i=s;i<numslots;i++){
    slots[i]->aday += gap;
  }
  
  resetinputlists();
}

void act_datedescription()
{
  int day, dd, mm, yy;
  
  day = inputnumlist[0];
  dd  = inputnumlist[1];
  mm  = inputnumlist[2];
  yy  = inputnumlist[3];
  
  if (day) {
    printf("Must give date only for day 0, not day %d \n", day);
    resetinputlists();
    return;
  } 
  
  dates[0] = (struct date *)malloc(sizeof(struct date));
  dates[0]->day = dd;
  dates[0]->month = mm;
  dates[0]->year  = yy;
  
  resetinputlists();
}

void act_modlength()
{
 _MODULE *modp;
 int modleng, i;
 
  modleng = inputnumlist[0];
 for(i=0;i<numnames;i++) {
   t_modules = addnewmodule(t_modules,inputnamelist[i]->n);
   modp = f_module;
   modp->len = modleng;
 }
 resetinputlists();
}

void act_expmodsize()
{
 _MODULE *modp;
 int modsize, i;

 modsize = inputnumlist[0];
 for(i=0;i<numnames;i++) {
   t_modules = addnewmodule(t_modules,inputnamelist[i]->n);
   modp = f_module;
   modp->size = modsize;
 }
 resetinputlists();
}

void act_modextrastud()
{
 char *modname;
 int modext;
 _MODULE *modp;

 modname = inputnamelist[0]->n;
 modext = inputnumlist[0];

 t_modules = addnewmodule(t_modules,modname);
 modp = f_module;
 modp->size+= modext;
 resetinputlists();
}

void act_studenttakes(virt)
int virt;
{
  int      i, nmods, start;
  char     *studname;
  _MODULE  *modp;
  _STUDENT *studp;
  
  if (virt) { studname = "virtual";
	      start = 0; }
  else      { studname = inputnamelist[0]->n;
	      start = 1;
	    }
  nmods = numnames;
  
  /* Initialise this student. Note: we assume this student is */
  /* entirely new to the system, and create a new structure   */
  
  studp = addnewstudent(studname);
  
  for(i=start;i<nmods;i++)  {
    /* Look for or place this module in the module tree  */
    t_modules = addnewmodule(t_modules,inputnamelist[i]->n);
    modp = f_module;

    /* Now add this to the list of modules that this student takes */
    /* -- this is a linked list, so the first one is a special case */
    
    if (studp->numtaken==0)   {   /* If this is the first */
      studp->s_mods = newllmodalloc();  /* Get space for it */
      studp->s_mods->mod = modp;        /* Point it to the module */
      studp->s_mods->next = NULL;
      studp->mods = studp->s_mods;
      studp->numtaken++;
    }
    else  {
      studp->p_mods = studp->mods;      /* p_mods points to previous */
      studp->mods = newllmodalloc();    /* Get space for new one */
      studp->mods->mod = modp;          /* Point it to the module */
      studp->mods->next = studp->p_mods;   /* Make the link */
      studp->numtaken++;
    }
    
    /* Similarly, now add this student to the list of takers of the module */
    
    if ((modp->numtakers)==0) {     /* If this is the first */
      modp->s_studs = newllstudalloc();  /* Get space for it */
      modp->s_studs->st = studp;        /* Point it to the student */
      modp->s_studs->next = NULL;
      modp->studs = modp->s_studs;
      modp->numtakers++;
    }
    else {
      modp->p_studs = modp->studs;      /* p_studs points to previous */
      modp->studs = newllstudalloc();   /* Get space for new one */
      modp->studs->st = studp;          /* Point it to the student */
      modp->studs->next = modp->p_studs;   /* Make the link */
      modp->numtakers++;
    }
  }
  
  
  if (debug) printf("Numstudgiven is %d \n", numstudentsgiven);
  resetinputlists();
  /* Individual edge constraints and their sizes are built up afterwards */
}



int declarenewroom(roomname)
char *roomname;
{
  int j;
  /* Find out if room is already declared */
  j=0;
  while ((j<numroomsgiven)&&(strcmp(rooms[j]->name,roomname))) j++;
  
  if (j<numroomsgiven) { /* already declared; it's number is j*/
    return(j);
  }
  else { /* This room is new. Declare it */
    rooms[numroomsgiven] = (struct room *)malloc(sizeof(struct room));
    rooms[numroomsgiven]->name = (char *)malloc(strlen(roomname)+1);
    strcpy(rooms[numroomsgiven]->name,roomname);
    rooms[numroomsgiven]->nummexceptions = 0;
    rooms[numroomsgiven]->numsexceptions = 0;
    rooms[numroomsgiven]->studcap = -1;
    rooms[numroomsgiven]->numexcslots = 0;
    rooms[numroomsgiven++]->modcap = -1;
    return(j);
  }
}

int declarenewagent(agentname)
     char *agentname;
{
  int j;
  
  /* Find out if agent is already declared */
  j=0;
  while ((j<numagentsgiven)&&(strcmp(agents[j]->name,agentname))) j++;
  
  if (j<numagentsgiven) { /* already declared; it's number is j*/
    return(j);
  }
  else { /* This agent is new. Declare it */
    agents[numagentsgiven] = (struct agent *)malloc(sizeof(struct agent));
    agents[numagentsgiven]->name = (char *)malloc(strlen(agentname)+1);
    strcpy(agents[numagentsgiven]->name,agentname);
    agents[numagentsgiven]->nummustdo = 0;
    agents[numagentsgiven]->maxmods = -1;
    agents[numagentsgiven]->minmods = -1;
    agents[numagentsgiven]->maxhours = -1;
    agents[numagentsgiven]->minhours = -1;
    agents[numagentsgiven]->numexcslots = 0;
    agents[numagentsgiven]->numavslots = 0; 
    agents[numagentsgiven]->maxpref = 0;
    agents[numagentsgiven++]->numcando = 0;
    return(j);
  }
}

void act_nstudssharemods()
{
  int   n;
  _MODULE  *mod1, *mod2;
  n = inputnumlist[0];
  
  t_modules  = addnewmodule(t_modules,inputnamelist[0]->n);
  mod1 = f_module;
  t_modules  = addnewmodule(t_modules,inputnamelist[2]->n);
  mod2 = f_module; 
  t_edges = addnewedge(t_edges,mod1,mod2,n);
}




  
void act_roomhascapstud()
{ 
  int roomindex, studcap;
  char *roomname;
  
  roomname = inputnamelist[0]->n;
  studcap = inputnumlist[0];
  
  roomindex = declarenewroom(roomname); 
  
  rooms[roomindex]->studcap = studcap;
  resetinputlists();
}

void act_roomhascapstudinslot()
{
  int roomindex, studcap, s;
  char *roomname;
  
  roomname = inputnamelist[0]->n;
  studcap = inputnumlist[0];
  roomindex = declarenewroom(roomname);
  
  for(s=1;s<numnums;s++) {
  rooms[roomindex]->sexceptions[rooms[roomindex]->numsexceptions] = 
    (struct cap * )malloc(sizeof(struct cap));
  rooms[roomindex]->sexceptions[rooms[roomindex]->numsexceptions]->slot = 
    inputnumlist[s];
  rooms[roomindex]->sexceptions[rooms[roomindex]->numsexceptions++]->cap =
    studcap;
}
  resetinputlists();
}

void act_roomhascapmodinslot()
{
  int roomindex, modcap, s;
  char *roomname;
  
  roomname = inputnamelist[0]->n;
  modcap = inputnumlist[0];
  roomindex = declarenewroom(roomname);

  for(s=1;s<numnums;s++) {
   rooms[roomindex]->mexceptions[rooms[roomindex]->nummexceptions] =
    (struct cap * )malloc(sizeof(struct cap));
   rooms[roomindex]->mexceptions[rooms[roomindex]->nummexceptions]->slot = 
     inputnumlist[s];
   rooms[roomindex]->mexceptions[rooms[roomindex]->nummexceptions++]->cap =
     modcap;
 }
  resetinputlists();
}

void act_roomhascapmod()
{
  int roomindex, modcap;
  char *roomname;
  
  roomname = inputnamelist[0]->n;
  modcap = inputnumlist[0];

  roomindex = declarenewroom(roomname);

  rooms[roomindex]->modcap = modcap;
  resetinputlists();
}

void act_roomunavailableinslot()
{
  char roomindex;
  int s;

  roomindex = declarenewroom(inputnamelist[0]->n);

  for(s=0;s<numnums;s++) {
    rooms[roomindex]->excslots[rooms[roomindex]->numexcslots++]
      = inputnumlist[s];
  }
  resetinputlists();
}
/* If module <modname> is new, declare it, if not, don't. In either case */
/* return its index */

_MODULE *addnewmodule(node,modname)
     _MODULE *node;
     char *modname;
{
  int direction;     /* Where next to go in the tree */

  if(node==NULL) {       /* This is new, so put it in the tree ... */
    
    node = newmodalloc();  /* Try to find memory for it */
    node->name = namealloc(modname);
    strcpy(node->name,modname);
    node->slotspec = node->dayspec = node->roomspec =
      node->agentspec = node->len = node->simgroup =-1;
    
    node->numexcslot = node->numexcagent = node->numexcroom =
      node->numexcday = node->numtakers = node->numedges =
	node->numjuxts = node->numoedges = node->numojuxts = 
	  node->size = node->sim = 0;

    node->id = nummodsgiven++;
    node->left = node->right = NULL;
    node->exslots = 
      node->exagents = 
      node->exrooms = NULL;

    
    node->juxts = NULL;    /* init juxts to NULL, 24/10/97 */
    
    f_module = node;                      /* Send up pointer to it */
    
    /* Now consider the linked list of modules */
    /* See if this is the very first one  */
    
    if(nummodsgiven==1) {   /* If so, special case ... */
      s_modules = node;
      s_modules->next = NULL; 
      modules = s_modules;
    }
    else  {                /* If not, just make the right links */
      p_modules = modules;
      modules = node;
      modules->next = p_modules;
    }     
  }
  else                    /* If this module is already in the tree */
    if ((direction = strcmp(modname,node->name)) == 0) 
      f_module = node;   /* Send up a pointer to it */
  /* Otherwise, continue looking */
   else  if (direction < 0)  
     node->left = addnewmodule(node->left,modname);
   else  if (direction > 0)
     node->right = addnewmodule(node->right,modname);
  return(node);
}


_STUDENT  *addnewstudent(name)
char *name;
{

    if (!numstudentsgiven) {   /* If this is the first student, it's a  */
                              /* special case for the linked list      */
 
   s_students = newstudentalloc();
   s_students->name = namealloc(name);
   strcpy(s_students->name,name);
   s_students->id = numstudentsgiven++;
   s_students->numtaken=0;
   s_students->next = NULL;
   students = s_students;
 }
   else { 
   
   p_students = students;
   students = newstudentalloc();
   students->name = namealloc(name);
   strcpy(students->name,name);
   students->id = numstudentsgiven++;
   students->numtaken=0;
   students->next = p_students;
 }
   return(students);
 }



void act_modexcslot(force)
int force;
{
  int      i, j, end, priority, *slotlist;
  _MODULE  *modp;

  slotlist = inputnumlist;

  if (force) { end=0; priority=10; }
  else { end = 1; priority = slotlist[numnums-1]; }

  for(i=0;i<numnames;i++) { /* For each module */
    t_modules = addnewmodule(t_modules,inputnamelist[i]->n);
    modp = f_module;
    for(j=0;j<numnums-end;j++)  { /* For each excluded slot */
     
      if (modp->numexcslot==0)
                            /* If it's the first, then do this :  */
        {
          modp->s_exslots = newllspecalloc();
          modp->s_exslots->id = slotlist[j];
          modp->s_exslots->forced = force;
          modp->s_exslots->priority = priority;
          modp->s_exslots->next = NULL;
          modp->exslots = modp->s_exslots;
          modp->numexcslot++;
        }
      else                  /* If not, then this : */
        {
          modp->p_exslots = modp->exslots;
          modp->exslots = newllspecalloc();
          modp->exslots->id = slotlist[j];
          modp->exslots->forced = force;
          modp->exslots->priority = priority;
          modp->exslots->next = modp->p_exslots;
          modp->numexcslot++;
	}
    }
  }
 resetinputlists();
}

void act_modreqagents()
{
  int      i, attendees;
  _MODULE  *modp;

   attendees = inputnumlist[0]; 
   for(i=0;i<numnames;i++) {
   t_modules =  addnewmodule(t_modules,inputnamelist[i]->n);
   modp = f_module;
   modp->attendees = attendees;
  }
}
      
void act_modsspecslot()
{
  int      i,s;
  _MODULE  *modp;

  s = inputnumlist[0];

  for(i=0;i<numnames;i++) { /* For each module */
   t_modules = addnewmodule(t_modules,inputnamelist[i]->n);
    modp = f_module;
    modp->slotspec = s;
  }
 resetinputlists();
}


/* rel: before, or between, or same day, or same time */
/* ex_m_l: exactly, at most, or at least */
/* days_mins: days or minutes */

void act_modprecmod(rel, ex_m_l, days_mins) 
int rel, ex_m_l, days_mins;
{
  int      index = 0, endlist1, startlist2, i, j;
  _MODULE  *modp1, *modp2;

  if ((rel==SAME)||(rel==DAY)) {
    /* if these modules are to be at the same time or same day */
    /* then there is just one input list of names, with no divider */
    for(i=0;i<numnames-1; i++) {
     t_modules =  addnewmodule(t_modules,inputnamelist[i]->n);
       modp1 = f_module;
       for(j=i+1;j<numnames; j++){
     t_modules =  addnewmodule(t_modules,inputnamelist[j]->n);
       modp2 = f_module;     
     t_juxts = addnewjuxt(t_juxts,modp1,modp2,rel,ex_m_l,days_mins);
      }
     }
  }
  else {
   /* there are two lists, divided by a "___" */
  while (strcmp(inputnamelist[index]->n,"___")) index++;
   endlist1=index;
   startlist2=index+1;
  
     for(i=0;i<endlist1;i++){
     t_modules =  addnewmodule(t_modules,inputnamelist[i]->n); 
     modp1 = f_module;
       for(j=startlist2;j<numnames;j++) {
       t_modules =  addnewmodule(t_modules,inputnamelist[j]->n);
       modp2 = f_module;
     t_juxts = addnewjuxt(t_juxts,modp1,modp2,rel,ex_m_l,days_mins);
       }
     }
  }
  resetinputlists();
}

JUXT *addnewjuxt(node,modp1,modp2,rel,ex_m_l,days_mins)
int      rel, ex_m_l, days_mins;
JUXT     *node;
_MODULE  *modp1, *modp2;
{
  int      direction, weight,gap=0;
  long     index;
  _MODULE  *temp;

  /* First, capture the gap and/or priority if either of these exist */
  /* If rel is between or before, then there is a gap in force */
  
  if((rel==BEFORE)||(rel==AFTER)||(rel==BETWEEN)) 
      {gap = inputnumlist[0]; weight = inputnumlist[1];}

  /* In all other cases, there is only the weight to be concerned with */
   else weight = inputnumlist[0];
  
  /* Now, put the modules in the right order */
  
   if(modp1->id>modp2->id) { temp=modp1;modp1=modp2;modp2=temp;
                   if (rel==BEFORE) rel=AFTER; 
                   else if (rel==AFTER) rel=BEFORE;}

   index = (long)10000*(modp1->id)+(modp2->id);      /* A hack */

  if(node==NULL) {       /* This is new, so put it in the tree ... */

     node = newjuxtalloc();  /* Try to find memory for it */
     node->id = numjuxts++;
     node->a = modp1;
     node->b = modp2;
     node->index = index; 
     switch (rel) {
          case BEFORE:  node->rel = 0; break;
          case AFTER:   node->rel = 1; break;
          case BETWEEN: node->rel = 2; break;
          case SAME:    node->rel = 3; break;
          case DAY:     node->rel = 4; break;
	  }
     switch (ex_m_l) {
          case EXACTLY: node->elm = 0; break;
          case LEAST:   node->elm = 1; break;
          case MOST:    node->elm = 2; break;
	  }
     switch (days_mins) {
          case DAYS:    node->dsm = 0; break;
          case MINUTES: node->dsm = 1; break;
	  }
      node->gap = gap;
      node->priority = weight;
      node->left = node->right = NULL;


    /* Now update the linked list */

    if(numjuxts==1)  /* It's the first, so a special case : */
      { s_juxts = node; 
        s_juxts->next = NULL;
        juxts = s_juxts;
      }
    else            /* Otherwise, just make the right links */
      { p_juxts = juxts;
        juxts = node;
        juxts->next = p_juxts;
      }

    /* Now add this juxt to the lists in the module structures involved */

     if (modp1->numjuxts==0)     /*  If the first one, then : */
       { 
         modp1->s_juxts = newlljuxtalloc();  /* Get space for it */
         modp1->s_juxts->j = node;
         modp1->s_juxts->next = NULL;
         modp1->juxts = modp1->s_juxts;
         modp1->numjuxts++;
       }
     else {
         modp1->p_juxts = modp1->juxts;
         modp1->juxts = newlljuxtalloc();
         modp1->juxts->j = node;
         modp1->juxts->next = modp1->p_juxts;
         modp1->numjuxts++;
       }

     if (modp2->numjuxts==0)     /*  If the first one, then : */
       {
         modp2->s_juxts = newlljuxtalloc();  /* Get space for it */
         modp2->s_juxts->j = node;
         modp2->s_juxts->next = NULL;
         modp2->juxts = modp2->s_juxts;
         modp2->numjuxts++;
       }
     else {
         modp2->p_juxts = modp2->juxts;
         modp2->juxts = newlljuxtalloc();
         modp2->juxts->j = node;
         modp2->juxts->next = modp2->p_juxts;
         modp2->numjuxts++;
       }
    }    
   else                    /* If this module is already in the tree */
         if ((direction = (index-node->index)) == 0)
           {  /* It's already there, so replace or augment it with the */
              /* new details */

           switch (rel) {
	   case BEFORE:  node->rel = 0; break;
	   case AFTER:   node->rel = 1; break;
	   case BETWEEN: node->rel = 2; break;
	   case SAME:    node->rel = 3; break;
	   case DAY:     node->rel = 4; break;
	   }
           switch (ex_m_l) {
           case EXACTLY: node->elm = 0; break;
           case LEAST:   node->elm = 1; break;
           case MOST:    node->elm = 2; break;
          }
           switch (days_mins) {
           case DAYS:    node->dsm = 0; break;
           case MINUTES: node->dsm = 1; break;
           }
           node->gap = gap;
           node->priority=weight;
	 }
                           /* Otherwise, continue looking */
   else  if (direction < 0)
        node->left = addnewjuxt(node->left,modp1,modp2,rel,ex_m_l,days_mins);
   else  if (direction > 0)
        node->right = addnewjuxt(node->right,modp1,modp2,rel,ex_m_l,days_mins);

   return(node);
}
     


void act_minimisestudconmods()
 { 
   minconmods=1;
 }


void act_modspecroom()
{
  char      *roomname;
  int       i, roomindex;
  _MODULE   *modp;

  roomname = inputnamelist[numnames-1]->n;
  roomindex = declarenewroom(roomname);

  for(i=0;i<numnames-1;i++) {

   t_modules = addnewmodule(t_modules,inputnamelist[i]->n);
    modp = f_module;
    modp->roomspec = roomindex;
  }
  resetinputlists();
}

void act_modexcroom()
{
  int       i, j, roomindex, priority, index, endlist1, startlist2;
  _MODULE   *modp;

  index=0;
  priority = inputnumlist[0];

 while (strcmp(inputnamelist[index]->n,"___")) index++;
   endlist1=index;
   startlist2=index+1;

  for(i=0;i<endlist1;i++) {  
   t_modules = addnewmodule(t_modules,inputnamelist[i]->n);
   modp = f_module;
     for(j=startlist2;j<numnames;j++) {
     roomindex = declarenewroom(inputnamelist[j]->n);

    if (modp->numexcroom==0)
                            /* If it's the first, then do this :  */
      {
          modp->s_exrooms = newllspecalloc();
          modp->s_exrooms->id = roomindex;
          modp->s_exrooms->forced = 1;
          modp->s_exrooms->priority = 10;
          modp->s_exrooms->next = NULL;
          modp->exrooms = modp->s_exrooms;
          modp->numexcroom++;
        }
      else                  /* If not, then this : */
        {
          modp->p_exrooms = modp->exrooms;
          modp->exrooms = newllspecalloc();
          modp->exrooms->id = roomindex;
          modp->exrooms->forced = 1;
          modp->exrooms->priority = 10;
          modp->exrooms->next = modp->p_exrooms;
          modp->numexcroom++;
        }
   }
  }
  resetinputlists();
}

void act_modallroom()
{

  int       i, j, r[MAXROOMS], priority, index, endlist1, startlist2;
  _MODULE   *modp;

  index=0;
  priority = inputnumlist[0];

 while (strcmp(inputnamelist[index]->n,"___")) index++;
   endlist1=index;
   startlist2=index+1;


  /* ASSUMING ALL ROOMS HAVE BEEN ENTERED, we will exclude all the rooms */
  /* NOT mentioned in endlist. So find these rooms */

  for(i=0;i<numroomsgiven;i++) r[i]=0;  /* Mark all rooms as excluded */

  for(j=startlist2;j<numnames;j++)
      r[declarenewroom(inputnamelist[j]->n)]=1; /* Unmark allowed rooms */

    for(i=0;i<endlist1;i++) {
   t_modules = addnewmodule(t_modules,inputnamelist[i]->n);
   modp = f_module;
   for(j=0;j<numroomsgiven;j++){
       if(r[j]==0) {
    if (modp->numexcroom==0)
	/* If it's the first, then do this :  */
	{
          modp->s_exrooms = newllspecalloc();
          modp->s_exrooms->id = j;
          modp->s_exrooms->forced = 1;
          modp->s_exrooms->priority = 10;
          modp->s_exrooms->next = NULL;
          modp->exrooms = modp->s_exrooms;
          modp->numexcroom++;
        }
    else                  /* If not, then this : */
        {
          modp->p_exrooms = modp->exrooms;
          modp->exrooms = newllspecalloc();
          modp->exrooms->id = j;
          modp->exrooms->forced = 1;
          modp->exrooms->priority = 10;
          modp->exrooms->next = modp->p_exrooms;
          modp->numexcroom++;
        }
       }
   }
  }
  resetinputlists();
}

void act_teachgivesmaxmods()
{
  char *agentname;
  int maxm, agentindex;

  agentname = inputnamelist[0]->n;
  maxm = inputnumlist[0];
  agentindex = declarenewagent(agentname);
  agents[agentindex]->maxmods = maxm;
  resetinputlists();
}
void act_teachgivesmaxhours()
{
  char *agentname;
  int maxh, agentindex;

  agentname = inputnamelist[0]->n;
  maxh = inputnumlist[0];
  agentindex = declarenewagent(agentname);
  agents[agentindex]->maxhours = maxh;
  resetinputlists();
}

void act_teachgivesminmods()
{
  char *agentname;
  int minm, agentindex;

  agentname = inputnamelist[0]->n;
  minm = inputnumlist[0];
  agentindex = declarenewagent(agentname);
  agents[agentindex]->minmods = minm;
  resetinputlists();
}

void act_teachgivesminhours()
{
  char *agentname;
  int minh, agentindex;

  agentname = inputnamelist[0]->n;
  minh = inputnumlist[0];
  agentindex = declarenewagent(agentname);
  agents[agentindex]->minhours = minh;
  resetinputlists();
}


void act_teachmustdomods()
{
  char     *teachname;
  int      i, teachindex;
  _MODULE  *modp;

   teachname = inputnamelist[0]->n;

   teachindex = declarenewagent(teachname);

   for(i=1;i<numnames;i++){
   t_modules = addnewmodule(t_modules,inputnamelist[i]->n);
   modp = f_module; 
     agents[teachindex]->mustdolist[agents[teachindex]->nummustdo++] = 
       modp->id;
   }
   resetinputlists();
}
void act_agentexcslots()
{
  char *agentname;
  int i, agentindex;
  
   agentname = inputnamelist[0]->n;
   agentindex = declarenewagent(agentname);
  
   for(i=0;i<numnums; i++) {
    agents[agentindex]->excslots[agents[agentindex]->numexcslots++]
    = inputnumlist[i];
  }
}



void act_agentavslots()
{
  char *agentname;
  int i, agentindex;

   agentname = inputnamelist[0]->n;
   agentindex = declarenewagent(agentname);

   for(i=0;i<numnums-1; i++) {
    agents[agentindex]->avslots[agents[agentindex]->numavslots] = 
       (struct option *)malloc(sizeof(struct option));
    agents[agentindex]->avslots[agents[agentindex]->numavslots]->mod =
    inputnumlist[i];
    agents[agentindex]->avslots[agents[agentindex]->numavslots++]->des =
    inputnumlist[numnums-1];
  }
}

void act_teachprefdomods()
{
   char     *teachname;
   int      i, teachindex, desire;
   _MODULE  *modp;
   int max_desire_sofar = 0;
   
   teachname = inputnamelist[0]->n;
   desire = inputnumlist[0];

   teachindex = declarenewagent(teachname);

   for(i=1;i<numnames;i++){
    t_modules = addnewmodule(t_modules,inputnamelist[i]->n);
    modp = f_module;
     agents[teachindex]->cando[agents[teachindex]->numcando] =
       (struct option *)malloc(sizeof(struct option));
     agents[teachindex]->cando[agents[teachindex]->numcando]->mod =
       modp->id;
     
     /**************************************************************/
     /* V1.6 - KEEP A RECORD OF THE MAXIMUM PREFERENCE OF AN AGENT */
     if (desire > agents[teachindex]->maxpref)
       agents[teachindex]->maxpref = desire;
     /**************************************************************/
     
     agents[teachindex]->cando[agents[teachindex]->numcando++]->des =
       desire;
   }
   resetinputlists();
 }
void act_teachcanmods()
{
   char     *agentname;
   int      i, agentindex, desire;
   _MODULE  *modp;

   agentname = inputnamelist[0]->n;
   desire = 0; 

   agentindex = declarenewagent(agentname);

   for(i=1;i<numnames;i++){
    t_modules =  addnewmodule(t_modules,inputnamelist[i]->n);
    modp = f_module;
     agents[agentindex]->cando[agents[agentindex]->numcando] =
       (struct option *)malloc(sizeof(struct option));
     agents[agentindex]->cando[agents[agentindex]->numcando]->mod =
       modp->id;  
     agents[agentindex]->cando[agents[agentindex]->numcando++]->des =
       desire;
   }
   resetinputlists();
 }


/************************************************************************/
/* This updates the screen and, if necessary, the output file           */
/************************************************************************/

void report(gen_total,fileoutput,pops,gen)
int gen_total, fileoutput,gen;
CHROMOSOME *pops;
{
  int pop, chromo, evs=0;
  double average, best, tmp;
  for(pop=0;pop<numpop;pop++) evs+=evals[pop];

  if(output) {
       fprintf(output, "\nGenerations=%d  Evaluations-so-far=%d\n",
                       gen_total,evs);

	 fprintf(output, "exlcuded: %d\n", pops[bestchrom].agentexcslots);
     }
   for(pop=0; pop<numpop; pop+=1) {
      average=0.0;
       for(chromo=0; chromo<numchromo; chromo+=1) {
          tmp = pops[pop*numchromo+chromo].fitness;
          average+=tmp;
        }
      average/=(double)numchromo;
      best = pops[bestchrom].fitness;

      if(output) {
          fprintf(output, "  %-4d    %12.7f     %12.7f\n",
                             pop,    average,   best);
        }
    }
    if(interactive==1) {
      makerunscreen(pops,evs,gen); 
      clrtoeol();
      refresh();}
}


/************************************************************************/
/* This frees whole population                                          */
/************************************************************************/

void free_pops(whole_pop,num)
CHROMOSOME *whole_pop;
int num;
{
  int i;
  for(i=0; i<num; i++) {
    freechromo(&whole_pop[i]);
  }
  free(whole_pop);
}



/************************************************************************/
/* Dumps chromosomes to a file. Filename is outfilename.gen, eg foo.500 */
/************************************************************************/

void dump_chromos(pops,g)
CHROMOSOME *pops;
int g;
{
  int i,j;

  if(!chromoutput) {
     sprintf(chromofilename,"%s.chr",outfilename);
     chromofile = fopen(chromofilename,"a");
     chromoutput = (chromofile != (FILE *)NULL);
   }

  if(chromoutput) {
    for(i=0;i<numpop;i++) {
      for(j=0;j<numchromo;j++) {
        fprintf(chromofile,
                "%-2d %-4d %-5d %12.7f  ",
                  i,   j,   g,    pops[i*numchromo+j].fitness);
        fprintf(chromofile,
                "   %5d %5d %5d\n",
                                 pops[i*numchromo+j].gdp->id,
                                 pops[i*numchromo+j].gdp->parent1,
                                 pops[i*numchromo+j].gdp->parent2);
      }
      fprintf(chromofile,"\n\n");
    }
  }
}


/************************************************************************/
/* This function inserts 'chromo' into the correct place (sorted by     */
/* fitness) within the subpopulation defined by 'base' and 'range' of   */
/* the populations array 'pops'.                                        */
/************************************************************************/

void insert(pops,chromo,base,range)
CHROMOSOME *pops,chromo;
int base,range;
{
  int current, pop;

  pop = base/numchromo;         /* which pop we're hitting */

                                /* Can it be inserted at all? */
  if (chromo.fitness>pops[base+range-1].fitness) {
    freechromo(&pops[base+range-1]);
    current=base+range-2;       /* Start at the second last place. */
    do {                        /* If 'chromo' is fitter ... */
      if (chromo.fitness>pops[current].fitness) {
        pops[current+1]=pops[current]; /* ... then push it down one. */
      }
      else {
        total_abs_fitness[pop] += fabs(chromo.fitness)
                                   - fabs(pops[current+1].fitness);
        pops[current+1]=chromo;        /* ... else insert 'chromo' below */
        current=base;                  /* and finish.                    */
      }
      current-=1;               /* Work up the array until ... */
    } while (current>=base);    /* we get past the 'base'.     */
    if (chromo.fitness>pops[base].fitness) {
      total_abs_fitness[pop] += fabs(chromo.fitness)
                                 - fabs(pops[base].fitness);
      pops[base]=chromo;        /* If chromo is the best put it in. */
    }
  }
   else {     /* It cannot be inserted, it is terrible */
        freechromo(&chromo);
    }
}

/************************************************************************/
/* Returns >0 if chromo2 is fitter than chromo1, <0 if chromo 1 is      */
/* fitter than chromo2, and 0 if they are equally fit. This is passed   */
/* to qsort as its comparison function.                                */
/************************************************************************/

int compchromo(chromo1,chromo2)
CHROMOSOME *chromo1,*chromo2;
{
  if((chromo2->fitness) > (chromo1->fitness))
     return(1);
  else if((chromo2->fitness) == (chromo1->fitness))
     return(0);
  else
     return(-1);
}

/***********************************************************************/
/* Returns a random double in range 0.0 to 1.0 (never 1.0 exactly)     */
/***********************************************************************/
double drandom()
{
  return((double)random()/2147483647.0);
}

EDGE     *addnewedge(node,mod1,mod2,ns)
EDGE     *node;
_MODULE  *mod1, *mod2;
int ns;
  {
    int direction ;
    long index;

    _MODULE *temp;

                            /* Put the modules in the rigt order */
    if(mod1->id>mod2->id) {temp = mod1; mod1 = mod2; mod2 = temp;}
                            /* work out the index. A hashing hack */
     index = (mod1->id)*10000+(mod2->id);

   if(node==NULL) {       /* This is new, so put it in the tree ... */

     node = newedgealloc();  /* Try to find memory for it */
     node->mod1 = mod1;
     node->mod2 = mod2;
     node->ns = ns; 
     node->id = numedges++;
     node->left = node->right = NULL;

     f_edges = node;                   /* Send up the new entry */
      /* Now consider the linked list of edges */
      /* See if this is the very first one  */

    if(numedges==1)  {  /* If so, special case ... */
       s_edges = node;
       s_edges->next = NULL;
       edges = s_edges;
     }
     else {                  /* If not, just make the right links */
       p_edges = edges;
       edges = node;
       edges->next = p_edges;
     }

     /* Now, make this edge known to the modules involved */
     
     if(mod1->numedges==0) {     /* Mod1's first so :    */
       mod1->s_edges = newlledgealloc();
        mod1->s_edges->e = node;
        mod1->s_edges->next = NULL;
        mod1->edges = mod1->s_edges;
        mod1->numedges++;
     }
     else {                  /* If not first, just make the right links  */
       mod1->p_edges = mod1->edges;
        mod1->edges = newlledgealloc();
        mod1->edges->e = node;
        mod1->edges->next = mod1->p_edges;
        mod1->numedges++;
      }
                                      /* Do the same for mod2 as well */

     if(mod2->numedges==0)      /* Mod1's first so :    */
      {
        mod2->s_edges = newlledgealloc();
        mod2->s_edges->e = node;
        mod2->s_edges->next = NULL;
        mod2->edges = mod2->s_edges;
        mod2->numedges++;
      }
     else                  /* If not first, just make the right links  */
       {
        mod2->p_edges = mod2->edges;
        mod2->edges = newlledgealloc();
        mod2->edges->e = node;
        mod2->edges->next = mod2->p_edges;
        mod2->numedges++;
      }
   }
   else 
     /* Not found this node yet */ 
     if ((direction =(index-(10000*(node->mod1->id)+node->mod2->id))) == 0)
       /* This is already in the tree, so just increment the number */
       /* of sharers of this edge, and return it */
       {node->ns+=ns; f_edges = node; }
    /* Otherwise, continue looking */
     else  if (direction < 0)
       node->left = addnewedge(node->left,mod1,mod2,ns);
     else  if (direction > 0)
       node->right = addnewedge(node->right,mod1,mod2,ns);
    
    return(node);
  }



_MODULE *newmodalloc()
{
 _MODULE *temp;

 if ((temp=(_MODULE *)malloc(sizeof(_MODULE)))!=NULL)
   return temp;
 else {
   printf("Trouble: Couldn't find enough space for storing modules\n");
   exit(0);
 }
}

JUXT *newjuxtalloc()
{
 JUXT *temp;

 if ((temp=(JUXT *)malloc(sizeof(JUXT)))!=NULL)
    return temp;
 else {
   printf("Trouble: Couldn't find space for a juxtaposition constrant\n");
   exit(0);
 }
}


_STUDENT *newstudentalloc()
{
 _STUDENT *temp;
 
 if ((temp=(_STUDENT *)malloc(sizeof(_STUDENT)))!=NULL)
    return temp;
 else {
   printf("Trouble: Couldn't find enough space for storing students\n");
   exit(0);
 }
}

EDGE *newedgealloc()
{
 EDGE *temp;
  
 if ((temp=(EDGE *)malloc(sizeof(EDGE)))!=NULL)
    return temp;
 else {
   printf("Trouble: Couldn't find enough space for storing edges\n");
   exit(0);
 }
}

LL_MODS *newllmodalloc()
{
 LL_MODS *temp;

 if ((temp=(LL_MODS *)malloc(sizeof(LL_MODS)))!=NULL)
    return temp;
 else {
   printf("Trouble: Couldn't find enough space for a new pointer!\n");
   exit(0);
 }
}

LL_SPEC *newllspecalloc()
{
 LL_SPEC *temp;

 if ((temp=(LL_SPEC *)malloc(sizeof(LL_SPEC)))!=NULL)
    return temp;
 else {
   printf("Trouble: Couldn't find enough space for a new pointer!\n");
   exit(0);
 }
}

LL_STUDS *newllstudalloc()
{
 LL_STUDS *temp;

 if ((temp=(LL_STUDS *)malloc(sizeof(LL_STUDS)))!=NULL)
    return temp;
 else {
   printf("Trouble: Couldn't find enough space for a new pointer!\n");
   exit(0);
 }
}

LL_JUXTS *newlljuxtalloc()
{
 LL_JUXTS *temp;

 if ((temp=(LL_JUXTS *)malloc(sizeof(LL_JUXTS)))!=NULL)
    return temp;
 else {
   printf("Trouble: Couldn't find enough space for a new pointer!\n");
   exit(0);
 }
}

LL_EDGES *newlledgealloc()
{
 LL_EDGES *temp;

 if ((temp=(LL_EDGES *)malloc(sizeof(LL_EDGES)))!=NULL)
    return temp;
 else {
   printf("Trouble: Couldn't find enough space for a new pointer!\n");
   exit(0);
 }
}


char *namealloc(name)
char *name;
{
 char *temp;

 if ((temp=(char *)malloc(strlen(name)+1))!=NULL)
    return temp;
 else {
   printf("Trouble: Couldn't find enough space for a name\n");
   exit(0);
 }
}

void getbestchromo(pops)
CHROMOSOME *pops;
{
   int pop;
   double tmp;
      bestchrom = 0;
       for(pop=1; pop<numpop*numchromo;pop++) {
	 tmp = pops[pop].fitness;
	 if(pops[bestchrom].fitness < tmp)
           bestchrom = pop;
       }
 }

/* void update_bests(CHROMOSOME *pops,
                  int newbest,
                  int place,
                  int oldwasbest)
{
    int index;

    if(newbest){
      nbests=1;
      bests[0]=place;
    }
    else 
      if((oldwasbest==1) && (pops[place].fitness<best_fitness)) {
	index=0;
	while( equal_timetables(pops[bests[index]].gdp->genotype,
				pops[place].gdp->genotype)==0)
	  index++;
	bests[index] = bests[--nbests];
      }
      else 
	if((oldwasbest==1) && (pops[place].fitness==best_fitness)) {
          distinct=0;
	  for(index=0;index<numpop*numchromo;index++)
            
	    
int find_num_distinct_bests(pops)
CHROMOSOME *pops;
{
     int pop, b, same;

     nbests=0;

     getbestchromo(pops);
     best_fitness = pops[bestchrom].fitness;

     for(pop=0; pop<numpop*numchromo;pop++)
       if (pops[pop].fitness == best_fitness)
	   {
           same=0;
           for(b=0;b<nbests;b++)
	       {
              if(equal_timetables(pops[bests[b]].gdp->genotype,
                                  pops[pop].gdp->genotype)==1)
		  {same=1; break;}
	       }
           if(same==0)
*/

int find_num_distinct_bests(pops)
CHROMOSOME *pops;
{
     int pop, b, same;

     nbests=0;

     getbestchromo(pops);
     best_fitness = pops[bestchrom].fitness;

     for(pop=0; pop<numpop*numchromo;pop++) 
       if (pops[pop].fitness == best_fitness)
         {
           same=0;
           for(b=0;b<nbests;b++)
             {
              if(equal_timetables(pops[bests[b]].gdp->genotype,
                                  pops[pop].gdp->genotype)==1)
               {same=1; break;}
             }
           if(same==0)
           bests[nbests++]=pop;
         }
    return(nbests);
}

double avhddb(pops)
CHROMOSOME *pops;
{
     int pop, b, same,i,j,k,n;
     double d,h;
     nbests=0;

     getbestchromo(pops);
     best_fitness = pops[bestchrom].fitness;

     for(pop=0; pop<numpop*numchromo;pop++) 
       if (pops[pop].fitness == best_fitness)
         {
           same=0;
           for(b=0;b<nbests;b++)
             {
              if(equal_timetables(pops[bests[b]].gdp->genotype,
                                  pops[pop].gdp->genotype)==1)
               {same=1; break;}
             }
           if(same==0)
           bests[nbests++]=pop;
         }
      d=0.0;n=0;
      for(i=0;i<(nbests-1);i++)
	  for(j=(i+1);j<nbests;j++)
	      {h=0;
               for(k=0;k<nummods;k++)
                  if(pops[bests[i]].gdp->genotype[k]!=
                     pops[bests[j]].gdp->genotype[k]) h++;
               d+=h;         
               n++;
              }
 return(d/n);
}

int equal_timetables(char *tt1, char *tt2)
{
  int l,d;
  d=0;
  for(l=0;l<geno_size;l++)
    if (tt1[l]!=tt2[l]) {d=1; break;}

  if(d==1) return(0); else return(1);
}

void act_slotseatexception()
{
  int i,cap;

  cap = inputnumlist[numnums-1];

  for(i=0;i<numnums-1;i++)
  slots[inputnumlist[i]]->sscap = cap;
}

void act_sloteventexception()
{
  int i,cap;

  cap = inputnumlist[numnums-1];

  for(i=0;i<numnums-1;i++)
    slots[inputnumlist[i]]->secap = cap;
}
  
void act_allmodexcslot()
{
 int i;

  for(i=0;i<numnums;i++)
    allmodsexclude[allmodsexcludenum++]=inputnumlist[i];
}

void adjust_temperature()
{
  static int iterations_so_far=0, changes_so_far=0;
  iterations_so_far++;

  if (changes_so_far ==0)
     temperature = initial_temperature;
  if (iterations_so_far>=iterations)
      {iterations_so_far=0;
       changes_so_far++;
       temperature*=cooling_rate;
     }
  if(temperature<=final_temperature)
     temperature=final_temperature;

}


void dcheck(pops)
CHROMOSOME *pops;
{
  int i,j,k,d,n,h;

  if(simulated_annealing==1) bestpen = (int) (1.0/sabestfit - 1);

  if(bestpen<vbestfitness) {
    vbestfitness=bestpen ;
    dchnum=0;
    if(simulated_annealing==1)
      for(i=0;i<nummods;i++)
	dch[dchnum][i]=sabest[i];
    else
      for(i=0;i<nummods;i++)
	dch[dchnum][i]=pops[0].gdp->genotype[i];
    dchnum++;
  }
  else if(bestpen==vbestfitness){
    if(simulated_annealing==1)
      for(i=0;i<nummods;i++)
	dch[dchnum][i]=sabest[i];
    else 
      for(i=0;i<nummods;i++) 
        dch[dchnum][i]=pops[0].gdp->genotype[i];
    dchnum++;
  }
  
 d=0;
 if (restart==restarts){
   if(dchnum==1) avhd=0.0; else {
     n=0;
     for(i=0;i<(dchnum-1);i++)
       for(j=i+1;j<dchnum;j++)
	 {h=0;n++;
	  for(k=0;k<nummods;k++)
	    if (dch[i][k]!=dch[j][k]) h++;
	  d+=h;
	}
     avhd=d/n;
   } 
 }
  
}

































yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 258
# define YYLAST 942
yytabelem yyact[]={

   151,   568,   162,   512,    31,   110,   371,   480,   278,   279,
   266,   310,   146,    32,   567,   148,   564,   268,   269,   451,
   111,   112,   143,   144,   125,   126,   179,   181,   113,   114,
   251,   154,   155,   530,   125,   126,   436,   157,   334,   150,
   152,   333,   331,   251,   326,   325,   251,   176,   178,   293,
   324,   164,   323,   321,   317,   182,   316,   123,   124,   550,
   551,    35,   163,   131,   132,   133,   134,   135,   136,   263,
   513,   484,   131,   132,   133,   134,   135,   136,   161,   270,
   305,   131,   132,   133,   134,   135,   136,   588,   495,   251,
   532,   166,   113,   114,   513,   292,   592,   115,   116,   117,
   118,   304,   254,   303,   291,   131,   132,   133,   134,   135,
   136,   183,   170,   485,   423,   131,   132,   133,   134,   135,
   136,   280,   277,   137,   139,   276,   302,   295,   255,   253,
   140,   249,   137,   139,   234,   233,   422,   232,   174,   140,
   231,   137,   139,   230,   229,   228,   267,   227,   140,   149,
   242,   243,   226,   113,   114,   169,   168,   446,   225,   246,
   283,   115,   116,   117,   118,   137,   139,   252,   297,   298,
   147,   281,   140,   149,   284,   137,   139,   294,   421,   289,
   252,   224,   140,   252,   223,   222,   180,   119,   120,   121,
   122,   156,   240,   221,   142,   141,   138,   113,   114,   153,
   220,   296,   295,   142,   141,   138,   447,   244,   514,   219,
   218,   217,   142,   141,   138,   216,   215,   113,   114,   214,
   213,   212,   115,   116,   117,   118,   252,   113,   114,   211,
   448,   210,   514,   125,   126,   534,   142,   141,   138,   449,
   167,   209,   208,   297,   298,   207,   142,   141,   138,   206,
   205,   119,   120,   121,   122,   204,   372,   203,   202,   201,
   200,   199,   374,   376,   377,   198,   115,   116,   117,   118,
   286,   162,   285,   290,   197,   196,   296,   195,   387,   194,
   193,   192,   392,   393,   191,   394,   115,   116,   117,   118,
   399,   493,   401,   398,   190,    48,   115,   116,   117,   118,
   363,   397,   189,   188,   411,   406,   408,   187,   186,   185,
   414,   415,   119,   120,   121,   122,   410,   143,   144,   184,
   301,   413,   402,   412,   417,   400,   295,   389,   391,   490,
   489,   163,   160,   427,   570,   428,   263,   175,   364,   239,
   123,   124,   560,   365,   482,   529,   425,   424,   429,   405,
   407,   263,   431,   263,   546,   263,   119,   120,   121,   122,
   263,   545,   263,   380,   381,   263,   263,   297,   298,   263,
   263,   544,   543,   113,   114,   263,   119,   120,   121,   122,
   385,   263,   630,   569,   432,   441,   119,   120,   121,   122,
   435,   388,   437,   367,   481,   455,   497,   629,   462,   628,
   296,   627,   263,   454,   263,   496,   616,   466,   615,   458,
   460,   614,   613,   508,   463,   612,   611,   467,   468,   263,
   507,   594,   477,   434,   386,   263,   241,   593,   390,   440,
   475,   476,   488,   261,   275,   450,   111,   112,   263,   585,
   263,   247,   115,   116,   117,   118,   537,   494,   499,   501,
   579,   453,   383,   172,   173,   266,   536,   287,   263,   260,
   539,   263,   263,   503,   472,   464,   506,   368,   517,   518,
   510,   509,   471,   123,   124,   584,   487,   583,   264,   516,
   527,   265,    33,   519,   520,   521,   522,   523,   525,   531,
   123,   124,   498,   500,   362,   582,   470,   533,   554,   553,
   535,   125,   126,   469,   416,   538,   404,   502,   403,   419,
   541,   542,   547,   548,   505,   113,   114,   552,   511,   369,
   555,   556,   557,   558,   526,   143,   144,   586,   268,   269,
   143,   144,   119,   120,   121,   122,   248,   125,   126,   309,
   236,   590,   571,   572,   111,   112,   308,   235,   563,   589,
   565,   566,   143,   144,   465,   634,   430,   573,   574,   575,
   576,   113,   114,   577,   578,   633,   587,   580,   581,   263,
   457,   591,   632,   631,   595,   596,   597,   598,   626,   625,
   624,   600,   601,   623,   115,   116,   117,   118,   622,   621,
   270,   267,   271,   272,   610,   609,   602,   603,   604,   605,
   608,   273,   274,   617,   618,   619,   620,   109,   607,    36,
    49,   111,   112,   143,   144,   113,   114,    40,   606,   113,
   114,    37,   599,   570,   562,   125,   126,   559,   245,   549,
   115,   116,   117,   118,   540,   482,   528,   515,   504,   492,
   491,   486,   474,    39,   473,   456,   452,   443,   123,   124,
   442,   129,   438,   433,    34,   426,   418,   396,   130,   395,
   384,   379,   373,   370,   361,   360,   524,   359,   358,   357,
   356,   355,   354,   353,   119,   120,   121,   122,   352,   444,
   351,   350,   349,   348,   115,   116,   117,   118,   115,   116,
   117,   118,   128,   113,   114,   347,   346,   345,   344,   343,
   127,   342,   341,   340,   339,   338,   131,   132,   133,   134,
   135,   136,   461,   337,   336,   335,   332,   330,   329,   327,
   119,   120,   121,   122,   315,   314,   313,   312,   311,   300,
   299,    62,   237,   171,   145,   177,   561,   479,   478,   263,
   375,   439,   378,   328,   322,   382,    65,   320,    57,    58,
    67,    76,    60,    61,    64,   319,    63,   318,   158,   258,
   257,   159,   115,   116,   117,   118,   137,   139,    43,    42,
   366,   262,    47,   140,   119,   120,   121,   122,   119,   120,
   121,   122,    41,    46,   409,   483,   420,    81,    82,    85,
    86,    88,   104,    89,    92,    93,    94,    95,    96,    97,
    98,    99,   100,   101,   102,   103,    83,    50,    51,    52,
    53,    54,    55,    56,    59,    66,    70,    73,   238,    45,
    91,    90,    69,    68,    71,    74,    77,    79,    80,    78,
    84,    87,    75,    72,    44,   106,   105,   142,   141,   138,
   107,   108,   165,    38,   459,   259,   445,   256,   250,   307,
    30,    29,   119,   120,   121,   122,    28,    27,    26,    25,
    24,    23,    22,    21,    20,    19,    18,    17,    16,    15,
    14,    13,    12,    11,    10,     9,     8,     7,     6,     5,
     4,     3,     2,     1,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   282,     0,     0,     0,     0,   288,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   306 };
yytabelem yypact[]={

   350,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,   474,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,  -248,  -219,  -227,  -341,   499,  -275,   346,  -175,   473,
   159,  -293,-10000000,-10000000,-10000000,-10000000,   476,   476,  -232,   262,
   -24,   -34,   -35,   -36,   -40,-10000000,-10000000,   -41,-10000000,   -49,
   -59,   -62,   -63,-10000000,   -64,   -66,   -68,   -69,   -78,   -82,
-10000000,-10000000,   -83,   -84,   -85,-10000000,   -86,   -88,   -93,   -94,
   -98,-10000000,  -101,  -102,  -112,  -114,  -122,  -123,  -124,  -127,
  -128,  -132,  -133,  -134,  -143,  -150,  -158,  -159,  -162,  -185,
  -191,  -196,  -198,  -199,  -200,  -203,  -206,  -208,  -209,   282,
   472,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,    37,
  -251,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,  -241,   271,  -212,  -171,-10000000,
  -215,   166,   161,  -218,  -221,  -425,  -222,   346,    -6,   476,
   -52,  -284,-10000000,-10000000,  -279,   346,   -56,  -239,-10000000,-10000000,
  -234,    54,   470,   469,    -7,  -201,   480,-10000000,   480,  -240,
  -242,  -345,   281,  -394,   468,   467,   466,   465,   464,  -320,
  -322,   498,   496,   488,  -323,   485,  -324,  -326,  -331,  -332,
   459,   484,   458,   457,  -334,   456,  -335,  -338,   455,   454,
   453,   445,   444,   443,   442,   441,   439,   438,   437,   436,
   435,   423,   422,   421,   420,   418,   413,   412,   411,   410,
   409,   408,   407,   405,   404,-10000000,-10000000,   229,   226,    35,
    76,   200,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,   253,   403,
  -463,-10000000,-10000000,-10000000,-10000000,   476,   402,   175,   283,   175,
   401,    69,   192,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,   400,   120,   476,    67,   141,
     4,   476,   476,   480,   476,   399,   397,   346,   283,   476,
     0,   476,    -3,   240,   238,-10000000,-10000000,-10000000,-10000000,    54,
    54,    42,   346,   476,    -1,   283,   283,   236,-10000000,-10000000,
   346,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,   396,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,   243,  -170,-10000000,    52,   395,    15,    53,   293,
  -116,   393,   480,   -70,  -224,-10000000,  -224,   392,   482,    54,
   390,   387,-10000000,  -284,  -117,  -145,  -359,   480,   386,   -42,
   283,   385,   310,   480,   480,   424,   292,   476,  -224,   160,
   291,   480,   283,   346,   346,   235,   228,   204,   196,-10000000,
-10000000,   480,   384,   382,  -224,  -224,   289,   479,   478,    84,
  -236,-10000000,-10000000,-10000000,   381,-10000000,    54,    11,    10,   380,
   379,-10000000,-10000000,  -177,-10000000,  -230,-10000000,  -217,-10000000,-10000000,
   114,   105,    54,    54,-10000000,   226,-10000000,-10000000,-10000000,   346,
-10000000,   378,   -42,   133,   126,  -224,   -42,-10000000,-10000000,-10000000,
-10000000,-10000000,  -190,  -230,   377,   346,-10000000,   476,   476,   346,
   346,   346,   346,   246,   104,  -230,  -214,   376,    49,  -343,
-10000000,   375,  -254,   346,-10000000,-10000000,   -72,   188,   178,-10000000,
-10000000,   346,   193,-10000000,-10000000,   374,   346,   346,    81,    80,
    70,    63,-10000000,-10000000,-10000000,-10000000,-10000000,   283,   283,  -230,
-10000000,-10000000,   369,  -295,-10000000,-10000000,   476,   203,   202,   476,
   476,   476,   476,-10000000,-10000000,-10000000,-10000000,   367,    46,   477,
-10000000,-10000000,   364,-10000000,   346,  -368,   346,   346,  -370,    74,
-10000000,   476,   476,   346,   346,   346,   346,  -224,  -224,-10000000,
-10000000,-10000000,   145,   346,   346,   199,   181,   179,   143,-10000000,
   267,-10000000,  -257,-10000000,   286,-10000000,-10000000,   278,-10000000,   363,
  -247,   122,   116,   476,   476,   476,   476,  -230,  -230,   362,
   476,   476,   346,   346,   346,   346,-10000000,   358,   348,-10000000,
-10000000,-10000000,   340,   335,   334,   111,   110,   107,   106,-10000000,
   103,   101,   476,   476,   476,   476,-10000000,-10000000,-10000000,-10000000,
-10000000,   329,   328,   323,   320,   319,   318,    96,    94,    92,
    77,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,   313,   312,   305,
   295,-10000000,-10000000,-10000000,-10000000 };
yytabelem yypgo[]={

     0,   883,   882,   881,   880,   879,   878,   877,   876,   875,
   874,   873,   872,   871,   870,   869,   868,   867,   866,   865,
   864,   863,   862,   861,   860,     4,     5,    61,   482,    13,
   295,   859,   858,   857,   856,   851,   850,     1,   849,     7,
    15,   848,     0,   847,    49,   846,   761,   760,   759,   845,
   843,   842,   834,   819,   818,   786,   785,   783,   772,   771,
   770,     3,   769,   768 };
yytabelem yyr1[]={

     0,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,    20,    19,    21,    21,    21,    21,    21,
    21,    21,    21,    21,    21,    21,    21,    21,    21,    21,
    21,    21,    21,    21,    21,    21,    21,    21,    21,    21,
    21,    21,     2,     2,     2,     2,     2,     2,     3,     3,
     3,     3,     3,     3,    31,    31,    34,    34,    35,    35,
     4,     4,    22,    23,    32,    33,    36,     6,     7,     8,
     9,     9,    10,    10,    10,    10,    11,    11,    11,    11,
    11,    11,    11,    11,    11,    11,    11,    11,    11,    11,
    14,    14,    52,    52,    17,    41,    41,    48,    48,    48,
    54,    54,    15,    15,    15,    57,    58,    55,    55,    55,
    56,    56,    53,    53,    53,    53,    60,    60,    60,    50,
    50,    16,    16,    16,    16,    16,    16,    16,    16,    16,
    16,    16,    16,    16,    16,    16,    16,    16,    12,    12,
    13,    13,    43,    43,    62,    62,    63,    63,    63,    51,
    51,    51,    47,    47,    61,    61,    61,    46,    46,    42,
    42,    40,    40,    40,    40,    59,    59,     5,     5,     5,
    24,    24,    25,    25,    26,    26,    27,    27,    28,    28,
    49,    49,    29,    29,    29,    29,    29,    29,    29,    29,
    29,    29,    30,    30,    30,    30,    30,    30,    30,    30,
    30,    30,    30,    30,    37,    39,    38,    38,    44,    44,
    44,    44,    45,    45,    45,    18,    18,    18,    18,    18,
    18,    18,    18,    18,    18,    18,    18,    18,    18,    18,
    18,    18,    18,    18,    18,    18,    18,    18,    18,    18,
    18,    18,    18,    18,    18,    18,    18,    18 };
yytabelem yyr2[]={

     0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     3,     1,     7,     7,     7,     7,     7,
     7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
     7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
     7,     7,     7,     7,     7,     7,     7,     7,     3,     3,
     3,     3,     3,     3,    16,    18,    16,    18,    10,    12,
    11,    11,    13,    13,     8,     8,     8,    11,    13,    11,
     9,     7,    11,    11,    15,    11,    21,    21,    23,    23,
    23,    23,    13,    19,    23,    23,    25,    25,    25,    25,
     2,     2,    13,    15,     9,     2,     2,     2,     2,     2,
     4,     2,    11,     5,     5,     9,     9,     2,     2,     2,
     2,     2,    15,    15,    17,    17,     4,     6,     6,     2,
     2,     9,    11,    15,    11,    11,    11,    11,    13,    13,
    13,    13,    13,    13,    15,    11,    11,    15,     9,     9,
     2,     2,     2,     2,    13,    13,    17,    17,    13,     2,
     2,     8,     2,     2,     4,     4,     2,     2,     2,     2,
     4,     2,     2,     4,     4,     2,     2,    11,    13,    13,
     4,     4,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     6,    10,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     7,     7,     7,     7,     7,
     3,     3,     7,     3,     7,     7,     9,    13,     7,     7,
     3,     7,     7,     7,     7,     7,     7,     3,     3,     7,
     7,     7,     3,     7,     7,     7,     7,     7 };
yytabelem yychk[]={

-10000000,    -1,    -2,    -3,    -4,    -5,    -6,    -7,    -8,    -9,
   -10,   -11,   -12,   -13,   -14,   -15,   -16,   -17,   -18,   -19,
   -20,   -21,   -22,   -23,   -24,   -31,   -32,   -33,   -34,   -35,
   -36,   -25,   -29,   -28,   304,   -27,   259,   271,   -50,   293,
   267,   432,   -62,   -63,   -52,   -53,   -57,   -58,   -30,   260,
   457,   458,   459,   460,   461,   462,   463,   398,   399,   464,
   402,   403,   381,   406,   404,   396,   465,   400,   473,   472,
   466,   474,   483,   467,   475,   482,   401,   476,   479,   477,
   478,   437,   438,   456,   480,   439,   440,   481,   441,   443,
   471,   470,   444,   445,   446,   447,   448,   449,   450,   451,
   452,   453,   454,   455,   442,   486,   485,   490,   491,   257,
   -26,   261,   262,   269,   270,   338,   339,   340,   341,   428,
   429,   430,   431,   298,   299,   275,   276,   350,   342,   301,
   308,   356,   357,   358,   359,   360,   361,   416,   489,   417,
   423,   488,   487,   263,   264,   260,   260,   418,   -40,   397,
   258,   -42,   259,   418,   258,   259,   418,   378,   259,   -46,
   -30,   353,   277,   337,   -29,   -51,   266,   415,   331,   330,
   287,   260,   294,   295,   431,   -30,   -42,   259,   -42,   258,
   418,   259,   -26,   -27,   343,   343,   343,   343,   343,   343,
   343,   343,   343,   343,   343,   343,   343,   343,   343,   343,
   343,   343,   343,   343,   343,   343,   343,   343,   343,   343,
   343,   343,   343,   343,   343,   343,   343,   343,   343,   343,
   343,   343,   343,   343,   343,   343,   343,   343,   343,   343,
   343,   343,   343,   343,   343,   265,   258,   260,   -54,   302,
   -27,   -30,   -25,   -26,   -27,   -28,   -29,   -30,   265,   343,
   -41,   260,   397,   300,   273,   343,   -43,   -47,   -48,   -49,
   293,   267,   -59,   259,   312,   315,   289,   425,   362,   363,
   424,   426,   427,   435,   436,   273,   343,   343,   433,   434,
   343,   -29,   -46,   -42,   -29,   324,   322,   -30,   -47,   -29,
   329,   343,   329,   -44,   -26,   272,   346,   313,   314,   260,
   260,   327,   327,   343,   343,   425,   -48,   -38,   265,   258,
   405,   260,   260,   260,   260,   260,   376,   376,   259,   259,
   259,   376,   259,   376,   376,   376,   376,   260,   259,   260,
   260,   376,   260,   376,   376,   260,   260,   260,   260,   260,
   260,   260,   260,   260,   260,   260,   260,   260,   260,   260,
   260,   260,   260,   260,   260,   260,   260,   260,   260,   260,
   260,   260,   265,   -27,   303,   267,   -60,   317,   267,   266,
   260,   469,   -42,   260,   -25,   -28,   -25,   -25,   -28,   260,
   294,   295,   -28,   260,   260,   260,   304,   -42,   324,   260,
   287,   324,   -42,   -42,   -42,   260,   260,   -29,   -25,   -42,
   325,   -42,   325,   268,   268,   -44,   -26,   -44,   -26,   -28,
   -29,   -42,   324,   322,   -25,   -25,   268,   -29,   260,   266,
   -55,   348,   306,   284,   295,   294,   260,   318,   320,   295,
   263,   468,   -29,   260,   -44,   -40,   260,   -40,   260,   259,
   -44,   -26,   260,   260,   -30,   -45,   274,   323,   347,   384,
   -44,   378,   260,   -27,   -29,   -25,   260,   260,   -29,   420,
   -29,   420,   -42,   -40,   305,   263,   -25,   -29,   -29,   268,
   268,   268,   268,   260,   260,   -40,   -40,   -26,   259,   259,
   -39,   310,   260,   -56,   307,   349,   260,   -44,   -26,   319,
   319,   260,   260,   468,   -29,   305,   291,   291,   -44,   -26,
   -44,   -26,   -27,   -29,   260,   -27,   -29,   287,   287,   -40,
   -29,   -27,   -61,   284,   422,   260,   -29,   -42,   -42,   -29,
   -29,   -29,   -29,   -29,   420,   -29,   420,   -61,   260,   296,
   376,   -39,   344,   -29,   307,   -29,   268,   268,   -29,   267,
   260,   -29,   -29,   291,   291,   291,   291,   -25,   -25,   260,
   354,   355,   -42,   296,   296,   -42,   -42,   -42,   -42,   260,
   296,   259,   260,   -29,   384,   -29,   -29,   384,   -37,   309,
   260,   -42,   -42,   -29,   -29,   -29,   -29,   -40,   -40,   305,
   -29,   -29,   296,   296,   296,   296,   260,   -26,   344,   263,
   263,   -37,   343,   305,   305,   -42,   -42,   -42,   -42,   260,
   -42,   -42,   -29,   -29,   -29,   -29,   260,   260,   260,   260,
   260,   305,   305,   305,   305,   305,   305,   -42,   -42,   -42,
   -42,   260,   260,   260,   260,   260,   260,   305,   305,   305,
   305,   260,   260,   260,   260 };
yytabelem yydef[]={

    24,    -2,     1,     2,     3,     4,     5,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,     0,    58,    59,    60,    61,    62,
    63,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   150,   151,   100,   101,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   230,   231,     0,   233,     0,
     0,     0,     0,   240,     0,     0,     0,     0,     0,     0,
   247,   248,     0,     0,     0,   252,     0,     0,     0,     0,
     0,    23,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   182,   183,   192,   193,   194,   195,   196,   197,   198,
   199,   200,   201,   188,   189,   186,   187,   129,   130,     0,
     0,   202,   203,   204,   205,   206,   207,   208,   209,   210,
   211,   212,   213,   184,   185,     0,   171,     0,     0,   172,
     0,     0,   169,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   167,   168,     0,     0,     0,     0,   159,   160,
     0,     0,     0,     0,     0,     0,   113,   169,   114,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   180,   181,     0,     0,   111,
     0,     0,    52,    53,    54,    55,    56,    57,     0,     0,
     0,   173,   174,   105,   106,     0,     0,     0,     0,     0,
     0,     0,     0,   170,   152,   153,   162,   163,   107,   108,
   109,   190,   191,   175,   176,     0,     0,     0,     0,     0,
     0,     0,     0,    81,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   218,   219,   220,   221,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   216,   217,
     0,   225,   226,   227,   228,   229,   232,   234,   235,   238,
   239,   241,   242,   243,   244,   245,   246,   249,   250,   251,
   253,   254,   255,   256,   257,    25,    26,    27,    28,    29,
    30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
    40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
    50,    51,     0,     0,   110,     0,     0,     0,     0,     0,
     0,     0,    75,     0,     0,   115,     0,     0,     0,     0,
     0,     0,   116,     0,     0,     0,     0,    74,     0,     0,
     0,     0,     0,    80,   131,     0,     0,     0,     0,     0,
     0,   104,     0,     0,     0,     0,     0,     0,     0,   148,
   149,    76,     0,     0,     0,     0,     0,     0,   236,     0,
     0,   117,   118,   119,     0,   126,     0,     0,     0,     0,
     0,    70,    71,     0,    77,    83,   171,     0,    85,   112,
     0,     0,     0,     0,   145,     0,   222,   223,   224,     0,
   177,     0,     0,     0,     0,     0,     0,    79,   134,   135,
   136,   137,   132,    82,     0,     0,   161,     0,     0,     0,
     0,     0,     0,     0,     0,   146,     0,     0,     0,     0,
    68,     0,     0,     0,   120,   121,     0,     0,     0,   127,
   128,     0,     0,    72,    73,     0,     0,     0,     0,     0,
     0,     0,    78,   142,   143,   154,   155,     0,     0,   158,
   178,   179,     0,     0,   166,    92,     0,     0,     0,     0,
     0,     0,     0,   138,   139,   140,   141,     0,     0,     0,
   237,    69,     0,   102,     0,     0,     0,     0,     0,     0,
    84,     0,     0,     0,     0,     0,     0,     0,     0,   133,
   164,   165,     0,     0,     0,     0,     0,     0,     0,   147,
     0,   144,     0,   103,     0,   122,   123,     0,    64,     0,
     0,     0,     0,     0,     0,     0,     0,   156,   157,     0,
     0,     0,     0,     0,     0,     0,    66,     0,     0,   125,
   124,    65,     0,     0,     0,     0,     0,     0,     0,    93,
     0,     0,     0,     0,     0,     0,    67,   215,   214,    86,
    87,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    88,    89,    90,    91,    94,    95,     0,     0,     0,
     0,    96,    97,    98,    99 };
typedef struct
#ifdef __cplusplus
	yytoktype
#endif
{ char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"THERE",	257,
	"ARE",	258,
	"NAME",	259,
	"NUMBER",	260,
	"SLOT",	261,
	"SLOTS",	262,
	"DAY",	263,
	"DAYS",	264,
	"IS",	265,
	"ON",	266,
	"AT",	267,
	"BETWEEN",	268,
	"MODULE",	269,
	"MODULES",	270,
	"ALL",	271,
	"MINUTES",	272,
	"HAS",	273,
	"EXTRA",	274,
	"STUDENT",	275,
	"STUDENTS",	276,
	"TAKES",	277,
	"FORCE",	278,
	"FORCIBLY",	279,
	"F",	280,
	"PREFER",	281,
	"PREFERABLY",	282,
	"P",	283,
	"WITH",	284,
	"STRENGTH",	285,
	"PRIORITY",	286,
	"IN_",	287,
	"INTO",	288,
	"EXCLUDE",	289,
	"FROM",	290,
	"BEFORE",	291,
	"AFTER",	292,
	"EXACTLY",	293,
	"LEAST",	294,
	"MOST",	295,
	"AND",	296,
	"PAIR",	297,
	"ROOM",	298,
	"ROOMS",	299,
	"HAVE",	300,
	"MINIMISE",	301,
	"NUMBER_W",	302,
	"OF",	303,
	"EXPECTED",	304,
	"WEIGHT",	305,
	"TAKING",	306,
	"CONSECUTIVE",	307,
	"ALLOW",	308,
	"TIME",	309,
	"DATE",	310,
	"LONG",	311,
	"LAST",	312,
	"MINS",	313,
	"MIN",	314,
	"LASTS",	315,
	"PRECISELY",	316,
	"NO",	317,
	"LESS",	318,
	"THAN",	319,
	"FEWER",	320,
	"A",	321,
	"MINIMUM",	322,
	"MORE",	323,
	"MAXIMUM",	324,
	"SAME",	325,
	"AS",	326,
	"TO",	327,
	"BE",	328,
	"THE",	329,
	"CONCURRENTLY",	330,
	"SIMULTANEOUSLY",	331,
	"MUST",	332,
	"TAKE",	333,
	"PLACE",	334,
	"OCCUR",	335,
	"HAPPEN",	336,
	"SITS",	337,
	"EXAM",	338,
	"EXAMS",	339,
	"LECTURE",	340,
	"LECTURES",	341,
	"TIMETABLE",	342,
	"COLON",	343,
	"SLASH",	344,
	"ONTO",	345,
	"MINUTE",	346,
	"ADDITIONAL",	347,
	"SITTING",	348,
	"CONSEC",	349,
	"SCHEDULE",	350,
	"STA",	351,
	"SDA",	352,
	"CAN",	353,
	"DESIRABILITY",	354,
	"DES",	355,
	"TEACHER",	356,
	"TEACHERS",	357,
	"LECTURER",	358,
	"LECTURERS",	359,
	"TUTOR",	360,
	"TUTORS",	361,
	"AVOID",	362,
	"PROHIBIT",	363,
	"PENALTY",	364,
	"CLASH",	365,
	"EVENT_SPREAD",	366,
	"CONSTRAINT",	367,
	"CONSTRAINTS",	368,
	"SPECIFICATIONS",	369,
	"EXCLUSIONS",	370,
	"ORDERING",	371,
	"TOO",	372,
	"MANY",	373,
	"BEING",	374,
	"CLOSE",	375,
	"DOUBLE",	376,
	"POPULATION",	377,
	"SIZE",	378,
	"SPREAD",	379,
	"INTERMODULE",	380,
	"REINITIS",	381,
	"INTERVAL",	382,
	"GENERATIONS",	383,
	"PER",	384,
	"STAGE",	385,
	"MIGRATION",	386,
	"RANDOM",	387,
	"SEED",	388,
	"OFFSPRING",	389,
	"BREEDING",	390,
	"USE",	391,
	"EVENT_FREEING",	392,
	"MUTATION",	393,
	"RATE",	394,
	"VIOLATION_DIRECTED",	395,
	"CROSSOVERIS",	396,
	"NUMRANGE",	397,
	"EFM_RATE",	398,
	"ADAPTIVEEFM",	399,
	"MUTATIONRATEIS",	400,
	"RESTARTSIS",	401,
	"SELECTIONIS",	402,
	"REPRODUCTIONIS",	403,
	"REINITRATEIS",	404,
	"SHARE",	405,
	"STOCHASTIC_REPRODUCTION",	406,
	"ONE_POINT",	407,
	"TWO_POINT",	408,
	"OUTPUT",	409,
	"FILE_W",	410,
	"DEMES",	411,
	"ONLY",	412,
	"GENE",	413,
	"FOR",	414,
	"APART",	415,
	"INVIGILATOR",	416,
	"INVIGILATES",	417,
	"DEFAULT",	418,
	"DEFAULTS",	419,
	"HOURS",	420,
	"HOUR",	421,
	"PREFERENCE",	422,
	"INVIGILATE",	423,
	"AVOIDS",	424,
	"EXCLUDES",	425,
	"SPECIFIES",	426,
	"SPECIFY",	427,
	"TUTORIAL",	428,
	"TUTORIALS",	429,
	"EVENT",	430,
	"EVENTS",	431,
	"ASSIGN",	432,
	"HOLDS",	433,
	"UNAVAILABLE",	434,
	"REQUIRE",	435,
	"REQUIRES",	436,
	"DEBUG",	437,
	"TOOMANYPERDAY",	438,
	"JUXTAPOSITION",	439,
	"TOOCLOSEPEN",	440,
	"MODEXCSLOTPEN",	441,
	"AGENTPREFPEN",	442,
	"MODAVSLOTPEN",	443,
	"EVENTCAPPEN",	444,
	"STUDCAPPEN",	445,
	"MODEXCROOMPEN",	446,
	"MODAVROOMPEN",	447,
	"AGENTEXCSLOTPEN",	448,
	"AGENTAVSLOTPEN",	449,
	"AGENTOVERHPEN",	450,
	"AGENTUNDERHPEN",	451,
	"AGENTOVEREPEN",	452,
	"AGENTUNDEREPEN",	453,
	"AGENTEXCMODPEN",	454,
	"AGENTAVMODPEN",	455,
	"CLASHPEN",	456,
	"NUMPOPSIS",	457,
	"POPSIZEIS",	458,
	"GENSSTAGEIS",	459,
	"REPINITIS",	460,
	"MIGINITIS",	461,
	"USE_VDM",	462,
	"USE_EFM",	463,
	"CROSSRATEIS",	464,
	"MUTATERATEIS",	465,
	"HEURISTIC_EVAL",	466,
	"EXP_OUTPUT",	467,
	"SEATS",	468,
	"CAPACITY",	469,
	"SSLOADPEN",	470,
	"SELOADPEN",	471,
	"SETDM",	472,
	"PERMRATEIS",	473,
	"NON_INTERACTIVE",	474,
	"SEEDIS",	475,
	"INITIAL_TEMPERATURE",	476,
	"FINAL_TEMPERATURE",	477,
	"COOLING_RATE",	478,
	"ITERATIONS",	479,
	"NCLASHPEN",	480,
	"NTOOCLOSEPEN",	481,
	"SIMULATED_ANNEALING",	482,
	"CROWDING_FACTOR",	483,
	"WORD",	484,
	"AGENTCLASHPEN",	485,
	"AGENTTOOMANYPEN",	486,
	"TEACH",	487,
	"TEACHES",	488,
	"INVIGILATORS",	489,
	"MINCOURSES",	490,
	"CONSECPEN",	491,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"valid_input : declaration",
	"valid_input : description",
	"valid_input : slotdefault",
	"valid_input : alldefault",
	"valid_input : modlength",
	"valid_input : modextrastud",
	"valid_input : modsize",
	"valid_input : studenttakes",
	"valid_input : modexcslotspec",
	"valid_input : intermodcon",
	"valid_input : roommatter",
	"valid_input : roomcap",
	"valid_input : eventspread",
	"valid_input : modroomcon",
	"valid_input : teachcon",
	"valid_input : lecturecon",
	"valid_input : gaparameter",
	"valid_input : blankline",
	"valid_input : debug",
	"valid_input : setpenalty",
	"valid_input : slotseatexception",
	"valid_input : sloteventexception",
	"debug : DEBUG",
	"blankline : /* empty */",
	"setpenalty : TOOMANYPERDAY COLON NUMBER",
	"setpenalty : CLASHPEN COLON NUMBER",
	"setpenalty : NCLASHPEN COLON NUMBER",
	"setpenalty : JUXTAPOSITION COLON NUMBER",
	"setpenalty : TOOCLOSEPEN COLON NUMBER",
	"setpenalty : NTOOCLOSEPEN COLON NUMBER",
	"setpenalty : MODEXCSLOTPEN COLON NUMBER",
	"setpenalty : MODAVSLOTPEN COLON NUMBER",
	"setpenalty : SELOADPEN COLON NUMBER",
	"setpenalty : SSLOADPEN COLON NUMBER",
	"setpenalty : EVENTCAPPEN COLON NUMBER",
	"setpenalty : STUDCAPPEN COLON NUMBER",
	"setpenalty : MODEXCROOMPEN COLON NUMBER",
	"setpenalty : MODAVROOMPEN COLON NUMBER",
	"setpenalty : AGENTEXCSLOTPEN COLON NUMBER",
	"setpenalty : AGENTAVSLOTPEN COLON NUMBER",
	"setpenalty : AGENTOVERHPEN COLON NUMBER",
	"setpenalty : AGENTUNDERHPEN COLON NUMBER",
	"setpenalty : AGENTOVEREPEN COLON NUMBER",
	"setpenalty : AGENTUNDEREPEN COLON NUMBER",
	"setpenalty : AGENTEXCMODPEN COLON NUMBER",
	"setpenalty : AGENTAVMODPEN COLON NUMBER",
	"setpenalty : AGENTPREFPEN COLON NUMBER",
	"setpenalty : AGENTTOOMANYPEN COLON NUMBER",
	"setpenalty : AGENTCLASHPEN COLON NUMBER",
	"setpenalty : MINCOURSES COLON NUMBER",
	"setpenalty : CONSECPEN COLON NUMBER",
	"declaration : declarer NUMBER slotsyn",
	"declaration : declarer NUMBER daysyn",
	"declaration : declarer NUMBER studsyn",
	"declaration : declarer NUMBER roomsyn",
	"declaration : declarer NUMBER modsyn",
	"declaration : declarer NUMBER teachsyn",
	"description : slotdescription",
	"description : roomdescription",
	"description : moddescription",
	"description : daydescription",
	"description : datedescription",
	"description : agentdescription",
	"slotdescription : slotsyn NUMBER IS ON DAY NUMBER AT time",
	"slotdescription : slotsyn NUMBER IS ON DAY NUMBER AT TIME time",
	"daydescription : NUMBER daysyn is_are BETWEEN daysyn NUMBER AND NUMBER",
	"daydescription : NUMBER daysyn is_are BETWEEN daysyn NUMBER AND daysyn NUMBER",
	"datedescription : daysyn NUMBER IS ON date",
	"datedescription : daysyn NUMBER IS ON DATE date",
	"slotdefault : slotsyn DEFAULT COLON NUMBER SEATS",
	"slotdefault : slotsyn DEFAULT COLON NUMBER modsyn",
	"slotseatexception : slotsyn numlist havesyn CAPACITY NUMBER SEATS",
	"sloteventexception : slotsyn numlist havesyn CAPACITY NUMBER modsyn",
	"roomdescription : roomsyn ARE COLON namelist",
	"moddescription : modsyn ARE COLON namelist",
	"agentdescription : teachsyn ARE COLON namelist",
	"modlength : modsyn namelist lastsyn NUMBER minsyn",
	"modextrastud : modsyn NAME HAS NUMBER extrasyn studsyn",
	"modsize : EXPECTED SIZE modsyn namelist NUMBER",
	"studenttakes : studsyn NAME sitsyn namelist",
	"studenttakes : NAME sitsyn namelist",
	"modexcslotspec : ALL modsyn excludesyn slotsyn numlist",
	"modexcslotspec : modsyn namelist excludesyn slotsyn numlist",
	"modexcslotspec : modsyn namelist avoidsyn slotsyn numlist WEIGHT NUMBER",
	"modexcslotspec : modsyn namelist specsyn slotsyn NUMBER",
	"intermodcon : modsyn namelist EXACTLY NUMBER minsyn BEFORE modsyn namelist WEIGHT NUMBER",
	"intermodcon : modsyn namelist EXACTLY NUMBER daysyn BEFORE modsyn namelist WEIGHT NUMBER",
	"intermodcon : modsyn namelist AT LEAST NUMBER minsyn BEFORE modsyn namelist WEIGHT NUMBER",
	"intermodcon : modsyn namelist AT LEAST NUMBER daysyn BEFORE modsyn namelist WEIGHT NUMBER",
	"intermodcon : modsyn namelist AT MOST NUMBER minsyn BEFORE modsyn namelist WEIGHT NUMBER",
	"intermodcon : modsyn namelist AT MOST NUMBER daysyn BEFORE modsyn namelist WEIGHT NUMBER",
	"intermodcon : schedsyn simulsyn modsyn namelist WEIGHT NUMBER",
	"intermodcon : schedsyn ON THE SAME DAY modsyn namelist WEIGHT NUMBER",
	"intermodcon : EXACTLY NUMBER minsyn BETWEEN modsyn namelist AND modsyn namelist WEIGHT NUMBER",
	"intermodcon : EXACTLY NUMBER daysyn BETWEEN modsyn namelist AND modsyn namelist WEIGHT NUMBER",
	"intermodcon : AT LEAST NUMBER minsyn BETWEEN modsyn namelist AND modsyn namelist WEIGHT NUMBER",
	"intermodcon : AT LEAST NUMBER daysyn BETWEEN modsyn namelist AND modsyn namelist WEIGHT NUMBER",
	"intermodcon : AT MOST NUMBER minsyn BETWEEN modsyn namelist AND modsyn namelist WEIGHT NUMBER",
	"intermodcon : AT MOST NUMBER daysyn BETWEEN modsyn namelist AND modsyn namelist WEIGHT NUMBER",
	"eventspread : minimiseconsec",
	"eventspread : allowbetween",
	"minimiseconsec : MINIMISE numberof studsyn sittingsyn consecsyn modsyn",
	"minimiseconsec : ALLOW studsyn AT MOST NUMBER CONSECUTIVE modsyn",
	"lecturecon : schedsyn APART COLON namelist",
	"havesyn : HAVE",
	"havesyn : HAS",
	"avoidsyn : AVOID",
	"avoidsyn : PROHIBIT",
	"avoidsyn : AVOIDS",
	"numberof : NUMBER_W OF",
	"numberof : NUMBER_W",
	"modroomcon : modsyn namelist specsyn roomsyn NAME",
	"modroomcon : modnamesexcroom namelist",
	"modroomcon : modnameallroom namelist",
	"modnamesexcroom : modsyn namelist excludesyn roomsyn",
	"modnameallroom : modsyn namelist requiresyn roomsyn",
	"sittingsyn : SITTING",
	"sittingsyn : TAKING",
	"sittingsyn : WITH",
	"consecsyn : CONSECUTIVE",
	"consecsyn : CONSEC",
	"allowbetween : ALLOW studsyn atleastsyn NUMBER minsyn BETWEEN modsyn",
	"allowbetween : ALLOW studsyn atleastsyn NUMBER daysyn BETWEEN modsyn",
	"allowbetween : ALLOW teachsyn AT MOST NUMBER modsyn PER DAY",
	"allowbetween : ALLOW studsyn AT MOST NUMBER modsyn PER DAY",
	"atleastsyn : AT LEAST",
	"atleastsyn : NO LESS THAN",
	"atleastsyn : NO FEWER THAN",
	"schedsyn : SCHEDULE",
	"schedsyn : TIMETABLE",
	"teachcon : NAME teachsyn modsyn namelist",
	"teachcon : NAME CAN teachsyn modsyn namelist",
	"teachcon : NAME CAN teachsyn modsyn namelist withdessyn NUMBER",
	"teachcon : NAME teachsyn MAXIMUM NUMBER modsyn",
	"teachcon : NAME teachsyn MAXIMUM NUMBER HOURS",
	"teachcon : NAME teachsyn MINIMUM NUMBER modsyn",
	"teachcon : NAME teachsyn MINIMUM NUMBER HOURS",
	"teachcon : teachsyn DEFAULT COLON MAXIMUM NUMBER modsyn",
	"teachcon : teachsyn DEFAULT COLON MAXIMUM NUMBER HOURS",
	"teachcon : teachsyn DEFAULT COLON MINIMUM NUMBER modsyn",
	"teachcon : teachsyn DEFAULT COLON MINIMUM NUMBER HOURS",
	"teachcon : modsyn DEFAULT COLON NUMBER PER modsyn",
	"teachcon : modsyn DEFAULT COLON EXPECTED SIZE NUMBER",
	"teachcon : NUMBER studsyn SHARE modsyn NAME AND NAME",
	"teachcon : modsyn namelist requiresyn NUMBER teachsyn",
	"teachcon : teachsyn NAME EXCLUDES slotsyn numlist",
	"teachcon : teachsyn NAME avoidsyn slotsyn numlist withdessyn NUMBER",
	"roommatter : ASSIGN EVENTS TO roomsyn",
	"roommatter : ASSIGN teachsyn TO modsyn",
	"roomcap : roomhascap",
	"roomcap : roomhascapinslot",
	"lastsyn : LAST",
	"lastsyn : LASTS",
	"roomhascap : roomsyn NAME HOLDS MAXIMUM NUMBER studsyn",
	"roomhascap : roomsyn NAME HOLDS MAXIMUM NUMBER modsyn",
	"roomhascapinslot : roomsyn NAME HOLDS NUMBER studsyn IN_ slotsyn numlist",
	"roomhascapinslot : roomsyn NAME HOLDS NUMBER modsyn IN_ slotsyn numlist",
	"roomhascapinslot : roomsyn NAME UNAVAILABLE IN_ slotsyn numlist",
	"simulsyn : SIMULTANEOUSLY",
	"simulsyn : CONCURRENTLY",
	"simulsyn : IN_ THE SAME slotsyn",
	"excludesyn : EXCLUDE",
	"excludesyn : EXCLUDES",
	"withdessyn : WITH DESIRABILITY",
	"withdessyn : WITH DES",
	"withdessyn : PREFERENCE",
	"sitsyn : TAKES",
	"sitsyn : SITS",
	"namelist : NAME",
	"namelist : namelist NAME",
	"numlist : NUMBER",
	"numlist : NUMRANGE",
	"numlist : numlist NUMBER",
	"numlist : numlist NUMRANGE",
	"requiresyn : REQUIRE",
	"requiresyn : REQUIRES",
	"alldefault : modsyn DEFAULT COLON NUMBER minsyn",
	"alldefault : roomsyn DEFAULT COLON MAXIMUM NUMBER modsyn",
	"alldefault : roomsyn DEFAULT COLON MAXIMUM NUMBER studsyn",
	"declarer : THERE IS",
	"declarer : THERE ARE",
	"slotsyn : SLOT",
	"slotsyn : SLOTS",
	"daysyn : DAY",
	"daysyn : DAYS",
	"studsyn : STUDENT",
	"studsyn : STUDENTS",
	"roomsyn : ROOM",
	"roomsyn : ROOMS",
	"specsyn : SPECIFIES",
	"specsyn : SPECIFY",
	"modsyn : MODULE",
	"modsyn : MODULES",
	"modsyn : EXAM",
	"modsyn : EXAMS",
	"modsyn : LECTURE",
	"modsyn : LECTURES",
	"modsyn : TUTORIAL",
	"modsyn : TUTORIALS",
	"modsyn : EVENT",
	"modsyn : EVENTS",
	"teachsyn : TEACHER",
	"teachsyn : TEACHERS",
	"teachsyn : LECTURER",
	"teachsyn : LECTURERS",
	"teachsyn : TUTOR",
	"teachsyn : TUTORS",
	"teachsyn : INVIGILATOR",
	"teachsyn : INVIGILATORS",
	"teachsyn : INVIGILATES",
	"teachsyn : INVIGILATE",
	"teachsyn : TEACHES",
	"teachsyn : TEACH",
	"time : NUMBER COLON NUMBER",
	"date : NUMBER SLASH NUMBER SLASH NUMBER",
	"is_are : IS",
	"is_are : ARE",
	"minsyn : MINUTES",
	"minsyn : MINUTE",
	"minsyn : MINS",
	"minsyn : MIN",
	"extrasyn : EXTRA",
	"extrasyn : MORE",
	"extrasyn : ADDITIONAL",
	"gaparameter : NUMPOPSIS COLON NUMBER",
	"gaparameter : POPSIZEIS COLON NUMBER",
	"gaparameter : GENSSTAGEIS COLON NUMBER",
	"gaparameter : REPINITIS COLON NUMBER",
	"gaparameter : MIGINITIS COLON NUMBER",
	"gaparameter : USE_VDM",
	"gaparameter : USE_EFM",
	"gaparameter : EFM_RATE COLON DOUBLE",
	"gaparameter : ADAPTIVEEFM",
	"gaparameter : CROSSRATEIS COLON DOUBLE",
	"gaparameter : SELECTIONIS COLON NAME",
	"gaparameter : SELECTIONIS COLON NAME NUMBER",
	"gaparameter : SELECTIONIS COLON NAME NUMBER NAME DOUBLE",
	"gaparameter : REPRODUCTIONIS COLON NAME",
	"gaparameter : REINITIS COLON NAME",
	"gaparameter : STOCHASTIC_REPRODUCTION",
	"gaparameter : REINITRATEIS COLON DOUBLE",
	"gaparameter : CROSSOVERIS COLON NAME",
	"gaparameter : MUTATERATEIS COLON DOUBLE",
	"gaparameter : MUTATIONRATEIS COLON DOUBLE",
	"gaparameter : PERMRATEIS COLON DOUBLE",
	"gaparameter : SETDM COLON DOUBLE",
	"gaparameter : HEURISTIC_EVAL",
	"gaparameter : NON_INTERACTIVE",
	"gaparameter : CROWDING_FACTOR COLON NUMBER",
	"gaparameter : EXP_OUTPUT COLON NAME",
	"gaparameter : SEEDIS COLON NUMBER",
	"gaparameter : SIMULATED_ANNEALING",
	"gaparameter : RESTARTSIS COLON NUMBER",
	"gaparameter : INITIAL_TEMPERATURE COLON DOUBLE",
	"gaparameter : ITERATIONS COLON NUMBER",
	"gaparameter : FINAL_TEMPERATURE COLON DOUBLE",
	"gaparameter : COOLING_RATE COLON DOUBLE",
};
#endif /* YYDEBUG */
# line	1 "/usr/ccs/bin/yaccpar"
/*
 * Copyright (c) 1993 by Sun Microsystems, Inc.
 */

#pragma ident	"@(#)yaccpar	6.12	93/06/07 SMI"

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#define YYNEW(type)	malloc(sizeof(type) * yynewmax)
#define YYCOPY(to, from, type) \
	(type *) memcpy(to, (char *) from, yynewmax * sizeof(type))
#define YYENLARGE( from, type) \
	(type *) realloc((char *) from, yynewmax * sizeof(type))
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-10000000)

/*
** global variables used by the parser
*/
YYSTYPE *yypv;			/* top of value stack */
int *yyps;			/* top of state stack */

int yystate;			/* current state */
int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



#ifdef YYNMBCHARS
#define YYLEX()		yycvtok(yylex())
/*
** yycvtok - return a token if i is a wchar_t value that exceeds 255.
**	If i<255, i itself is the token.  If i>255 but the neither 
**	of the 30th or 31st bit is on, i is already a token.
*/
#if defined(__STDC__) || defined(__cplusplus)
int yycvtok(int i)
#else
int yycvtok(i) int i;
#endif
{
	int first = 0;
	int last = YYNMBCHARS - 1;
	int mid;
	wchar_t j;

	if(i&0x60000000){/*Must convert to a token. */
		if( yymbchars[last].character < i ){
			return i;/*Giving up*/
		}
		while ((last>=first)&&(first>=0)) {/*Binary search loop*/
			mid = (first+last)/2;
			j = yymbchars[mid].character;
			if( j==i ){/*Found*/ 
				return yymbchars[mid].tvalue;
			}else if( j<i ){
				first = mid + 1;
			}else{
				last = mid -1;
			}
		}
		/*No entry in the table.*/
		return i;/* Giving up.*/
	}else{/* i is already a token. */
		return i;
	}
}
#else/*!YYNMBCHARS*/
#define YYLEX()		yylex()
#endif/*!YYNMBCHARS*/

/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
#if defined(__STDC__) || defined(__cplusplus)
int yyparse(void)
#else
int yyparse()
#endif
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */

#if defined(__cplusplus) || defined(lint)
/*
	hacks to please C++ and lint - goto's inside switch should never be
	executed; yypvt is set to 0 to avoid "used before set" warning.
*/
	static int __yaccpar_lint_hack__ = 0;
	switch (__yaccpar_lint_hack__)
	{
		case 1: goto yyerrlab;
		case 2: goto yynewstate;
	}
	yypvt = 0;
#endif

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

#if YYMAXDEPTH <= 0
	if (yymaxdepth <= 0)
	{
		if ((yymaxdepth = YYEXPAND(0)) <= 0)
		{
			yyerror("yacc initialization error");
			YYABORT;
		}
	}
#endif

	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */
	goto yystack;	/* moved from 6 lines above to here to please C++ */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			int yynewmax;
#ifdef YYEXPAND
			yynewmax = YYEXPAND(yymaxdepth);
#else
			yynewmax = 2 * yymaxdepth;	/* double table size */
			if (yymaxdepth == YYMAXDEPTH)	/* first time growth */
			{
				char *newyys = (char *)YYNEW(int);
				char *newyyv = (char *)YYNEW(YYSTYPE);
				if (newyys != 0 && newyyv != 0)
				{
					yys = YYCOPY(newyys, yys, int);
					yyv = YYCOPY(newyyv, yyv, YYSTYPE);
				}
				else
					yynewmax = 0;	/* failed */
			}
			else				/* not first time */
			{
				yys = YYENLARGE(yys, int);
				yyv = YYENLARGE(yyv, YYSTYPE);
				if (yys == 0 || yyv == 0)
					yynewmax = 0;	/* failed */
			}
#endif
			if (yynewmax <= yymaxdepth)	/* tables not expanded */
			{
				yyerror( "yacc stack overflow" );
				YYABORT;
			}
			yymaxdepth = yynewmax;

			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
			skip_init:
				yynerrs++;
				/* FALLTHRU */
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 23:
# line 420 "main.y"
{ debug = TRUE; } break;
case 24:
# line 422 "main.y"
{ ; } break;
case 25:
# line 426 "main.y"
{ npdpen = inputnumlist[0]; numnums=0;} break;
case 26:
# line 427 "main.y"
{clashpen = inputnumlist[0]; numnums=0;} break;
case 27:
# line 428 "main.y"
{nclashpen = inputnumlist[0]; numnums=0;} break;
case 28:
# line 429 "main.y"
{juxtpen = inputnumlist[0]; numnums=0;} break;
case 29:
# line 430 "main.y"
{ tooclosepen = inputnumlist[0]; numnums=0;} break;
case 30:
# line 431 "main.y"
{ ntooclosepen = inputnumlist[0]; numnums=0;} break;
case 31:
# line 432 "main.y"
{modexcslotpen = inputnumlist[0]; numnums=0;} break;
case 32:
# line 433 "main.y"
{modavslotpen = inputnumlist[0]; numnums=0;} break;
case 33:
# line 434 "main.y"
{seloadpen = inputnumlist[0]; numnums=0;} break;
case 34:
# line 435 "main.y"
{ssloadpen = inputnumlist[0]; numnums=0;} break;
case 35:
# line 436 "main.y"
{eventcappen = inputnumlist[0]; numnums=0;} break;
case 36:
# line 437 "main.y"
{ studcappen = inputnumlist[0]; numnums=0;} break;
case 37:
# line 438 "main.y"
{modexcroompen = inputnumlist[0]; numnums=0;} break;
case 38:
# line 439 "main.y"
{modavroompen = inputnumlist[0]; numnums=0;} break;
case 39:
# line 440 "main.y"
{agentexcslotpen=inputnumlist[0];numnums=0;} break;
case 40:
# line 441 "main.y"
{agentavslotpen=inputnumlist[0];numnums=0;} break;
case 41:
# line 442 "main.y"
{ agentoverhpen =inputnumlist[0];numnums=0;} break;
case 42:
# line 443 "main.y"
{agentunderhpen =inputnumlist[0];numnums=0;} break;
case 43:
# line 444 "main.y"
{agentoverepen = inputnumlist[0];numnums=0;} break;
case 44:
# line 445 "main.y"
{agentunderepen =inputnumlist[0];numnums=0;} break;
case 45:
# line 446 "main.y"
{agentexcmodpen =inputnumlist[0];numnums=0;} break;
case 46:
# line 447 "main.y"
{agentavmodpen = inputnumlist[0];numnums=0;} break;
case 47:
# line 448 "main.y"
{ agentprefpen = inputnumlist[0];numnums=0;} break;
case 48:
# line 449 "main.y"
{ agenttoomanypen = inputnumlist[0];numnums = 0;} break;
case 49:
# line 450 "main.y"
{agentclashpen =  inputnumlist[0];numnums=0;} break;
case 50:
# line 451 "main.y"
{clashperexam_pen = inputnumlist[0];numnums=0;} break;
case 51:
# line 452 "main.y"
{consecpen = inputnumlist[0];numnums=0;} break;
case 52:
# line 456 "main.y"
{ act_declareslots(); } break;
case 53:
# line 458 "main.y"
{ act_declaredays(); } break;
case 54:
# line 460 "main.y"
{ act_declarestudents();} break;
case 55:
# line 462 "main.y"
{ act_declarerooms(); } break;
case 56:
# line 464 "main.y"
{ act_declaremods(); } break;
case 57:
# line 466 "main.y"
{ act_declareagents(); } break;
case 58:
# line 469 "main.y"
{ act_slotdescription(); } break;
case 59:
# line 471 "main.y"
{ act_roomdescription(); } break;
case 60:
# line 473 "main.y"
{ act_moddescription(); } break;
case 61:
# line 475 "main.y"
{ act_daydescription(); } break;
case 62:
# line 477 "main.y"
{ act_datedescription(); } break;
case 63:
# line 479 "main.y"
{ act_agentdescription(); } break;
case 70:
# line 498 "main.y"
{ slotseatconstraints = 1;
                    slotseatmax = inputnumlist[0];
                    resetinputlists();} break;
case 71:
# line 503 "main.y"
{ sloteventconstraints = 1;
                    sloteventmax = inputnumlist[0];
                    resetinputlists();} break;
case 72:
# line 510 "main.y"
{
		    slotseatconstraints = 1;
                    act_slotseatexception(); resetinputlists();
                  } break;
case 73:
# line 517 "main.y"
{
		    sloteventconstraints = 1;
                   act_sloteventexception(); resetinputlists();
                  } break;
case 77:
# line 533 "main.y"
{ act_modlength(); } break;
case 78:
# line 537 "main.y"
{ act_modextrastud(); } break;
case 79:
# line 540 "main.y"
{ act_expmodsize(); } break;
case 80:
# line 544 "main.y"
{ act_studenttakes(0); } break;
case 81:
# line 546 "main.y"
{ act_studenttakes(0); } break;
case 82:
# line 550 "main.y"
{ act_allmodexcslot();
                    resetinputlists();
                  } break;
case 83:
# line 554 "main.y"
{ act_modexcslot(1);
                    resetinputlists(); } break;
case 84:
# line 559 "main.y"
{ act_modexcslot(0); 
                    resetinputlists(); } break;
case 85:
# line 563 "main.y"
{ act_modsspecslot(); } break;
case 86:
# line 566 "main.y"
{ act_modprecmod(BEFORE,EXACTLY,MINUTES); } break;
case 87:
# line 569 "main.y"
{ act_modprecmod(BEFORE,EXACTLY,DAYS,1); } break;
case 88:
# line 572 "main.y"
{ act_modprecmod(BEFORE,LEAST,MINUTES,1); } break;
case 89:
# line 575 "main.y"
{ act_modprecmod(BEFORE,LEAST,DAYS,1); } break;
case 90:
# line 578 "main.y"
{ act_modprecmod(BEFORE,MOST,MINUTES,1); } break;
case 91:
# line 581 "main.y"
{ act_modprecmod(BEFORE,MOST,DAYS,1); } break;
case 92:
# line 584 "main.y"
{ act_modprecmod(SAME,0,0,1); } break;
case 93:
# line 587 "main.y"
{ act_modprecmod(DAY,0,0,1); } break;
case 94:
# line 590 "main.y"
{ act_modprecmod(BETWEEN,EXACTLY,MINUTES,1); } break;
case 95:
# line 593 "main.y"
{ act_modprecmod(BETWEEN,EXACTLY,DAYS,1); } break;
case 96:
# line 596 "main.y"
{ act_modprecmod(BETWEEN,LEAST,MINUTES,1); } break;
case 97:
# line 599 "main.y"
{ act_modprecmod(BETWEEN,LEAST,DAYS,1); } break;
case 98:
# line 602 "main.y"
{ act_modprecmod(BETWEEN,MOST,MINUTES,1); } break;
case 99:
# line 605 "main.y"
{ act_modprecmod(BETWEEN,MOST,DAYS,1); } break;
case 102:
# line 613 "main.y"
{ act_minimisestudconmods(); } break;
case 103:
# line 617 "main.y"
{maxconsecutive = inputnumlist[0]; numnums=0;} break;
case 104:
# line 620 "main.y"
{ act_studenttakes(1); } break;
case 112:
# line 637 "main.y"
{ act_modspecroom(); } break;
case 113:
# line 640 "main.y"
{ act_modexcroom(); } break;
case 114:
# line 643 "main.y"
{ act_modallroom(); } break;
case 115:
# line 646 "main.y"
{ addtonamelist("___"); } break;
case 116:
# line 649 "main.y"
{ addtonamelist("___"); } break;
case 122:
# line 664 "main.y"
{ alminsbetweenmods = inputnumlist[0];
                    resetinputlists();} break;
case 123:
# line 668 "main.y"
{ aldaysbetweenmods = inputnumlist[0];
                    resetinputlists();} break;
case 124:
# line 673 "main.y"
{ agentmodsperday = inputnumlist[0];
                    resetinputlists();} break;
case 125:
# line 677 "main.y"
{ studmodsperday = inputnumlist[0]; 
                    resetinputlists();} break;
case 131:
# line 690 "main.y"
{ act_teachmustdomods();} break;
case 132:
# line 693 "main.y"
{ act_teachcanmods(); } break;
case 133:
# line 696 "main.y"
{ act_teachprefdomods(); } break;
case 134:
# line 699 "main.y"
{ act_teachgivesmaxmods(); } break;
case 135:
# line 702 "main.y"
{ act_teachgivesmaxhours(); } break;
case 136:
# line 705 "main.y"
{ act_teachgivesminmods(); } break;
case 137:
# line 708 "main.y"
{ act_teachgivesminhours(); } break;
case 138:
# line 711 "main.y"
{ default_agentmaxmods = inputnumlist[0];
             resetinputlists(); } break;
case 139:
# line 715 "main.y"
{ default_agentmaxhours = inputnumlist[0];
             resetinputlists(); } break;
case 140:
# line 719 "main.y"
{ default_agentminmods = inputnumlist[0];
             resetinputlists(); } break;
case 141:
# line 723 "main.y"
{ default_agentminhours = inputnumlist[0];
             resetinputlists(); } break;
case 142:
# line 727 "main.y"
{ default_agentspermod = inputnumlist[0];
            resetinputlists(); } break;
case 143:
# line 731 "main.y"
{ default_expectedmodsize = inputnumlist[0];
            resetinputlists(); } break;
case 144:
# line 736 "main.y"
{ act_nstudssharemods();
            resetinputlists();} break;
case 145:
# line 741 "main.y"
{ act_modreqagents(); 
            resetinputlists(); } break;
case 146:
# line 745 "main.y"
{ act_agentexcslots();
             resetinputlists(); } break;
case 147:
# line 749 "main.y"
{ act_agentavslots();
             resetinputlists(); } break;
case 148:
# line 754 "main.y"
{ roomsmatter = TRUE; } break;
case 149:
# line 757 "main.y"
{ agentsmatter = TRUE; } break;
case 154:
# line 767 "main.y"
{ act_roomhascapstud(); } break;
case 155:
# line 770 "main.y"
{ act_roomhascapmod();  } break;
case 156:
# line 773 "main.y"
{ act_roomhascapstudinslot(); } break;
case 157:
# line 776 "main.y"
{ act_roomhascapmodinslot(); } break;
case 158:
# line 779 "main.y"
{ act_roomunavailableinslot(); } break;
case 177:
# line 821 "main.y"
{ default_modlength = inputnumlist[0];
                    resetinputlists(); } break;
case 178:
# line 826 "main.y"
{ default_roommodcap = inputnumlist[0];
                    resetinputlists(); } break;
case 179:
# line 831 "main.y"
{ default_roomstudcap = inputnumlist[0];
                    resetinputlists(); } break;
case 225:
# line 906 "main.y"
{ numpop = inputnumlist[0]; numnums=0;} break;
case 226:
# line 907 "main.y"
{ numchromo =inputnumlist[0]; numnums=0;} break;
case 227:
# line 908 "main.y"
{gens_stage=inputnumlist[0]; numnums=0;} break;
case 228:
# line 909 "main.y"
{repinterval=inputnumlist[0]; numnums=0;} break;
case 229:
# line 910 "main.y"
{migint = inputnumlist[0]; numnums=0;} break;
case 230:
# line 911 "main.y"
{ dsm=1;efm=0;} break;
case 231:
# line 912 "main.y"
{ dsm=1;efm=1;} break;
case 232:
# line 913 "main.y"
{ dsm_rate = inputdouble; } break;
case 233:
# line 914 "main.y"
{ adaptive_efm = 1; } break;
case 234:
# line 915 "main.y"
{cross_rate = inputdouble;} break;
case 235:
# line 916 "main.y"
{ act_set_select();resetinputlists();} break;
case 236:
# line 918 "main.y"
{ act_set_select();resetinputlists();} break;
case 237:
# line 920 "main.y"
{ insert_prob = inputdouble;
                                   act_set_select();resetinputlists();} break;
case 238:
# line 922 "main.y"
{ act_set_repro();resetinputlists();} break;
case 239:
# line 923 "main.y"
{ act_set_reinit(); resetinputlists();} break;
case 240:
# line 924 "main.y"
{ stochastic_reproduction = 1; } break;
case 241:
# line 925 "main.y"
{ reinit_rate = inputdouble;} break;
case 242:
# line 926 "main.y"
{ act_set_cross(); resetinputlists();} break;
case 243:
# line 927 "main.y"
{ mute_rate = inputdouble; } break;
case 244:
# line 928 "main.y"
{ mutation_rate = inputdouble; } break;
case 245:
# line 929 "main.y"
{perm_rate = inputdouble; } break;
case 246:
# line 930 "main.y"
{ act_set_directed_mutation(); } break;
case 247:
# line 931 "main.y"
{ evaluate = eval_tt; } break;
case 248:
# line 932 "main.y"
{ interactive=0;} break;
case 249:
# line 934 "main.y"
{crowding_factor = inputnumlist[0]; numnums=0;} break;
case 250:
# line 935 "main.y"
{ if(!strcmp(inputnamelist[0]->n,"none"))
                                      output=(FILE *)NULL;
                                      else { 
                                       if ((output = fopen(inputnamelist[0]->n,"a")) == NULL) {printf("Couldn't open output file");exit(0);}
                                resetinputlists();}} break;
case 251:
# line 940 "main.y"
{use_seed_given=1; seed_given = inputnumlist[0];
                      resetinputlists();} break;
case 252:
# line 942 "main.y"
{simulated_annealing=1; 
                               numchromo=1; 
                               sabestfit=-1000000.0;} break;
case 253:
# line 945 "main.y"
{restarts = inputnumlist[0]; numnums=0;restart=0;} break;
case 254:
# line 946 "main.y"
{initial_temperature=inputdouble;} break;
case 255:
# line 947 "main.y"
{iterations=inputnumlist[0];numnums=0;} break;
case 256:
# line 948 "main.y"
{final_temperature=inputdouble;} break;
case 257:
# line 949 "main.y"
{cooling_rate=inputdouble;} break;
# line	532 "/usr/ccs/bin/yaccpar"
	}
	goto yystack;		/* reset registers in driver code */
}

